package captcha.c01;

import drjava.util.Lizt;

public class NumberParser {
  static Lizt<String> digits = Lizt.of("zero one two three four five six seven eight nine".split(" "));
  static Lizt<String> tens = Lizt.of("twenty thirty forty fifty sixty seventy eighty ninety".split(" "));
  static Lizt<String> teens = Lizt.of("ten eleven twelve thirteen fourteen fifteen sixteen seventeen eighteen nineteen".split(" "));

  public static int parse(String s) {
    WordScanner scanner = new WordScanner(s);
    return parse(scanner);
  }

  public static int parse(WordScanner scanner) {
    int x = 0, total = 0;
    while (scanner.more()) {
      String w = scanner.next();
      int i = digits.indexOf(w);
      if (i >= 0) {
        x += i;
        continue;
      }

      i = tens.indexOf(w);
      if (i >= 0) {
        x += i*10+20;
        continue;
      }

      i = teens.indexOf(w);
      if (i >= 0) {
        x += i+10;
        continue;
      }

      if (w.equals("thousand")) {
        total += x*1000;
        x = 0;
        continue;
      }

      if (w.equals("hundred")) {
        total += x*100;
        x = 0;
        continue;
      }

      if (w.equals("and"))
        continue;

      unknownWord(w);
    }
    total += x;
    //System.out.println("number found: " + total);
    return total;
  }

  private static void unknownWord(String w) {
    //System.out.println("? " + w);
  }
}
