package captcha.c01;

import drjava.util.Errors;
import drjava.util.StringUtil;
import drjava.util.Tree;
import prophecy.m.m13.StringUnfreezer;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.List;

public class Riddle {
  public String question;
  public List<String> answerHashes = new ArrayList<String>();

  public Riddle(String question) {
    this.question = question.toLowerCase();
  }

  public boolean isAnswerCorrect(String answer) {
    String hash = hash(answer.toLowerCase());
    return answerHashes.contains(hash);
  }

  private String hash(String answer) {
    try {
      MessageDigest md5 = MessageDigest.getInstance("MD5");
      md5.reset();
      md5.update(answer.getBytes());
      byte[] result = md5.digest();
      return StringUtil.bytesToHex(result);
    } catch (Exception e) {
      throw Errors.asRuntimeException(e);
    }
  }

  public void print() {
    System.out.println(question);
    for (String hash : answerHashes) {
      System.out.println("  <" + hash + ">");
    }
  }

  public String getQuestionHash() {
    return hash(question);
  }
}
