package captcha.c01;

import java.io.File;

public class SolveCaptchas {
  int numTried, numSolved, numAttempts;

  public static void main(String[] args) {
    new SolveCaptchas();
  }

  SolveCaptchas() {
    File dir = new File("captchas");
    File[] files = dir.listFiles();
    for (File file : files) {
      if (file.getName().endsWith(".xml"))
        solveCaptcha(file);
    }

    System.out.println("");
    System.out.println("Solved: " + numSolved + " of " + numTried);
    if (numAttempts > numSolved)
      System.out.println("Extra attempts: " + numAttempts);

    if (numSolved != numTried) {
      // System.out.println("Uhm... keep working! :)");
    } else if (numAttempts == numTried) {
      System.out.println("");
      System.out.println("PERFECT!!!");
    } else {
      System.out.println("");
      System.out.println("Good start, but bring down those attempts!");
    }
  }

  private void solveCaptcha(File file) {
    ++numTried;
    Riddle riddle = TextcaptchaXmlParser.loadRiddle(file);
    RiddleToSolve riddleToSolve = new RiddleToSolve(riddle);
    RiddleSolver solver = new RS1();
    solver.setRiddle(riddleToSolve);
    solver.solveUntilDone();
    if (riddleToSolve.solved) {
      ++numSolved;
      numAttempts += riddleToSolve.attempts;
    } else {
      System.out.println("<unsolved> " + riddle.question);
      System.out.println("  " + file.getName());
    }
  }
}
