package captcha.c01;

import drjava.util.Errors;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.InputStream;

public class TextcaptchaXmlParser {
  public static Riddle loadRiddle(String xmlSrc) {
    try {
      DocumentBuilder documentBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
      Document document = documentBuilder.parse(new ByteArrayInputStream(xmlSrc.getBytes()));
      return riddleFromDocument(document);
    } catch (Exception e) {
      throw Errors.asRuntimeException(e);
    }
  }

  public static Riddle loadRiddle(File xmlFile) {
    try {
      DocumentBuilder documentBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
      Document document = documentBuilder.parse(xmlFile);
      return riddleFromDocument(document);
    } catch (Exception e) {
      throw Errors.asRuntimeException(e);
    }
  }

  private static Riddle riddleFromDocument(Document document) {
    Element root = document.getDocumentElement();
    String question = root.getElementsByTagName("question").item(0).getTextContent().trim();
    Riddle riddle = new Riddle(question);
    NodeList answers = root.getElementsByTagName("answer");
    for (int i = 0; i < answers.getLength(); i++)
      riddle.answerHashes.add(answers.item(i).getTextContent().trim());
    return riddle;
  }
}
