package captcha.c02;

import captcha.c01.Riddle;
import captcha.c01.RiddleToSolve;
import drjava.util.MultiMap;
import prophecy.common.Var;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Blackboard {
  public final IntVar numCaptchas = new IntVar(0);
  public final IntVar numCaptchasSolved = new IntVar(0);
  private CaptchasArchive archive;
  public List<RiddleToSolve> riddlesToSolve = new ArrayList<RiddleToSolve>();
  private Map<String, RiddleToSolve> lookup = new HashMap<String, RiddleToSolve>();

  public void load() {
    archive = new CaptchasArchive();
    archive.load();
    for (Riddle riddle : archive.riddles) {
      RiddleToSolve riddleToSolve = new RiddleToSolve(riddle);
      riddleToSolve.solvedTrigger.addListener(new Runnable() {
        public void run() {
          numCaptchasSolved.inc();
        }
      });
      riddlesToSolve.add(riddleToSolve);
      lookup.put(riddleToSolve.riddle.getQuestionHash(), riddleToSolve);
    }
    numCaptchas.set(riddlesToSolve.size());
  }

  /*public void trySolution(RiddleToSolve riddle, String solution) {
    if (!riddle.solved) {
      riddle.trySolution(solution);
      if (riddle.solved)
        numCaptchasSolved.inc();
    }
  }*/

  public RiddleToSolve get(String questionHash) {
    return lookup.get(questionHash);
  }
}
