package captcha.c03;

import captcha.c01.RiddleToSolve;
import captcha.c02.Blackboard;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ExtractList {
  public static void main(String[] args) {
    Blackboard blackboard = new Blackboard();
    blackboard.load();
    int listsFound = 0;
    for (RiddleToSolve riddle : blackboard.riddlesToSolve) {
      String list = extractList(riddle.question);
      if (list == null)
        System.out.println("??? " + riddle.question);
      else {
        System.out.println(list + " <-- " + riddle.question);
        ++listsFound;
      }
    }
    System.out.println("Lists found: " + listsFound + " in "
      + blackboard.riddlesToSolve.size() + " riddles");
  }

  public static String extractList(String q) {
    String list;

    list = match("the series (.+ (and|or) [^,\\?]+)", q);
    if (list != null) return list;

    list = match("the list (.+ (and|or) [^,\\?]+)", q);
    if (list != null) return list;

    list = match("which of (.+ (and|or) .*?) is ", q);
    if (list != null) return list;

    list = match("^of the numbers (.+ (and|or) [^,\\?]+)", q);
    if (list != null) return list;

    list = match("number of (.+ (and|or) [^,\\?:]+)", q);
    if (list != null) return list;

    list = match("^(.+ (and|or) [^:]+):", q);
    if (list != null) {
      if (!list.startsWith("enter "))
        return list;
    }

    list = match(" from (.+) is[ \\?]", q);
    if (list != null) return list;

    return null;
  }

  private static String match(String regex, String q) {
    Matcher matcher = Pattern.compile(regex).matcher(q);
    if (matcher.find())
      return matcher.group(1);
    return null;
  }
}
