package captcha.c04;

import captcha.c01.RiddleToSolve;
import drjava.util.MultiMap;
import drjava.util.Tree;

import java.util.*;

public class TagMap {
  // question hash -> tag
  private Map<String, String> tagMap = new HashMap<String, String>();

  // tag -> question hashes
  private MultiMap<String, String> reverseMap = new MultiMap<String, String>();

  public void fromTree(Tree tree) {
    for (Map.Entry<String, Tree> entry : tree.children().entrySet()) {
      put(entry.getKey(), entry.getValue().name());
    }
  }

  private void put(String questionHash, String tag) {
    tagMap.put(questionHash, tag);
    reverseMap.put(tag, questionHash);
  }

  public List<String> tags() {
    // use TreeSet for sorting
    return new ArrayList<String>(new TreeSet<String>(reverseMap.keySet()));
  }

  public String get(RiddleToSolve riddle) {
    return tagMap.get(riddle.riddle.getQuestionHash());
  }

  public List<String> riddlesForTag(String tag) {
    return reverseMap.get(tag);
  }
}
