/**
 * --------------------------------------------------------------------------
 * Copyright (c) 2002, Sebastian Delmont <sdelmont@zonageek.com> 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions  of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer. 
 * 
 * - Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * - Neither the name of Sebastian Delmont nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * ---------------------------------------------------------------------------
 */

package com.zonageek.jpeg.test;

import com.zonageek.jpeg.Jpeg;
import com.zonageek.jpeg.JpegBlock;
import junit.framework.TestCase;
import java.io.FileInputStream;
import java.util.Vector;

public class JpegTest extends TestCase {
	protected static final String TEST_FILE_1 = "./test/images/test.jpg";
	
	public JpegTest(String str) {
		super(str);
	}
	
	public void testBlockParsing() {
	    try {
    		Jpeg jpeg = new Jpeg();
      		Jpeg jpeg2 = new Jpeg();
      
	      	jpeg.read(new FileInputStream(TEST_FILE_1));
      
	      	Vector blocks = jpeg.getBlocks();
			JpegBlock block;
			
			block = (JpegBlock) blocks.elementAt(0);
			assertTrue(block.getMarker() == Jpeg.MARKER_APP1);
			
			block = (JpegBlock) blocks.elementAt(1);
			assertTrue(block.getMarker() == Jpeg.MARKER_DQT);
		}
		catch (Exception ex) {
			assertTrue(false);
		}
	}
	
}