/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package drjava.gui;

import drjava.util.GUIUtil;
import drjava.util.LetterLayout;

import javax.swing.*;

public class Form extends JPanel {
  public Form() {
    setLayout(LetterLayout.formWideRightSide().setSpacing(20, 5));
  }

  public Form(int minWidth) {
    this();
    GUIUtil.setMinimumWidth(this, minWidth);
  }

  public void addRow(String label, JComponent component) {
    add(new JLabel(label));
    add(component != null ? component : new JPanel());
  }

  public void addRow(JComponent component) {
    add(component);
    add(LetterLayout.getDummyComponent());
  }

  public void addSpacer() {
    addRow(new JLabel(" "));
  }

  public void addRow(String label, String text) {
    addRow(label, new JBetterLabel(text));
  }
}