package drjava.superversion.filesystem;

import drjava.util.Logger;
import drjava.util.ProgressControl;
import drjava.vats.Promise;

public interface Directory {
  FileSystem getFileSystem();

  public DirectoryContents getContents(Logger logger);
  public Promise<DirectoryContents> getContents_promise(Logger logger, ProgressControl progressControl);
  public String getName();
  public String getPath();

  /** get a file from this directory or a subdirectory
   * @param path slash-separated file path
   */
  public File getFile(String path);

  boolean isLocal();
  boolean exists();

  MutableDirectory getDirectory(String name);
}
