package drjava.superversion.filesystem;

import drjava.superversion.DownloadFailedException;
import drjava.superversion.api.Data;
import drjava.vats.Promise;

public abstract class WrappedData extends Data {
  private Data data;

  public WrappedData(Data data) {
    super(0);
    this.data = data;
  }

  public long getFingerprint() {
    return data.getFingerprint();
  }

  public long getSize() throws DownloadFailedException {
    return data.getSize();
  }

  public int getRef() {
    return data.getRef();
  }

  public Data getOriginal() {
    return data.getOriginal();
  }

  public boolean isLinkable() {
    return data.isLinkable();
  }

  public void ensureAvailability() throws DownloadFailedException {
    data.ensureAvailability();
  }

  public byte[] getBytes() throws DownloadFailedException {
    return data.getBytes();
  }

  public boolean isBinary() {
    return data.isBinary();
  }

  public Promise<byte[]> getBytes_promise() {
    return data.getBytes_promise();
  }
}
