package drjava.superversion.tools;

import drjava.vats.Vat;

import java.io.File;
import java.io.IOException;
import java.io.FileOutputStream;
import java.util.zip.ZipOutputStream;
import java.util.zip.ZipEntry;
import java.util.Date;

public class IOManagerImpl implements IOManager {
  private static IOManager_far instance;
  private static Vat vat;
  private static boolean debugMode;

  public static synchronized IOManager_far getInstance() {
    if (instance == null) {
      vat = new Vat("IOManager");
      if (!debugMode)
        vat.startThread()/*.setPriority(Thread.MIN_PRIORITY)*/;
      instance = (IOManager_far) vat.addObject(new IOManagerImpl());
    }
    return instance;
  }

  public byte[] loadFile(File file) throws IOException {
    return FileUtil.loadFile(file);
  }

  public static synchronized void turns() {
    getVat().turns();
  }

  private static Vat getVat() {
    getInstance();
    return vat;
  }

  public static synchronized void setDebugMode(boolean debug) {
    debugMode = debug;
  }

  public static Object addObjectToIOVat(Object object) {
    return getVat().addObject(object);
  }

}
