/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package drjava.util.i18n;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class ClasspathScanner {
  public static List<String> findAllClasses(File baseDir) {
    List<String> result = new ArrayList<String>();
    scanDir(baseDir, "", result);
    return result;
  }

  private static void scanDir(File dir, String pkg, List<String> result) {
    for (File file : dir.listFiles()) {
      if (file.isFile()) {
        if (file.getName().endsWith(".class")) {
          String className = pkg + file.getName().substring(0, file.getName().length() - 6);
          result.add(className);
        }
      } else {
        if (!file.getName().startsWith("."))
          scanDir(file, pkg + file.getName() + "/", result);
      }
    }
  }
}