package eye.eye01;

import drjava.util.Errors;
import drjava.util.GUIUtil;
import prophecy.common.image.BWImage;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.reflect.Method;

public class EyeGuiUtil {
  public static ActionListener actionListener(final Object object, String methodName) {
    final Method method;
    try {
      method = object.getClass().getMethod(methodName);
    } catch (NoSuchMethodException e) {
      throw new RuntimeException(e);
    }

    return new ActionListener() {
      public void actionPerformed(ActionEvent actionEvent) {
        try {
          method.invoke(object);
        } catch (Throwable t) {
          Errors.report(t);
        }
      }
    };
  }

  public static JFrame showImage(BWImage image) {
    return showImage(image, "Eye");
  }

  public static JFrame showImage(BWImage image, String title) {
    ScrollableImage scrollableImage = new ScrollableImage(image);
    JFrame frame = new JFrame(title);
    frame.setSize(500, 500);
    GUIUtil.centerOnScreen(frame);
    frame.getContentPane().add(scrollableImage);
    frame.setVisible(true);
    return frame;
  }
}
