package eye.eye02;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class FontSelector extends JComboBox {
  private FontEntry[] fontEntries;

  public FontSelector() {
    List<FontEntry> fontEntries = new ArrayList<FontEntry>();

    fontEntries.addAll(FontFinder.allEyeFonts());
    fontEntries.addAll(FontFinder.allSystemFonts());

    this.fontEntries = fontEntries.toArray(new FontEntry[fontEntries.size()]);
    setModel(new DefaultComboBoxModel(this.fontEntries));
  }

  public Font getSelectedFont() throws Exception {
    return ((FontEntry) getSelectedItem()).loadFont();
  }

  public String getSelectedFontName() {
    return ((FontEntry) getSelectedItem()).getName();
  }

  public void selectFont(String name) {
    if (name == null) return;
    for (int i = 0; i < fontEntries.length; i++) {
      FontEntry fontEntry = fontEntries[i];
      if (name.equals(fontEntry.getName())) {
        setSelectedIndex(i);
        return;
      }
    }
  }
}
