package eye.eye03;

import drjava.util.FileUtil;
import drjava.util.Tree;
import prophecy.common.PersistentTree;
import prophecy.common.Trigger;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Recognizers {
  private File dir;
  public Trigger trigger = new Trigger();

  public Recognizers() {
    dir = new File("memory/recognizers");
    dir.mkdirs();
  }

  public File save(RecognizerInfo info) throws IOException {
    int i = 1;
    File file;
    while (true) {
      file = new File(dir, "recognizer" + i + ".eye");
      if (!file.exists())
        break;
      else
        ++i;
    }

    FileUtil.saveTextFile(file, info.getTree().toString());
    System.out.println("Saved " + file.getPath());
    trigger.trigger();
    return file;
  }

  public List<RecognizerOnDisk> scan() throws IOException {
    List<RecognizerOnDisk> list = new ArrayList<RecognizerOnDisk>();
    for (File file : dir.listFiles()) {
      if (file.getName().toLowerCase().endsWith(".eye")) {
        Tree tree = Tree.parse(FileUtil.loadTextFile(file));
        list.add(new RecognizerOnDisk(file, new RecognizerInfo(tree).getName()));
      }
    }
    return list;
  }

  public void rename(RecognizerOnDisk recognizer, String newName) throws IOException {
    PersistentTree tree = recognizer.getTree();
    new RecognizerInfo(tree).setName(newName);
    tree.save();
    trigger.trigger();
  }

  public void delete(RecognizerOnDisk recognizer) throws IOException {
    if (!recognizer.file.delete())
      throw new IOException("Could not delete " + recognizer.file.getPath());
    trigger.trigger();
  }

  public RecognizerOnDisk findByName(String name) throws IOException {
    for (RecognizerOnDisk recognizerOnDisk : scan()) {
      if (recognizerOnDisk.getName().equals(name))
        return recognizerOnDisk;
    }
    return null;
  }
}
