package eyedev._14;

import eyedev._01.ImageReader;
import eyedev._01.OCRUtil;
import eyedev._09.*;
import eyedev._13.CompareImages;
import eyedev._13.IRSegmenter;
import prophecy.common.image.BWImage;

public class Fratboy extends ImageReader implements IRSegmenter {
  private CompareImages characterRecognizer = new CompareImages();
  private BWImage image;

  public Fratboy() {
  }

  public Fratboy(CompareImages characterRecognizer) {
    this.characterRecognizer = characterRecognizer;
  }

  public String readImage(BWImage image) {
    this.image = image;

    // Threshold is not so important here, just shouldn't produce any spurious black pixels

    Segmenter lineFinder = new EliminateLargeLetters(new LineFinder());

    // We wanna do a good letter segmentation, with a well-chosen threshold
    // (a too low threshold splits "n"s in two parts.
    // a too high threshold merges letters together.)

    FlexibleSegmenter lineSegmenter = new FlexibleSegmenter();
    lineSegmenter.setThreshold(0.75f);
    //lineSegmenter.setThreshold(0.25f); // this works fairly well for april-10-2.jpg

    SaR sar = new SaR(lineFinder, lineSegmenter, characterRecognizer);
    return delegateRecognition(sar, image);
  }

  public void setCharRecognizer(String description) {
    characterRecognizer = (CompareImages) OCRUtil.makeImageReader(description);
  }

  public String rerecognize() {
    return readImage(image);
  }
}
