package eyedev._14;

import drjava.util.Tree;
import eyedev._09.Segment;
import eyedev._09.SegmentLevel;
import eyedev._09.Segmenter;
import prophecy.common.image.BWImage;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class LineFinder extends Segmenter {
  private BWImage image;
  private float threshold = 0.5f;

  public LineFinder() {
  }

  private void addLine(List<Segment> segments, int y1, int y2) {
    Rectangle box = new Rectangle(0, y1, image.getWidth(), y2 - y1);
    segments.add(new Segment(SegmentLevel.line, box, image.clip(box)));
  }

  public List<Segment> segment(BWImage image) {
    this.image = image;
    
    boolean lastWhite = true;
    int lineStart = 0;
    List<Segment> segments = new ArrayList<Segment>();

    for (int y = 0; y < image.getHeight(); y++) {
      boolean white = isWhiteRow(y, 0, image.getWidth());
      if (!white && lastWhite) {
        lineStart = y;
      } else if (white && !lastWhite) {
        addLine(segments, lineStart, y);
      }
      lastWhite = white;
    }
    if (!lastWhite)
      addLine(segments, lineStart, image.getHeight());
    return segments;
  }

  private boolean isWhiteRow(int y, int x1, int x2) {
    for (int x = x1; x < x2; x++)
      if (image.getPixel(x, y) < threshold)
        return false;
    return true;
  }

  public void setThreshold(float threshold) {
    this.threshold = threshold;
  }

  @Override
  public void fromTree(Tree tree) {
    threshold = tree.getFloat("threshold", threshold);
  }

  @Override
  public Tree toTree() {
    return super.toTree().setFloat("threshold", threshold);
  }
}
