/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package jazz.retroui;

import java.awt.*;

public class Box {
  private FancyScreen screen;
  private int x1;
  private int y1;
  private int w;
  private int h;

  public Box(Screen screen, int x1, int y1, int w, int h) {
    this.screen = new FancyScreen(screen);
    this.x1 = x1;
    this.y1 = y1;
    this.w = w;
    this.h = h;
  }

  public Box(Screen screen, Rectangle r) {
    this(screen, r.x, r.y, r.width, r.height);
  }

  public void drawBorder() {
    screen.drawBox(x1, y1, w, h);
  }

  public void drawTitle(String s) {
    screen.print(x1 + 1, y1, " " + s + " ");
  }

  public FancyScreen innerScreen() {
    return screen.subscreen(x1+1, y1+1, w-2, h-2);
  }
}