/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package jazz.retroui;

import java.awt.*;

public class Cursor {
  private int x, y;
  private int blinkRate = 1000;

  public Cursor(int x, int y) {
    this.x = x;
    this.y = y;
  }

  public void paint(RetroUIPanel panel, Graphics g) {
    if (System.currentTimeMillis() % (blinkRate*2) > blinkRate) return;
    FontMetrics metrics = g.getFontMetrics(panel.theFont());
    int lineHeight = panel.lineHeight(metrics);
    int x = this.x*metrics.getMaxAdvance(), y = this.y*lineHeight;
    g.setColor(Color.white);
    g.drawRect(x, y+2, 1, lineHeight-2);
  }

  public int getBlinkRate() {
    return blinkRate;
  }

  public void setBlinkRate(int blinkRate) {
    this.blinkRate = blinkRate;
  }

  public int getX() {
    return x;
  }

  public int getY() {
    return y;
  }
}