/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package jazz.retroui;

import javax.swing.*;
import java.awt.*;

public class RetroUIFrame extends JFrame {
  private RetroUIPanel panel;
  private JPanel southPanel;

  public RetroUIFrame(String title, int cols, int rows) throws HeadlessException {
    super(title);
    setResizable(false);
    panel = new RetroUIPanel(cols, rows);
    getContentPane().add(panel);
    pack();
  }

  public FancyScreen getScreen() {
    return panel.getScreen();
  }

  public JPanel getSouthPanel() {
    if (southPanel == null) {
      southPanel = new JPanel();
      getContentPane().add(BorderLayout.SOUTH, southPanel);
    }
    return southPanel;
  }

  public RetroUIPanel getRetroUIPanel() {
    return panel;
  }
}