/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package newinternet.ni01;

import drjava.util.Tree;
import prophecy.common.socket.SocketHandler;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import static drjava.util.ObjectUtil.nice;

public abstract class Cmd {
  private String pattern;

  protected Cmd(String pattern) {
    this.pattern = pattern;
  }

  protected Cmd() {
    this.pattern = nice(getClass()).replaceFirst("^Cmd", "");
  }

  public abstract void run(String input, Matcher matcher, SocketHandler handler);

  public String getPattern() {
    return pattern;
  }

  public boolean matches(String input) {
    return matcher(input).matches();
  }

  public Matcher matcher(String input) {
    return Pattern.compile(pattern, Pattern.CASE_INSENSITIVE).matcher(input.trim());
  }

  public void run(String line, SocketHandler handler) {
    Matcher matcher = matcher(line);
    matcher.matches(); // assume that it does
    run(line, matcher, handler);
  }
}