package newinternet.ni01;

import drjava.util.Lizt;
import drjava.util.SwingTimerHelper;
import drjava.util.Updatable;
import prophecy.common.gui.Form;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

public class FileTransferPanel extends JPanel implements Updatable {
  private JCheckBox chkEnable = new JCheckBox();
  private JTextField tfDir = new JTextField();
  private JList list = new JList();
  private FileTransferSettings settings;
  private FileTransferHistory history;

  FileTransferPanel(FileTransferSettings settings, FileTransferHistory history) {
    this.settings = settings;
    this.history = history;
    chkEnable.setSelected(settings.isAllowReceive());
    ActionListener actionListener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saveSettings();
      }
    };
    chkEnable.addActionListener(actionListener);

    tfDir.setText(new File(settings.getDir()).getAbsolutePath());
    tfDir.addActionListener(actionListener);

    Form form = new Form();
    form.addRow("Allow receiving files", chkEnable);
    form.addRow("Save files in" , tfDir);
    form.addRow("", "(if you change this, confirm with enter)");
    form.addHeading("Files received");
    JScrollPane scrollPane = new JScrollPane(list);
    scrollPane.setMinimumSize(new Dimension(100, 100));
    form.addRow(scrollPane);
    new SwingTimerHelper(this, 2000).installOn(this);
    setLayout(new BorderLayout());
    add(form);
  }

  private void saveSettings() {
    settings.setAllowReceive(chkEnable.isSelected());
    settings.setDir(tfDir.getText());
    settings.save();
  }

  public void update() {
    Lizt<String> files = history.getFiles();
    list.setListData(files.toArray());
  }
}
