package newinternet.ni01;

import drjava.util.Tree;
import prophecy.common.PersistentTree;
import prophecy.common.Var;

public class FileTransferSettings {
  private Var<Boolean> allowReceive = new Var<Boolean>(false);
  private Var<String> dir = new Var<String>("");
  private PersistentTree tree;

  public FileTransferSettings(PersistentTree tree) {
    this.tree = tree;
    fromTree(tree);
  }

  public Tree toTree() {
    return new Tree()
      .setBool("allowReceive", allowReceive.get())
      .setString("dir", dir.get());
  }

  public void fromTree(Tree tree) {
    allowReceive.set(tree.getBool("allowReceive", true));
    dir.set(tree.getString("dir", "received_files"));
  }

  public boolean isAllowReceive() {
    return allowReceive.get();
  }

  public String getDir() {
    return dir.get();
  }

  public void setAllowReceive(boolean allowReceive) {
    this.allowReceive.set(allowReceive);
  }

  public void setDir(String dir) {
    this.dir.set(dir);
  }

  public void save() {
    tree.set(toTree());
    tree.save();
  }
}
