package newinternet.ni01;

import net.sbbi.upnp.impls.InternetGatewayDevice;
import net.sbbi.upnp.messages.UPNPResponseException;

import java.io.IOException;
import java.net.InetAddress;

public class FirewallOpener {
  private int discoveryTimeout = 5000;
  private String localIP;
  private int routersFound;
  private String externalIP;
  private boolean portOpened;

  public void openPort(int port) throws IOException, UPNPResponseException {
    //Discovery of the router
    System.out.println("Router discovery (timeout " + discoveryTimeout + " ms)");
    InternetGatewayDevice[] IGDs = InternetGatewayDevice.getDevices(discoveryTimeout);
    System.out.println(IGDs == null ? "No router found" : IGDs.length + " router(s) found");
    if (IGDs != null) {
      routersFound = IGDs.length;
      InternetGatewayDevice testIGD = IGDs[0];    //Internal Address
      externalIP = testIGD.getExternalIPAddress();
      System.out.println("External address: " + externalIP);
      localIP = InetAddress.getLocalHost().getHostAddress();
      testIGD.addPortMapping("UPnP Test", null, port, port, localIP, 0, "TCP");
      portOpened = true;
      System.out.println("Port mapping added");
    }
  }

  public String getLocalIP() {
    return localIP;
  }

  public int getRoutersFound() {
    return routersFound;
  }

  public String getExternalIP() {
    return externalIP;
  }

  public int getDiscoveryTimeout() {
    return discoveryTimeout;
  }

  public void setDiscoveryTimeout(int discoveryTimeout) {
    this.discoveryTimeout = discoveryTimeout;
  }

  public boolean isPortOpened() {
    return portOpened;
  }
}
