/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a01;

import prophecy.common.Marker;
import prophecy.common.StandardSubsetContest;
import prophecy.common.SubsetTI;
import prophecy.common.sound.Sound;

public class DetectSpeechFragments extends StandardSubsetContest<Sound> {
  double clipSize = 0.01;

  public DetectSpeechFragments(Sound sound, Marker speechStart, Marker speechEnd) {
    for (double s = 0; s < sound.getSeconds(); s += clipSize) {
      Marker m1 = new Marker(s), m2 = new Marker(s+clipSize);
      if (m1.after(speechStart) && m2.before(speechEnd))
        addContestItem(new SubsetTI<Sound>(sound.clip(m1, m2), true));
      else if (m2.before(speechStart) || m1.after(speechEnd))
        addContestItem(new SubsetTI<Sound>(sound.clip(m1, m2), false));
    }
    System.out.println(getPositiveExamples().size() + " pos, " + getNegativeExamples().size() + " neg");
  }

  public double getClipSize() {
    return clipSize;
  }
}