/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a01;

import org.tritonus.share.sampled.FloatSampleBuffer;
import prophecy.common.Prophecy;

import javax.sound.sampled.*;
import java.io.File;
import java.io.IOException;

public class LoadWav {
  public static void main(String[] args) throws IOException, UnsupportedAudioFileException {
    File file = new File(Prophecy.dataDir() + "audio/aibo.wav");
    //loadWithJavaSound(file);
    loadWithTritonus(file);
  }

  private static float[] loadWithTritonus(File file) throws IOException, UnsupportedAudioFileException {
    AudioInputStream inputStream = AudioSystem.getAudioInputStream(file);
    byte[] tempBuffer = readFully(inputStream);
    int samples = tempBuffer.length;
    System.out.println("samples: " + samples);

    FloatSampleBuffer floatSampleBuffer = new FloatSampleBuffer(tempBuffer, 0, tempBuffer.length,
      inputStream.getFormat());

    System.out.println("channel 0 size: " + floatSampleBuffer.getChannel(0).length);
    return floatSampleBuffer.getChannel(0);
  }

  private static byte[] readFully(AudioInputStream inputStream) throws IOException {
    int samples = (int) inputStream.getFrameLength();
    byte[] buffer = new byte[samples];
    int idx = 0, bytes;
    while ((bytes = inputStream.read(buffer, idx, samples-idx)) > 0) {
      idx += bytes;
    }
    return buffer;
  }

  private static void loadWithJavaSound(File file) throws UnsupportedAudioFileException, IOException {
    AudioFileFormat fileFormat = AudioSystem.getAudioFileFormat(file);
    System.out.println(fileFormat);

    //AudioFormat targetFormat = new AudioFormat(8000, 16, 1, true, true);
    AudioFormat targetFormat = new AudioFormat(48000, 16, 1, true, true);
    boolean supported = AudioSystem.isConversionSupported(targetFormat, fileFormat.getFormat());
    System.out.println("Conversion supported: " + supported);

    AudioInputStream inputStream = AudioSystem.getAudioInputStream(file);
    System.out.println(inputStream.getFormat());
  }
}