/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a01;

import prophecy.audio.a03.AudioAnalysis;
import prophecy.common.sound.Sound;

/** logarithm of average of sample amplitudes */
public class Loudness extends Feature<Sound> {
  public Loudness() {
    super("loudness");
  }

  public double extract(Sound sound) {
    double result = AudioAnalysis.absAverage(sound);
    //System.out.println("loudness: " + result);
    return (float) Math.log(result);
  }
}