/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a01;

import prophecy.common.Subset;
import prophecy.common.SubsetContest;
import prophecy.common.SubsetTI;
import prophecy.common.sound.Sound;
import prophecy.common.sound.SoundSurface;

import java.awt.*;

public class SoundDiscriminationSurface extends SoundSurface {
  private SubsetContest<Sound> contest;
  private double clipSize;
  private Subset<Sound> contestant;

  public SoundDiscriminationSurface(Sound sound, SubsetContest<Sound> contest, double clipSize, Subset<Sound> contestant) {
    super(sound);
    this.contest = contest;
    this.clipSize = clipSize;
    this.contestant = contestant;
  }

  public void render(int w, int h, Graphics2D g) {
    super.render(w, h, g);

    for (int i = 0; i < contest.getContestData().size(); i++) {
      SubsetTI<Sound> item = contest.getContestData().get(i);
      boolean inSet = item.inSet;
      g.setColor(inSet ? Color.white : Color.gray);
      g.fillRect(secondToX(i*clipSize), 0, 5, 10);

      boolean inSet2 = contestant.contains(item.example);
      g.setColor(inSet2 ? Color.white : Color.gray);
      g.fillRect(secondToX(i*clipSize), 10, 5, 10);
    }
  }
}