/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a02;

import prophecy.common.Marker;
import prophecy.common.StandardSubsetContest;
import prophecy.common.SubsetTI;
import prophecy.common.sound.Sound;

public class SoundDiscriminationContest extends StandardSubsetContest<Sound> {
  double clipSize = defaultClipSize;
  public static final double defaultClipSize = 0.01;

  public SoundDiscriminationContest() {
  }

  public SoundDiscriminationContest(double clipSize) {
    this.clipSize = clipSize;
  }

  public void addExample(Sound sound, boolean inSet) {
    for (double s = 0; s < sound.getSeconds(); s += clipSize) {
      Marker m1 = new Marker(s), m2 = new Marker(s+clipSize);
      addContestItem(new SubsetTI<Sound>(sound.clip(m1, m2), inSet));
    }
  }

  public double getClipSize() {
    return clipSize;
  }
}