/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a04;

import drjava.util.TreeUtil;
import prophecy.common.Prophecy;
import prophecy.audio.a01.SoundDiscriminationSurface;
import prophecy.audio.a02.SoundDiscriminationContest;
import prophecy.audio.a03.A3;
import prophecy.common.*;
import prophecy.common.sound.Sound;
import prophecy.common.sound.SoundUtil;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class A4 {
  public static void main(String[] args) {
    TreeUtil.registerPackageMigration("prophecy.audio.a1", "prophecy.audio.a01");
    TreeUtil.registerPackageMigration("prophecy.audio.a3", "prophecy.audio.a03");
    Subset<Sound> contestant = A3.loadEWFWinner();

    List<Named<Surface>> surfaces = new ArrayList<Named<Surface>>();
    addSurface(contestant, surfaces, Prophecy.dataDir() + "audio/beat.wav", true);
    addSurface(contestant, surfaces, Prophecy.dataDir() + "audio/background.wav", false);
    InspectionUtil.inspect(surfaces);
  }

  private static void addSurface(Subset<Sound> contestant, List<Named<Surface>> surfaces, String file, boolean inSet) {
    Sound sound = SoundUtil.load(new File(file));
    SoundDiscriminationContest contest = new SoundDiscriminationContest();
    contest.addExample(sound, inSet);
    surfaces.add(new Named<Surface>(file, new SoundDiscriminationSurface(sound, contest, contest.getClipSize(), contestant)));
  }
}