/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a05;

import prophecy.common.Prophecy;
import prophecy.audio.a01.SoundDiscriminationSurface;
import prophecy.audio.a02.SoundDiscriminationContest;
import prophecy.audio.a03.A3;
import prophecy.common.*;
import prophecy.common.sound.Sound;
import prophecy.common.sound.SoundUtil;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class A5 {
  public static void main(String[] args) {
    Subset<Sound> contestant = A3.loadEWFWinner();
    if (contestant == null) throw new RuntimeException("A3 winner not found");

    List<Named<Surface>> surfaces = new ArrayList<Named<Surface>>();
    addSurface(SoundDiscriminationContest.defaultClipSize, contestant, surfaces, Prophecy.dataDir() + "audio/beat.wav", true);
    addSurface(SoundDiscriminationContest.defaultClipSize, contestant, surfaces, Prophecy.dataDir() + "audio/background.wav", false);
    InspectionUtil.inspect(surfaces);
  }

  private static void addSurface(double originalClipSize, Subset<Sound> contestant, List<Named<Surface>> surfaces, String file, boolean inSet) {
    System.out.println();
    System.out.println(file);
    Sound sound = SoundUtil.load(new File(file));
    SoundDiscriminationContest contest = new SoundDiscriminationContest(1.0);
    contest.addExample(sound, inSet);
    Subset<Sound> translatedContestant = new TranslateClipSize(contestant, originalClipSize);
    contest.addContestant(translatedContestant);
    contest.run();
    surfaces.add(new Named<Surface>(file, new SoundDiscriminationSurface(sound, contest, contest.getClipSize(), translatedContestant)));
  }
}