/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a05;

import prophecy.audio.a03.AudioAnalysis;
import prophecy.common.Subset;
import prophecy.common.sound.Sound;

public class TranslateClipSize implements Subset<Sound> {
  private Subset<Sound> contestant;
  private double originalClipSize;

  public TranslateClipSize(Subset<Sound> contestant, double originalClipSize) {
    this.contestant = contestant;
    this.originalClipSize = originalClipSize;
  }

  public boolean contains(Sound sound) {
    int sum = 0;
    for (Sound clip : AudioAnalysis.clips(sound, originalClipSize)) {
      sum += contestant.contains(clip) ? 1 : -1;
    }
    return sum > 0;
  }
}