/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a08;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class SampleCollection {
  private List<SampleOnDisk> samples = new ArrayList<SampleOnDisk>();

  public SampleCollection(String dir) {
    for (File file : new File(dir).listFiles()) {
      if (file.isFile() && file.getName().endsWith(".wav")) {
        samples.add(new SampleOnDisk(file));
      }
    }
  }

  public List<SampleOnDisk> getSamples() {
    return samples;
  }
}