/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a08;

import drjava.util.Errors;
import prophecy.common.sound.Sound;
import prophecy.common.sound.SoundUtil;

import java.io.File;
import java.io.IOException;

public class SampleOnDisk {
  private File file;
  private SampleInfo info = new SampleInfo();

  public SampleOnDisk(File file) {
    this.file = file;
    try {
      info = SampleInfo.loadSampleInfo(file);
    } catch (IOException e) {
      Errors.add(e);
    }
  }

  public SampleOnDisk(String file) {
    this(new File(file));
  }

  public Sound load() {
    return SoundUtil.load(file);
  }

  public File getFile() {
    return file;
  }

  public SampleInfo getInfo() {
    return info;
  }

  public void saveInfo() {
    try {
      SampleInfo.saveSampleInfo(file, info);
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
  }
}