/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a08;

import drjava.util.GUIUtil;
import prophecy.common.Prophecy;
import prophecy.common.InspectionNode;
import prophecy.common.InspectionPanel;
import prophecy.common.Visualizable;

import javax.swing.*;

public class SamplesPanel {
  static JComponent makePanel() {
    SampleCollection sampleCollection = new SampleCollection(Prophecy.dataDir() + "audio");
    InspectionNode root = new InspectionNode("Samples on disk");
    for (final SampleOnDisk sample : sampleCollection.getSamples()) {
      InspectionNode node = new InspectionNode(sample.getFile().getName());
      node.setVisualizable(new Visualizable() {
        public JComponent visualize() {
          SamplePanel samplePanel = new SamplePanel(sample);
          return GUIUtil.withTitle(sample.getFile().getName(), samplePanel);
        }
      });
      root.add(node);
    }
    return new InspectionPanel(root).getPanel();
  }
}