/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a09;

import prophecy.common.Prophecy;
import prophecy.audio.a06.A06;
import prophecy.audio.a06.AudioEventFinder;
import prophecy.audio.a08.SampleOnDisk;
import prophecy.common.ContestUtil;
import static prophecy.common.SurfaceUtil.show;

import prophecy.common.sound.Sound;
import prophecy.common.sound.SoundSurface;
import prophecy.common.sound.SoundWithMarkers;

public class A09 {
  public static final String SINGHALLELUJA = Prophecy.dataDir() + "audio/singhalleluja_chorus.wav";
  public static final double SINGHALLELUJA_BPM = 124.6;

  public static void main(String[] args) {
    SampleOnDisk sample = new SampleOnDisk(Prophecy.dataDir() + "audio/singhalleluja_chorus.wav");
    AudioEventFinder eventFinder = (AudioEventFinder) ContestUtil.loadWinner(A06.CONTEST_STAGE0);
    System.out.println(eventFinder);
    Sound sound = sample.load();
    show(new SoundSurface(new SoundWithMarkers(sound, eventFinder.findEvents(sound))));
  }
}