/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a09;

import prophecy.e.e01.Metric;
import prophecy.e.e02.Distribution;

import static java.lang.Math.abs;

/** an asymmetric metric! */
public class RelativeDistributionMetric implements Metric<Distribution> {
  public double getDistance(Distribution main, Distribution b) {
    if (main.getAverage() == 0)
      return abs(b.getAverage());
    return abs(b.getAverage()-main.getAverage())/abs(main.getAverage());
  }
}