/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a09;

import prophecy.audio.a06.A06;
import prophecy.audio.a06.AudioEventFinder;
import prophecy.common.ContestUtil;
import prophecy.common.ContestantReceiver;
import prophecy.common.OpenContestRetroUI;
import prophecy.common.OpenContestRun;
import prophecy.common.sound.SoundUtil;

public class RunContest {
  private static final String CONTEST = "a09";

  public static void main(String[] args) {
    BPMContest contest = new BPMContest(SoundUtil.loadSound(A09.SINGHALLELUJA), A09.SINGHALLELUJA_BPM);
    ContestUtil.saveContest(contest, CONTEST);

    OpenContestRun<BPMDetector> run = new OpenContestRun<BPMDetector>(CONTEST);
    run.clearHallOfFame();
    run.setUI(new OpenContestRetroUI<BPMDetector>());
    makeContestants(run);
    run.run();
  }

  private static void makeContestants(ContestantReceiver<BPMDetector> run) {
    final AudioEventFinder beatFinder = (AudioEventFinder) ContestUtil.loadWinner(A06.CONTEST_STAGE0);
    run.addContestant(new BeatGrid(beatFinder));
  }

}