/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a10;

import prophecy.audio.a06.A06;
import prophecy.audio.a06.AudioEventFinder;
import prophecy.audio.a09.A09;
import prophecy.audio.a09.BPMDetector;
import prophecy.audio.a09.BeatGrid;
import prophecy.common.*;
import static prophecy.common.sound.SoundUtil.loadSound;

public class A10 {
  private static ContestGroup contestGroup = new ContestGroup("a10");
  public static ContestOnDisk<BPMContest_vol, BPMDetector> volumes = contestGroup.getContest("volumes");

  public static void main(String[] args) {
    BPMContest_vol contest = volumes.load();
    if (contest == null) {
      contest = new BPMContest_vol(loadSound(A09.SINGHALLELUJA), A09.SINGHALLELUJA_BPM);
      volumes.save(contest);
    }

    OpenContestRun<BPMDetector> run = new OpenContestRun<BPMDetector>(volumes);
    run.clearHallOfFame();
    run.setUI(new OpenContestRetroUI<BPMDetector>());
    makeContestants(run);
    run.run();
  }

  private static void makeContestants(ContestantReceiver<BPMDetector> run) {
    final AudioEventFinder beatFinder = (AudioEventFinder) ContestUtil.loadWinner(A06.CONTEST_STAGE0);
    run.addContestant(new BeatGrid(beatFinder));
    run.addContestant(new BeatGrid(new NormalizedAudioEventFinder(beatFinder)));
  }

}