/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a10;

import drjava.util.Tree;
import prophecy.audio.a03.AudioAnalysis;
import prophecy.audio.a09.BPMContest;
import prophecy.audio.a09.BPMDetector;
import prophecy.common.sound.Sound;

public class BPMContest_vol extends BPMContest {
  public BPMContest_vol(Sound sound, double realBPM) {
    super(sound, realBPM);
  }

  public BPMContest_vol(Tree tree) {
    super(tree);
  }

  public double evaluate(BPMDetector contestant) {
    double score = 0;
    for (int i = 1; i <= 5; i++) {
      double volume = i/5.0;
      score += new BPMContest(AudioAnalysis.mul(sound, volume), realBPM).evaluate(contestant);
    }
    return score;
  }
}