/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a10;

import prophecy.common.ContestUtil;
import prophecy.common.SimpleInspectableParent;
import prophecy.common.ContestOnDisk;

import java.util.List;

public class ContestGroup implements SimpleInspectableParent {
  private String groupName;

  public ContestGroup(String groupName) {
    this.groupName = groupName;
  }

  public String getGroupName() {
    return groupName;
  }

  public ContestOnDisk getContest(String contestName) {
    return new ContestOnDisk(groupName, contestName);
  }

  public List<ContestOnDisk> getContests() {
    return ContestUtil.getAllContestsOnDisk(groupName + "_");
  }

  public List getInspectionChildren() {
    return getContests();
  }

  public String toString() {
    return "Contest group " + groupName;
  }
}