/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.audio.a10;

import prophecy.common.Prophecy;
import prophecy.audio.a09.BPMContest;
import prophecy.audio.a09.BPMDetector;
import prophecy.audio.a09.BeatGrid;
import prophecy.common.ContestUtil;
import prophecy.common.HallOfFame;
import static prophecy.common.InspectionUtil.inspect;

import prophecy.common.sound.Sound;
import prophecy.common.sound.SoundUtil;

public class Idealistic {
  public static void main(String[] args) {
    Sound sound = SoundUtil.loadSound(Prophecy.dataDir() + "audio/idealistic.wav");
    BPMContest contest = new BPMContest(sound, 130);
    HallOfFame<BPMDetector> hallOfFame = ContestUtil.<BPMDetector>loadHallOfFame(A10.volumes);
    contest.addContestants(hallOfFame.getContestants());

    // make another contestant to improve the -4 score
    // current result: -2.68
    contest.addContestant(new BeatGrid(((BeatGrid) hallOfFame.getWinner()).getBeatFinder(),
      new GridFinder2(2)));

    contest.run();
    BPMDetector winner = contest.getWinner();
    Debug.start();
    winner.detectBPM(sound);
    Debug.stop();
    inspect(winner);
  }
}