/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.ce.ce01;

import drjava.util.Lizt;
import static drjava.util.ObjectUtil.nice;

import java.util.List;

public class CurrentUserState extends ActiveIngredient {
  private final UserState userState;

  public CurrentUserState(UserState userState) {
    this.userState = userState;
  }

  public UserState getUserState() {
    return userState;
  }

  public CurrentUserState getReplacement() {
    return (CurrentUserState) replacement;
  }

  public List<PossibleReaction> getPossibleReactions() {
    return Lizt.<PossibleReaction> of(new PossibleReaction(this, CurrentUserState.class) {
      public boolean runWith(Object b) {
        CurrentUserState newState = (CurrentUserState) b;
        if (userState.getNick().equalsIgnoreCase(newState.getUserState().getNick())
          && newState.getUserState().getEvidence().getTimestamp()
            .isLaterThan(userState.getEvidence().getTimestamp())) {
          replaceWith(newState);
          return true;
        }
        return false;
      }
    });
  }

  public String toString() {
    return "CurrentUserState " + nice(userState);
  }
}