/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.ce.ce01;

import drjava.util.SwingTimerHelper;
import drjava.util.Updatable;
import prophecy.common.SequenceNumber;

import javax.swing.*;
import java.awt.*;

public class JSequenceCounter extends JLabel implements Updatable {
  private long lastValue;

  public JSequenceCounter() {
    super(" ", JLabel.CENTER);
    setFont(new Font("Courier New", Font.BOLD, 48));

    new SwingTimerHelper(this, 100).installOn(this);
  }

  public void update() {
    long currentNumber = SequenceNumber.currentNumber();
    if (currentNumber != lastValue) {
      lastValue = currentNumber;
      setNumber(currentNumber);
    }
  }

  protected void setNumber(long currentNumber) {
    setText(String.valueOf(currentNumber));
  }

  public static JFrame makeFrame() {
    final JFrame frame = new JFrame("Sequence counter");
    frame.getContentPane().setLayout(new BorderLayout());
    frame.getContentPane().add(BorderLayout.CENTER, new JSequenceCounter() {
      protected void setNumber(long currentNumber) {
        super.setNumber(currentNumber);
        frame.setTitle(currentNumber + " (Sequence counter)");
      }
    });
    frame.setSize(250, 100);
    return frame;
  }

  public static void showFrame() {
    makeFrame().setVisible(true);
  }
}