/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.ce.ce01;

public class UserState {
  private final String nick;
  private final boolean loggedIn;
  private final String status;
  private Evidence evidence;

  public UserState(String nick, boolean loggedIn, String status,
                   Evidence evidence) {
    this.nick = nick;
    this.loggedIn = loggedIn;
    this.status = status;
    this.evidence = evidence;
  }

  public String getNick() {
    return nick;
  }

  public boolean isLoggedIn() {
    return loggedIn;
  }

  public String getStatus() {
    return status;
  }

  public Evidence getEvidence() {
    return evidence;
  }

  public String toString() {
    return /*"UserState " +*/ (isLoggedIn() ? "" : "--")
      + nick + " [" + status + "] " + evidence.getTimestamp();
  }
}