/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.ce.ce01;

import drjava.util.Lizt;

import java.util.List;

public class UserStateQuery extends ActiveIngredient {
  private String nick;
  private CurrentUserState replacement;

  public UserStateQuery(String nick) {
    this.nick = nick;
  }

  public String getNick() {
    return nick;
  }

  public CurrentUserState getReplacement() {
    return replacement;
  }

  public List<PossibleReaction> getPossibleReactions() {
    return Lizt.<PossibleReaction> of(new PossibleReaction(this, UserState.class) {
      public boolean runWith(Object b) {
        UserState userState = (UserState) b;
        if (nick.equals(userState.getNick())) {
          replacement = add(new CurrentUserState(userState));
          return true;
        }
        return false;
      }
    });
  }
}