package prophecy.ce.ce03;

import drjava.util.StringUtil;

import java.util.Collection;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class AlphabeticalSmileyCorrector implements SmileyCorrector {
  private ArrayList<String> names = new ArrayList<String>();

  public synchronized void setSmileyNames(Collection<String> names) {
    this.names = new ArrayList<String>(names);
    Collections.sort(this.names);
  }

  public synchronized String getCorrection(String name) {
    int i = Collections.binarySearch(names, name);
    if (i >= 0) return names.get(i);
    List<String> candidates = new ArrayList<String>();
    int j = -i-2;
    if (j >= 0 && j < names.size()) candidates.add(names.get(j));
    j = -i-1;
    if (j >= 0 && j < names.size()) candidates.add(names.get(j));
    return getBestCandidate(candidates, name);
  }

  private String getBestCandidate(List<String> candidates, String key) {
    if (candidates.isEmpty()) return null;
    String best = candidates.get(0);
    for (int i = 1; i < candidates.size(); i++) {
      if (StringUtil.commonPrefix(best, key).length()
        < StringUtil.commonPrefix(candidates.get(i), key).length())
        best = candidates.get(i);
    }
    return best;
  }
}
