/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import drjava.util.FromTree;
import drjava.util.ToTree;
import drjava.util.Tree;

public class ContestInfo implements FromTree, ToTree {
  private String shortDescription = "", longDescription = "", author = "";

  public String getShortDescription() {
    return shortDescription;
  }

  public void setShortDescription(String shortDescription) {
    this.shortDescription = shortDescription;
  }

  public String getLongDescription() {
    return longDescription;
  }

  public void setLongDescription(String longDescription) {
    this.longDescription = longDescription;
  }

  public String getAuthor() {
    return author;
  }

  public void setAuthor(String author) {
    this.author = author;
  }

  public void fromTree(Tree tree) {
    shortDescription = tree.getString("shortDescription", "");
    longDescription = tree.getString("longDescription", "");
    author = tree.getString("author", "");
  }

  public Tree toTree() {
    return new Tree(getClass())
      .setString("shortDescription", shortDescription)
      .setString("longDescription", longDescription)
      .setString("author", author);
  }
}