/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import prophecy.common.*;
import prophecy.common.ContestInfo;

public class ContestOnDisk<C extends Contest, A> {
  private String groupName;
  private String contestName;

  public ContestOnDisk(String groupName, String contestName) {
    this.groupName = groupName;
    this.contestName = contestName;
  }

  public ContestOnDisk(String name) {
    this.groupName = "";
    this.contestName = name;
  }

  public C load() {
    return (C) ContestUtil.loadContest(getFullName());
  }

  public String getFullName() {
    return groupName.length() == 0 ? contestName : groupName + "_" + contestName;
  }

  public void save(C contest) {
    ContestUtil.saveContest(contest, getFullName());
  }

  public HallOfFame getHallOfFame() {
    return ContestUtil.loadHallOfFame(getFullName());
  }

  public Object getWinner() {
    return getHallOfFame().getWinner();
  }

  public OpenContestRun<A> getOpenContestRun() {
    return ContestUtil.getOpenContestRun(getFullName());
  }

  public ContestInfo getContestInfo() {
    return ContestUtil.loadContestInfo(getFullName());
  }

  public void saveContestInfo(ContestInfo contestInfo) {
    ContestUtil.saveContestInfo(contestInfo, getFullName());
  }

  public void addContestant(Object contestant) {
    OpenContestRun openContestRun = getOpenContestRun();
    openContestRun.addContestant(contestant);
    openContestRun.run();
  }
}