/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

public class ContestRun<A> extends AbstractContestRun<A> {
  private final IContest<A> contest;

  public ContestRun(IContest<A> contest) {
    super();
    this.contest = contest;
    trainer = contest.getTrainer();
  }

  public double evaluate(A contestant) {
    return contest.evaluate(contestant);
  }

  public Double getBestPossibleScore() {
    return contest.getBestPossibleScore();
  }

  public Double getWorstPossibleScore() {
    return contest.getWorstPossibleScore();
  }
}