/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

public class RevolvingSuccessMeter {
  private int total, correct, bufPtr;
  private boolean[] buffer;

  public RevolvingSuccessMeter() {
    this(100);
  }

  public RevolvingSuccessMeter(int bufferSize) {
    buffer = new boolean[bufferSize];
  }

  public void add(boolean success) {
    set(bufPtr, success);
    bufPtr = (bufPtr+1) % buffer.length;
    if (total < buffer.length) ++total;
  }

  private void set(int i, boolean b) {
    if (buffer[i] != b) {
      correct += b ? 1 : -1;
      buffer[i] = b;
    }
  }

  public int getPercent() {
    return total == 0 ? 0 : correct*100/total;
  }

  public int getCorrect() {
    return correct;
  }

  public int getTotal() {
    return total;
  }

  public int getBufferSize() {
    return buffer.length;
  }
}