/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import prophecy.common.Generator;

public class SingletonGenerator<A> implements Generator<A> {
  private A a;

  public SingletonGenerator(A a) {
    this.a = a;
  }

  public A next() {
    try {
      return a;
    } finally {
      a = null;
    }
  }
}