/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import drjava.util.Errors;
import drjava.util.FileUtil;
import drjava.util.TextView;

import javax.swing.*;
import java.awt.*;
import java.io.File;
import java.io.IOException;

public class SourceFile implements Visualizable {
  private File file;

  public SourceFile(File file) {
    this.file = file;
  }

  public JComponent visualize() {
    try {
      String text = FileUtil.loadTextFile(file);
      TextView textView = makeSourceView(text);
      return textView;
    } catch (IOException e) {
      Errors.add(e);
      return null;
    }
  }

  public static TextView makeSourceView(String text) {
    TextView textView = new TextView(TextView.nlToBrWithIndent(text));
    textView.setTextFont(new Font("Courier New", Font.PLAIN, 12));
    textView.setInset(10);
    return textView;
  }

  public String toString() {
    return file.getName().substring(0, file.getName().length()-5);
  }
}