/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import java.util.ArrayList;
import java.util.List;

public class StandardSubsetContest<A> extends SubsetContest<A> {
  List<SubsetTI<A>> contestData = new ArrayList<SubsetTI<A>>();
  List<A> positiveExamples = new ArrayList<A>();
  List<A> negativeExamples = new ArrayList<A>();

  public void addContestItems(List<SubsetTI<A>> items) {
    for (SubsetTI<A> item : items)
      addContestItem(item);
  }

  public void addContestItem(SubsetTI<A> item) {
    contestData.add(item);
    (item.inSet ? positiveExamples : negativeExamples).add(item.example);
  }

  protected List<A> getPositiveExamples() {
    return positiveExamples;
  }

  protected List<A> getNegativeExamples() {
    return negativeExamples;
  }

  public List<SubsetTI<A>> getContestData() {
    return contestData;
  }
}