/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import java.util.List;

public class SubsetAutoTrainer<A, C extends Trainable<SubsetTI<A>>> implements Trainer<C> {
  private final double trainingRatio = 0.25;
  private List<SubsetTI<A>> trainingData;

  public SubsetAutoTrainer(SubsetContest<A> contest) {
    trainingData = TrainerUtil.makeTrainingData(contest.getContestData(), trainingRatio);
  }

  public void train(C contestant) {
    contestant.train(trainingData);
  }
}