/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import drjava.util.ToTree;
import drjava.util.Tree;

import static java.util.Arrays.asList;
import java.util.List;

public class SubsetTI<A> implements InspectableParent, ToTree {
  public final A example;
  public final boolean inSet;

  public SubsetTI(A example, boolean inSet) {
    this.example = example;
    this.inSet = inSet;
  }

  public List<InspectionNode> getInspectionChildren() {
    return asList(new InspectionNode("example", example), new InspectionNode("inSet", inSet));
  }

  public Tree toTree() {
    return new Tree(getClass())
      .add("example", example)
      .add("inSet", inSet);
  }
}