/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import prophecy.common.SequenceNumber;

public class Timestamp {
  private long time;
  private SequenceNumber sequenceNumber;

  public Timestamp() {
    time = System.currentTimeMillis();
    sequenceNumber = new SequenceNumber();
  }

  public Timestamp(long time) {
    this.time = time;
  }

  public long getTime() {
    return time;
  }

  public boolean isLaterThan(Timestamp timestamp) {
    if (sequenceNumber != null && timestamp.getSequenceNumber() != null)
      return sequenceNumber.getNumber() > timestamp.getSequenceNumber().getNumber();
    return time > timestamp.getTime();
  }

  public String toString() {
    return "time(" + ((time/100) % 10000) + ")";
  }

  public SequenceNumber getSequenceNumber() {
    return sequenceNumber;
  }
}