/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import drjava.util.ToTree;
import drjava.util.Tree;

import java.util.List;

public class TrainableTrainer<TD, C extends Trainable<TD>> implements Trainer<C>, ToTree {
  private final List<TD> trainingData;

  public TrainableTrainer(List<TD> trainingData) {
    this.trainingData = trainingData;
  }

  public void train(C trainable) {
    trainable.train(trainingData);
  }

  public Tree toTree() {
    return new Tree(getClass()).add("trainingData", trainingData);
  }
}