/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import java.util.ArrayList;
import java.util.List;

public class TrainerUtil {
  public static <A> List<A> makeTrainingData(List<A> items, double ratio) {
    double x = 0;
    List<A> result = new ArrayList<A>();
    for (A item : items) {
      x += ratio;
      if (x >= 1.0) {
        x -= 1.0;
        result.add(item);
      }
    }
    return result;
  }
}