/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common;

import drjava.util.Errors;
import drjava.util.FileUtil;

import javax.swing.*;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class ZipSourceFile implements Visualizable {
  private String zipFileName;
  private String entryName;

  public ZipSourceFile(String zipFileName, String entryName) {
    this.zipFileName = zipFileName;
    this.entryName = entryName;
  }

  public String toString() {
    return entryName.substring(entryName.lastIndexOf('/') + 1, entryName.length() - 5);
  }

  public JComponent visualize() {
    ZipFile zipFile = null;
    try {
      zipFile = new ZipFile(zipFileName);
      ZipEntry entry = zipFile.getEntry(entryName);
      Reader reader = new InputStreamReader(zipFile.getInputStream(entry));
      String text = FileUtil.loadTextFile(reader);
      zipFile.close();
      return SourceFile.makeSourceView(text);
    } catch (IOException e) {
      Errors.add(e);
      return null;
    }
  }
}