/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.comments;

import drjava.util.Tree;
import static drjava.util.TreeUtil.treeToList;

import java.io.IOException;
import java.util.List;

public class CommentClient {
  private TreeClient client;

  public CommentClient(String server) {
    client = new TreeClient(server, 54005);
  }

  public int getCommentCount() throws IOException {
    return client.ask(new Tree("getCommentCount")).intValue();
  }

  public Comment getComment(int index) throws IOException {
    return client.ask(new Tree("getComment", new Tree(index))).getObject();
  }

  public static void main(String[] args) throws IOException {
    CommentClient client = new CommentClient("localhost");
    int count = client.getCommentCount();
    System.out.println("comment count = " + count);
    for (int i = 0; i < count; i++)
      System.out.println(i + ": " + client.getComment(i));
  }

  public void addComment(Comment comment) throws IOException {
    client.ask(new Tree("addComment").add(comment));
  }

  public List<Comment> getComments() throws IOException {
    return treeToList(client.ask(new Tree("getComments")));
  }

  /*public Stream<List<Comment>> getComments_keepalive() throws IOException {
    Stream<Tree> rawStream = client.ask_keepalive(new Tree("getComments_keepalive"));
    final Stream<List<Comment>> stream = new Stream<List<Comment>>();
    rawStream.addStreamListener(new StreamListener<Tree>() {
      public void dataReceived(Tree item) {
        stream.putIn(treeToList(item));
      }

      public void streamClosed() {
        stream.close();
      }
    });
    return stream;
  }*/

  public Stream getTriggerStream() throws IOException {
    return client.ask_keepalive(new Tree("getTriggerStream"));
  }
}