/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.comments;

import drjava.util.TreePersistence;
import drjava.util.TreeUtil;

import java.util.ArrayList;
import java.util.List;

public class CommentList {
  private final TreePersistence persistence;
  private List<Comment> comments = new ArrayList<Comment>();

  public CommentList(TreePersistence persistence) {
    this.persistence = persistence;
    comments = TreeUtil.treeToList(persistence.load());
  }

  public synchronized Comment getComment(int index) {
    return comments.get(index);
  }

  public synchronized int getCommentCount() {
    return comments.size();
  }

  public synchronized void addComment(Comment comment) {
    comments.add(comment);
    persistence.store(TreeUtil.listToTree(comments));
  }

  public synchronized List<Comment> getComments() {
    return new ArrayList<Comment>(comments);
  }
}