/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.comments;

import drjava.util.Errors;
import drjava.util.FileUtil;
import prophecy.common.Prophecy;

import java.io.IOException;

public class ShoutboxDefaults {
  private static final String userNameFile = Prophecy.memoryDir() + "shoutbox/username.txt";

  public static String getUserName() {
    try {
      return FileUtil.loadTextFile(userNameFile, "");
    } catch (IOException e) {
      Errors.add(e);
      return "";
    }
  }

  public static void setUserName(String userName) {
    try {
      FileUtil.saveTextFile(userNameFile, userName);
    } catch (IOException e) {
      Errors.add(e);
    }
  }
}