/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.comments;

import java.util.ArrayList;
import java.util.List;

public class Stream<A> {
  private List<StreamListener<A>> listeners = new ArrayList<StreamListener<A>>();

  public void close() {
    for (StreamListener<A> listener : listeners) {
      listener.streamClosed();
    }
  }

  public void putIn(A item) {
    for (StreamListener<A> listener : listeners) {
      listener.dataReceived(item);
    }
  }

  public void addStreamListener(StreamListener<A> listener) {
    listeners.add(listener);
  }
}