/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.lifeform;

import static drjava.util.ObjectUtil.nice;

public class Box extends Lifeform {
  private Object contents;

  public Box() {
  }

  public Box(Object contents) {
    this.contents = contents;
  }

  public Object getContents() {
    return contents;
  }

  public void setContents(Object contents) {
    this.contents = contents;
  }

  public String toString() {
    try {
      return contents == null ? "Empty box" : "Box | " + nice(contents);
    } catch (Throwable e) {
      error(e);
      return "Box with unknown contents";
    }
  }

  public void set(Object contents) {
    setContents(contents);
  }

  public Object get() {
    return contents;
  }
}