/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.lifeform;

import drjava.util.StringUtil;

import java.util.Date;

public class LogEntry {
  private Date date;
  private String text;

  public LogEntry(String text) {
    date = new Date();
    this.text = text;
  }

  public Date getDate() {
    return date;
  }

  public String getText() {
    return text;
  }

  public String getDateAndText() {
    return "[" + StringUtil.formatTime(date) + "] "
      + text;
  }

  public String toString() {
    return getDateAndText();
  }
}