/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.lifeform;

import drjava.util.Errors;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

public class SmartIntroduce {
  private List<Method> methods = new ArrayList<Method>();

  public SmartIntroduce(Class lfClass) {
    for (Method method : lfClass.getMethods()) {
      if (method.getName().equals("introduce") && method.getParameterTypes().length == 1
        && !Lifeform.class.equals(method.getParameterTypes()[0]))
        methods.add(method);
    }
  }

  public void introduce(Lifeform instance, Lifeform object) {
    for (Method method : methods) {
      if (method.getParameterTypes()[0].isInstance(object))
        try {
          method.invoke(instance, object);
        } catch (Throwable e) {
          Errors.add(e);
        }
    }
  }

  public int getMethodCount() {
    return methods.size();
  }
}