/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.lifeform;

public class Wait extends Activity {
  private Long startTime;
  private double seconds;
  private Activity followUp;
  private String status;

  public Wait(double seconds, Activity followUp) {
    this.seconds = seconds;
    this.followUp = followUp;
    status = "Waiting " + seconds + "s, then: " + followUp.getStatus();
  }

  public Wait(String status, double seconds, Activity followUp) {
    this.seconds = seconds;
    this.followUp = followUp;
    this.status = status;
  }

  protected void idleImpl() {
    if (startTime == null)
      startTime = System.currentTimeMillis();
    if (System.currentTimeMillis() >= startTime+seconds*1000)
      getLifeform().setActivity(followUp);
  }

  public String getStatus() {
    return status;
  }
}