/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.common.lifeform;

import java.util.ArrayList;
import java.util.List;
import java.util.WeakHashMap;

public class WeakRefShelter extends HomelessShelter {
  private WeakHashMap<Lifeform,Object> map = new WeakHashMap<Lifeform, Object>();

  public synchronized void add(Lifeform lifeform) {
    map.put(lifeform, "");
  }

  public synchronized void remove(Lifeform lifeform) {
    map.remove(lifeform);
  }

  public synchronized String toString() {
    return "Homeless shelter [" + map.size() + "]";
  }

  public synchronized List<Lifeform> getInhabitants() {
    return new ArrayList<Lifeform>(map.keySet());
  }
}