package prophecy.common.socket;

import java.net.Socket;
import java.net.SocketAddress;
import java.io.InputStream;
import java.io.IOException;
import java.io.OutputStream;

public class RealSocket implements ISocket {
  private Socket socket;

  public RealSocket(Socket socket) {
    this.socket = socket;
  }

  public InputStream getInputStream() throws IOException {
    return socket.getInputStream();
  }

  public OutputStream getOutputStream() throws IOException {
    return socket.getOutputStream();
  }

  public boolean isClosed() {
    return socket.isClosed();
  }

  // socket handler closes streams, nothing to do here
  public void close() {
  }

  public SocketAddress getRemoteSocketAddress() {
    return socket.getRemoteSocketAddress();
  }
}
