package prophecy.common.socket;

import drjava.util.Tree;

import java.util.concurrent.locks.ReentrantLock;

public class SocketClient {
  private SocketHandler socketHandler;
  protected ReentrantLock lock = new ReentrantLock();
  public boolean debug = false;

  public void startCommunication(SocketHandler socketHandler) {
    if (this.socketHandler != null)
      throw new RuntimeException("Use a new instance, this object is bound");
    this.socketHandler = socketHandler;

    lock();
    try {
      String greeting = socketHandler.readLine();
      System.out.println("Greeting: " + greeting);
    } finally {
      unlock();
    }
  }

  private void lock() {
    if (debug)
      System.out.println("SocketClient.lock");
    lock.lock();
  }

  private void unlock() {
    if (debug)
      System.out.println("SocketClient.unlock");
    lock.unlock();
  }

  public Tree cmd(Tree cmd) {
    lock();
    try {
      socketHandler.println(cmd);
      return socketHandler.expectOK();
    } finally {
      unlock();
    }
  }

  public void closeConnection() {
    socketHandler.close();
  }

  public Tree bye() {
    return cmd(new Tree("bye"));
  }

  public boolean isConnected() {
    return socketHandler != null && !socketHandler.isClosed() && socketHandler.getIOException() == null;
  }

  public boolean isBusy() {
    return lock.isLocked();
  }
}
