/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e01;

import java.util.HashSet;

public class StatsUtil {
  public static <A> float getDistance(Stats<A> statsA, Stats<A> statsB) {
    statsA = statsA.normalized();
    statsB = statsB.normalized();

    HashSet<A> objects = new HashSet<A>();
    objects.addAll(statsA.getObjects());
    objects.addAll(statsB.getObjects());

    float sum = 0;
    for (A object : objects) {
      float dist = statsA.get(object) - statsB.get(object);
      sum += dist * dist;
    }
    return sum;
  }

  public static <A> Metric<Stats<A>> getMetric() {
    return new Metric<Stats<A>>() {
      public double getDistance(Stats<A> a, Stats<A> b) {
        return StatsUtil.getDistance(a, b);
      }
    };
  }
}