/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e03;

import prophecy.common.image.RGBImage;
import prophecy.e.e02.DistributionMaker;

import java.util.ArrayList;
import java.util.List;

public class ByBrightness implements CuckooSpotter<RGBImage> {
  public int guess(List<RGBImage> candidates) {
    List<Float> values = new ArrayList<Float>();
    DistributionMaker analyzer = new DistributionMaker();

    for (RGBImage image : candidates) {
      float v = (float) image.toBW().averageBrightness();
      //System.out.println("v=" + v);
      values.add(v);
      analyzer.addData((double) v);
    }

    // find the one with largest distance to average

    double avg = analyzer.getResult().getAverage();
    int best = 0;
    double max = 0;
    for (int i = 0; i < values.size(); i++) {
      Float value = values.get(i);
      double dist = Math.abs(value - avg);
      if (dist > max) {
        max = dist;
        best = i;
      }
    }

    return best;
  }
}