/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e04;

import prophecy.common.Prophecy;
import prophecy.common.Contest;
import prophecy.common.image.ImageSet;

import java.io.IOException;

public class SpotTheStation extends Contest<StationSpotter> {
  final ImageSet images;

  public SpotTheStation() throws IOException {
    super(StationSpotter.class);
    images = new ImageSet(Prophecy.dataDir() + "aibopics", "bongo", "bongo_station", "bongo_station2");
  }

  public double evaluate(StationSpotter contestant) {
    double score = 0;
    for (ImageSet.Image image : images.getImages()) {
      boolean hasStation = (image.comment + image.name).contains("station");
      boolean correct = hasStation == contestant.stationSpotted(image.image);
      if (correct)
        score += 1.0;
    }
    return score;
  }

  public ImageSet getImages() {
    return images;
  }
}