/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e05;

import prophecy.common.image.BWImage;
import prophecy.common.image.ImageProcessing;
import static prophecy.common.image.ImageProcessing.brighten;
import prophecy.common.image.RGBImage;

public class VDiff extends StationPartSpotter {
  FloatSplitter splitter = new FloatSplitter();

  public void train(RGBImage clip, boolean isStationPart) {
    float brightness = getBrightness(clip);
    //System.out.println("isStation: " + isStationPart + ", brightness: " + brightness);
    splitter.train(brightness, isStationPart);
  }

  private float getBrightness(RGBImage clip) {
    BWImage vd = preprocessImage(clip);
    return (float) vd.averageBrightness();
  }

  protected BWImage preprocessImage(RGBImage clip) {
    return brighten(ImageProcessing.vdiff(clip), 10);
  }

  public FuzzyBool isStationPart(RGBImage clip) {
    float brightness = getBrightness(clip);
    return new FuzzyBool(splitter.isYin(brightness));
  }
}