/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e07;

import drjava.util.Function;

import java.util.ArrayList;
import java.util.List;

public class FunctionUtil {
  public static <A, B> Function<List<A>, List<B>> liftForLists(final Function<A, B> f) {
    return new Function<List<A>, List<B>>() {
      public List<B> get(List<A> list) {
        ArrayList<B> result = new ArrayList<B>();
        for (A a : list)
          result.add(f.get(a));
        return result;
      }
    };
  }
}