/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e07;

import drjava.util.Function;
import prophecy.common.image.BWImage;
import prophecy.common.image.ImageProcessing;
import static prophecy.common.image.ImageProcessing.brighten;
import prophecy.common.image.RGBImage;

public class Preprocessing implements Function<TrainingItem, PreprocessedItem>, RGBtoBWPreprocessing {
  public PreprocessedItem get(TrainingItem trainingItem) {
    return new PreprocessedItem(preprocessImage(trainingItem.clip), trainingItem.stationPart);
  }

  public BWImage preprocessImage(RGBImage clip) {
    return brighten(ImageProcessing.vdiff(clip), 10);
  }
}