/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e07;

import drjava.util.Factory;
import prophecy.common.image.BWImage;
import prophecy.e.e01.Analyzer;
import prophecy.e.e01.WatcherPool;
import prophecy.e.e06.BWImageMetric;
import prophecy.e.e06.ClipAnalyzer;

import java.util.List;

public class Stage1 {
  private WatcherPool<BWImage, BWImage> makeWatcherPool() {
    WatcherPool<BWImage, BWImage> pool = new WatcherPool<BWImage, BWImage>(new Factory<Analyzer<BWImage, BWImage>>() {
      public Analyzer<BWImage, BWImage> make() {
        return new ClipAnalyzer();
      }
    }, new BWImageMetric());
    pool.setSpawnThreshold(0.25);
    return pool;
  }

  public Prototypes<BWImage> getPrototypes(List<PreprocessedItem> items, boolean stationPart) {
    WatcherPool<BWImage, BWImage> watcherPool = makeWatcherPool();
    for (PreprocessedItem item : items) {
      if (item.stationPart == stationPart)
        for (BWImage miniclip : item.getMiniClips()) {
          watcherPool.processData(miniclip);
      }
    }

    return new Prototypes<BWImage>(watcherPool.getResults(), new BWImageMetric());
  }
}