/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e07;

import drjava.util.MultiSet;
import prophecy.common.image.BWImage;
import prophecy.e.e01.Stats;

import java.util.ArrayList;
import java.util.List;

public class Stage2 {
  private Prototypes<BWImage> miniclipPrototypes;

  public Stage2(Prototypes<BWImage> miniclipPrototypes) {
    this.miniclipPrototypes = miniclipPrototypes;
  }

  public List<Stats<Integer>> getDistributions(List<PreprocessedItem> items) {
    List<Stats<Integer>> result = new ArrayList<Stats<Integer>>();
    for (PreprocessedItem item : items) {
      Stats<Integer> stats = getDistribution(item);
      result.add(stats);
    }
    return result;
  }

  public Stats<Integer> getDistribution(PreprocessedItem item) {
    MultiSet<Integer> multiSet = new MultiSet<Integer>();
    for (BWImage miniclip : item.getMiniClips()) {
      multiSet.add(miniclipPrototypes.getClosestMatch(miniclip));
    }
    Stats<Integer> stats = new Stats<Integer>(multiSet);
    return stats;
  }
}