/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e08;

import prophecy.common.image.RGBImage;
import prophecy.e.e05.FuzzyBool;
import prophecy.e.e05.StationPartSpotter;

public class CombineTwo extends StationPartSpotter {
  private StationPartSpotter spotter1;
  private StationPartSpotter spotter2;

  public CombineTwo(StationPartSpotter spotter1, StationPartSpotter spotter2) {
    this.spotter1 = spotter1;
    this.spotter2 = spotter2;
  }

  public FuzzyBool isStationPart(RGBImage clip) {
    FuzzyBool bool1 = spotter1.isStationPart(clip);
    FuzzyBool bool2 = spotter2.isStationPart(clip);
    //return new FuzzyBool(bool1.getValue() + bool2.getValue() - 0.5f);
    return new FuzzyBool(bool1.getValue() * bool2.getValue());
  }

  public void train(RGBImage clip, boolean isStationPart) {
    spotter1.train(clip, isStationPart);
    spotter2.train(clip, isStationPart);
  }

  public void trainingDone() {
    spotter1.trainingDone();
    spotter2.trainingDone();
  }
}