/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e08;

import prophecy.common.SurfaceUtil;
import prophecy.e.e04.SpotTheStation;
import prophecy.e.e05.SpotStationParts;
import prophecy.e.e05.StationPartSpotter;
import prophecy.e.e07.VDiff3;

import java.io.IOException;

public class Experiment8 {
  private SpotStationParts partContest;

  public Experiment8() throws IOException {
    StationPartSpotter partSpotter = makePartSpotter();

    SpotTheStation contest = new SpotTheStation();
    contest.getImages().getImages().remove(contest.getImages().size()-1); //what a pretty little hack!

    contest.setRounds(1);
    ByClips spotter = new ByClips(partSpotter, partContest.getClipSize());
    contest.addContestant(spotter);
    contest.run();
    SurfaceUtil.show(partSpotter.toString(), spotter.getSurface());
  }

  private StationPartSpotter makePartSpotter() throws IOException {
    partContest = new SpotStationParts();
    StationPartSpotter partSpotter;
    //partSpotter = new VDiff();
    //partSpotter = new VDiff2();
    //partSpotter = new HDiff3();
    //partSpotter = new HDiff();
    partSpotter = new CombineTwo(new HDiff3(), new VDiff3());
    partContest.addContestant(partSpotter);
    /*partContest.setRounds(1);
    partContest.run();*/
    partContest.training();
    return partSpotter;
  }

  public static void main(String[] args) throws IOException {
    new Experiment8();
  }
}