/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e09;

import prophecy.common.Contest;
import prophecy.common.Trainer;

import java.io.IOException;
import java.util.List;

public class SpotTheBall extends Contest<ObjectSpotter> {
  private List<TrainingImage> trainingImages, contestImages;

  public SpotTheBall() throws IOException {
    super(ObjectSpotter.class);
    trainingImages = BallTrainingImages.get().getTrainingImages();
    contestImages = BallTrainingImages.get().getContestImages();

    setTrainer(new Trainer<ObjectSpotter>() {
      public void train(ObjectSpotter contestant) {
        contestant.train(trainingImages);
      }
    });
  }

  public double evaluate(ObjectSpotter contestant) {
    int score = 0;
    for (TrainingImage image : contestImages) {
      if (image.containsObject == contestant.objectSpotted(image.image).asBoolean())
        ++score;
    }
    return score;
  }
}