/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e09;

import drjava.util.ToTree;
import drjava.util.Tree;
import prophecy.common.image.RGBImage;

import java.awt.*;

public class TrainingImage implements ToTree {
  public final RGBImage image;
  public final boolean containsObject;
  public final Rectangle rectangle;

  public TrainingImage(RGBImage image, boolean containsObject, Rectangle rectangle) {
    this.image = image;
    this.containsObject = containsObject;
    this.rectangle = rectangle;
  }

  public Tree toTree() {
    return new Tree(getClass())
      .add("image", image)
      .add("containsObject", containsObject)
      .add("rectangle", rectangle);
  }
}