/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e10;

import drjava.util.StdOutDisplay;
import prophecy.common.SubsetTI;
import prophecy.common.image.RGBImage;
import prophecy.e.e05.FloatSplitter;

import java.util.List;

public class Contestant1 implements E10Contestant {
  FloatSplitter splitter = new FloatSplitter();

  public void train(List<SubsetTI<RGBImage>> trainingData) {
    for (SubsetTI<RGBImage> item : trainingData) {
      splitter.train(processImage(item.example), item.inSet);
    }
  }

  private float processImage(RGBImage image) {
    return (float) image.toBW().averageBrightness();
  }

  public void dump() {
    splitter.display(new StdOutDisplay());
  }

  public boolean contains(RGBImage image) {
    return splitter.isYin(processImage(image));
  }
}