/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e10;

import drjava.util.ToTree;
import drjava.util.Tree;
import prophecy.common.image.RGBImage;
import static prophecy.e.e10.VerbalizerUtil.tenSections;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class StandardVerbalizer implements ImageVerbalizer, ToTree {
  public Collection<String> imageToWords(RGBImage image) {
    List<String> words = new ArrayList<String>();
    words.add(tenSections("brightness", image.toBW().averageBrightness()));
    words.add(tenSections("red", image.redChannel().averageBrightness()));
    words.add(tenSections("green", image.greenChannel().averageBrightness()));
    words.add(tenSections("blue", image.blueChannel().averageBrightness()));
    return words;
  }

  public Tree toTree() {
    return new Tree(getClass());
  }
}