/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e10;

import java.util.Collection;
import java.util.Collections;

public class VerbalizerUtil {
  public static Collection<String> threeSections(String prefix, float v) {
    String s;
    if (v < 0.3)
      s = "low";
    else if (v > 0.7)
      s = "high";
    else
      s = "mid";
    return Collections.singleton(prefix + "_" + s);
  }

  public static String tenSections(String prefix, double v) {
    return prefix + "_" + (int) (zeroToOne(v)*10);
  }

  private static double zeroToOne(double v) {
    return Math.max(0, Math.min(1, v));
  }

  public static Collection<String> sections(String prefix, double v, int sections) {
    return Collections.singleton(prefix + "_" + (int) (zeroToOne(v)*sections));
  }
}