/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e11;

import prophecy.common.Surface;
import prophecy.common.image.RGBImage;

import java.awt.*;

public class BallLocatorSurface extends Surface {
  private RGBImage image;
  private final BallLocator ballLocator;

  public BallLocatorSurface(RGBImage image, BallLocator ballLocator) {
    this.image = image;
    this.ballLocator = ballLocator;
  }

  public void render(int width, int height, Graphics2D g2) {
    g2.drawImage(image.getBufferedImage(), 0, 0, null);
    Point p = ballLocator.locateBall(image);
    if (p != null) {
      g2.setColor(Color.yellow);
      g2.fillRect(p.x-4, p.y-4, 8, 8);
    }
  }

  public void setImage(RGBImage image) {
    this.image = image;
  }
}