/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e11;

import drjava.util.StdOutDisplay;
import prophecy.common.InspectionUtil;
import prophecy.common.Subset;
import prophecy.common.Surface;
import prophecy.common.image.RGBImage;
import prophecy.e.e10.E10;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class E11 {
  public static void main(String[] args) {
    Subset<RGBImage> clipAnalyzer = E10.getBestClipAnalyzer();
    run(clipAnalyzer);
  }

  public static void run(Subset<RGBImage> clipAnalyzer) {
    LocateTheBall contest = new LocateTheBall();

    for (int i = 1; i < 10; i++)
      contest.addContestant(new BallLocator1(clipAnalyzer, i*0.002));

    contest.run();
    inspect(contest);
  }

  private static void inspect(LocateTheBall contest) {
    BallLocator winner = contest.getWinner();
    System.out.println("Winner:");
    StdOutDisplay.get().put(winner).vspace();
    List<Surface> surfaces = new ArrayList<Surface>();
    for (int i = 0; i < contest.getContestImages().size(); i++) {
      surfaces.add(contest.getSurface(i, winner));
    }
    InspectionUtil.inspect(surfaces);
  }

  public static BallLocator getBestBallLocator() throws IOException {
    return new BallLocator1(E10.getBestClipAnalyzer(), 0.008);
  }
}