/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e12;

import drjava.util.ToTree;
import drjava.util.Tree;
import prophecy.common.image.RGBImage;
import prophecy.e.e09.ColorCube;
import prophecy.e.e10.ImageVerbalizer;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class ColorCubeVerbalizer implements ImageVerbalizer, ToTree {
  private final int graininess;

  public ColorCubeVerbalizer(int graininess) {
    this.graininess = graininess;
  }

  public Collection<String> imageToWords(RGBImage image) {
    List<String> words = new ArrayList<String>();
    ColorCube cube = new ColorCube(graininess);
    cube.addPixels(image);
    int[] dom = cube.getDominantCell();
    if (dom != null)
      words.add("cube_" + dom[0] + "_" + dom[1] + "_" + dom[2]);
    return words;
  }

  public String toString() {
    return "ColorCube_" + graininess;
  }

  public Tree toTree() {
    return new Tree(getClass()).add("graininess", graininess);
  }
}