/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e12;

import prophecy.common.BayesParams;
import prophecy.e.e10.BayesContestant;
import prophecy.e.e10.E10;
import prophecy.e.e10.ImageVerbalizer;

import java.io.IOException;
import java.util.Arrays;

/** new contestants for E10 (SpotBallParts) */
public class E12 {
  public static void main(String[] args) throws IOException {
    E10 e10 = new E10() {
      protected void makeContestants() {
        addContestant(makeChampion());
        addContestant(new FeatureContestant(new ImageFeatureSet(new HDiff())));
        addContestant(new FeatureContestant(new ImageFeatureSet(new HDiff(), new VDiff())));
        addContestant(new FeatureContestant(new ImageFeatureSet(
          /*new Brightness(),*/ new Red(), new Green(), new Blue())));
        addContestant(new FeatureContestant(new ImageFeatureSet(
          new Brightness(), new Red(), new Green(), new Blue())));
        addContestant(new FeatureContestant(new ImageFeatureSet(
          new Brightness(), new Red(), new Green(), new Blue(), new HDiff(), new VDiff())));

        addContestant(new BayesContestant(new BayesParams(0.1), 0,
          Arrays.<ImageVerbalizer> asList(new ColorCubeVerbalizer(3))));
      }
    };
    e10.runContest();
    e10.inspect();
  }
}