/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e12;

import drjava.util.StdOutDisplay;
import prophecy.common.SubsetTI;
import prophecy.common.image.RGBImage;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class FeatureSetAdjuster {
  public static ImageFeatureSet adjust(ImageFeatureSet featureSet, Collection<SubsetTI<RGBImage>> trainingItems) {
    List<RangedFeature> adjustedFeatures = new ArrayList<RangedFeature>();
    for (ImageFeature feature : featureSet.getFeatures()) {
      adjustedFeatures.add(new RangedFeature(feature));
    }
    for (SubsetTI<RGBImage> trainingItem : trainingItems) {
      for (RangedFeature feature : adjustedFeatures) {
        feature.processImage(trainingItem.example);
      }
    }

    ImageFeatureSet adjustedFeatureSet = new ImageFeatureSet();
    for (RangedFeature feature : adjustedFeatures) {
      StdOutDisplay.get().put(feature.feature).put(": ").putnl(feature.range);
      adjustedFeatureSet.add(feature.getAdjustedFeature());
    }

    return adjustedFeatureSet;
  }
}