/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e12;

import prophecy.common.image.RGBImage;
import prophecy.e.e10.ImageVerbalizer;
import prophecy.e.e10.VerbalizerUtil;

import java.util.ArrayList;
import java.util.Collection;

public class FeatureSetVerbalizer implements ImageVerbalizer {
  private ImageFeatureSet featureSet;

  public FeatureSetVerbalizer(ImageFeatureSet featureSet) {
    this.featureSet = featureSet;
  }

  public Collection<String> imageToWords(RGBImage image) {
    Collection<String> words = new ArrayList<String>();
    for (ImageFeature feature : featureSet.getFeatures()) {
      words.add(VerbalizerUtil.tenSections(feature.getName(), feature.extract(image)));
    }
    return words;
  }
}