/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e12;

public class Range {
  float min = Float.NaN, max = Float.NaN;

  public Range() {
  }

  public Range(float min, float max) {
    this.max = max;
    this.min = min;
  }

  public void addExample(float example) {
    if (Double.isNaN(min) || example < min)
      min = example;
    if (Double.isNaN(max) || example > max)
      max = example;
  }

  public static void main(String[] args) {
    Range range = new Range();
    range.addExample(5);
    System.out.println(range);
  }

  public String toString() {
    return "(" + min + ", " + max + ")";
  }

  public float scaleTo(Range range, float value) {
    return range.min+(value-min)/(max-min)*(range.max-range.min);
  }
}