/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e12;

import prophecy.common.image.RGBImage;

public class RangedFeature {
  public final ImageFeature feature;
  public final Range range = new Range();

  public RangedFeature(ImageFeature feature) {
    this.feature = feature;
  }

  public void processImage(RGBImage image) {
    float value = feature.extract(image);
    range.addExample(value);
  }

  public ImageFeature getAdjustedFeature() {
    return new ImageFeature(feature.getName()) {
      public float extract(RGBImage image) {
        return range.scaleTo(new Range(0, 1), feature.extract(image));
      }
    };
  }
}