/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e13;

import prophecy.e.e10.E10Contestant;
import prophecy.e.e12.FeatureContestant;
import prophecy.e.e12.ImageFeature;
import prophecy.e.e12.ImageFeatureSet;
import prophecy.common.Generator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class G1 implements Generator<E10Contestant> {
  private List<ImageFeature> features = new ArrayList<ImageFeature>();
  private int counter;

  public void addFeatures(Collection<ImageFeature> features) {
    this.features.addAll(features);
    if (this.features.size() > 63)
      throw new RuntimeException("Too many features");
  }

  public long getTotal() {
    return (1L << features.size())-1;
  }

  public E10Contestant next() {
    if (counter >= getTotal())
      return null;
    ++counter;
    List<ImageFeature> selectedFeatures = new ArrayList<ImageFeature>();
    for (int i = 0; i < features.size(); i++)
      if ((counter & (1L << i)) != 0)
        selectedFeatures.add(features.get(i));
    return new FeatureContestant(new ImageFeatureSet(selectedFeatures));
  }
}