/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e13;

import drjava.util.GUIUtil;
import jazz.retroui.Box;
import jazz.retroui.FancyScreen;
import jazz.retroui.RetroUIFrame;

import javax.swing.*;

public class RetroProgressMonitor {
  private RetroUIFrame frame;

  public RetroProgressMonitor(String task) {
    frame = new RetroUIFrame(task, 80, 25);
    FancyScreen screen = new FancyScreen(frame.getScreen());
    Box box = new Box(screen, screen.centeredRect(task.length() + 4, 5));
    box.drawBorder();
    box.innerScreen().print(1, 1, task);
    GUIUtil.showFrame(frame);
  }

  public void close() {
    frame.dispose();
  }

  public void exitOnClose() {
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  }
}