/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e13;

import prophecy.common.SubsetTI;
import prophecy.common.image.RGBImage;
import prophecy.e.e09.BallTrainingImages;
import prophecy.e.e10.E10Contestant;
import prophecy.e.e10.SpotBallParts;

import java.util.List;

public class SBPWithTraining {
  private List<SubsetTI<RGBImage>> trainingData
    = new SpotBallParts(BallTrainingImages.get().getTrainingImages()).getContestData();

  public SpotBallParts trainAndRunContest(E10Contestant contestant) {
    train(contestant);
    SpotBallParts contest = new SpotBallParts(BallTrainingImages.get().getContestImages());
    contest.addContestant(contestant);
    contest.run();
    return contest;
  }

  public void train(E10Contestant contestant) {
    contestant.train(trainingData);
  }
}