/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e14;

import drjava.util.ObjectUtil;
import drjava.util.ToTree;
import drjava.util.Tree;
import drjava.util.TreeUtil;
import prophecy.common.Subset;
import prophecy.common.image.RGBImage;
import prophecy.e.e10.E10Contestant;

public class CorrectFalsePositives implements Subset<RGBImage>, ToTree {
  private E10Contestant baseAnalyzer;
  private Subset<RGBImage> corrector;

  public CorrectFalsePositives(E10Contestant baseAnalyzer, Subset<RGBImage> corrector) {
    this.baseAnalyzer = baseAnalyzer;
    this.corrector = corrector;
  }

  public boolean contains(RGBImage rgbImage) {
    return baseAnalyzer.contains(rgbImage) && !corrector.contains(rgbImage);
  }

  public String toString() {
    return "CorrectFalsePositives " + ObjectUtil.toNiceString(baseAnalyzer) + " " + ObjectUtil.toNiceString(corrector);
  }

  public Tree toTree() {
    return new Tree(getClass())
      .add("baseAnalyzer", TreeUtil.objectToTree(baseAnalyzer))
      .add("corrector", TreeUtil.objectToTree(corrector));
  }
}