/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e14;

import prophecy.common.Subset;
import prophecy.common.SubsetContest;
import prophecy.common.SubsetTI;
import prophecy.common.image.RGBImage;

import java.util.ArrayList;
import java.util.List;

public class FalsePositives extends SubsetContest<RGBImage> {
  private List<RGBImage> positiveExamples = new ArrayList<RGBImage>();
  private List<RGBImage> negativeExamples = new ArrayList<RGBImage>();

  public FalsePositives(Subset<RGBImage> baseAnalyzer, List<SubsetTI<RGBImage>> contestData) {
    for (SubsetTI<RGBImage> item : contestData) {
      if (baseAnalyzer.contains(item.example)) {
        boolean falsePositive = !item.inSet;
        (falsePositive ? positiveExamples : negativeExamples).add(item.example);
      }
    }
    System.out.println(positiveExamples.size() + "/" + negativeExamples.size() + " (total was: " + contestData.size() + ")");
  }

  protected List<RGBImage> getPositiveExamples() {
    return positiveExamples;
  }

  protected List<RGBImage> getNegativeExamples() {
    return negativeExamples;
  }
}