/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e14;

import prophecy.common.SubsetTI;
import prophecy.common.image.RGBImage;
import prophecy.e.e09.BallTrainingImages;
import prophecy.e.e10.E10;
import prophecy.e.e10.E10Contestant;
import prophecy.e.e10.SpotBallParts;
import prophecy.e.e13.SBPWithTraining;

import java.util.List;

public class Pre1 {
  public static void main(String[] args) {
    E10Contestant baseAnalyzer = E10.getBestClipAnalyzer();
    new SBPWithTraining().train(baseAnalyzer);

    SpotBallParts contest = new SpotBallParts(BallTrainingImages.get().getContestImages());
    List<SubsetTI<RGBImage>> contestData = contest.getContestData();

    int falsePositives = 0;
    for (SubsetTI<RGBImage> item : contestData) {
      if (!item.inSet && baseAnalyzer.contains(item.example))
        ++falsePositives;
    }
    System.out.println("false positives: " + falsePositives);
  }
}