/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e15;

import drjava.util.ToTree;
import prophecy.common.Contest;
import prophecy.common.SubsetTI;
import prophecy.common.Trainer;
import prophecy.common.image.RGBImage;
import prophecy.e.e10.E10;
import prophecy.e.e10.E10Contestant;
import prophecy.e.e10.SpotBallParts;

import java.util.List;

public class E15Contest extends Contest<E10Contestant> implements ToTree {
  SpotBallParts realContest;

  public E15Contest() {
    super(E10Contestant.class);
  }

  protected void init() {
    final E10 e10 = new E10();
    realContest = new SpotBallParts(e10.getContestImages());
    setTrainer(new Trainer<E10Contestant>() {
      public void train(E10Contestant contestant) {
        List<SubsetTI<RGBImage>> trainingData = e10.getTrainingData();
        contestant.train(trainingData);
      }
    }, false);
  }

  public double evaluate(E10Contestant contestant) {
    return realContest.evaluate(contestant);
  }

  public Double getBestPossibleScore() {
    return realContest.getBestPossibleScore();
  }

  public Double getWorstPossibleScore() {
    return realContest.getWorstPossibleScore();
  }
}