/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e15;

import drjava.util.ToTree;
import drjava.util.Tree;
import prophecy.common.SubsetTI;
import prophecy.common.Trainable;
import prophecy.common.Trainer;

import java.util.List;

public class SubsetTrainer<A> implements Trainer<Trainable<SubsetTI<A>>>, ToTree {
  private final List<SubsetTI<A>> trainingData;

  public SubsetTrainer(List<SubsetTI<A>> trainingData) {
    this.trainingData = trainingData;
  }

  public void train(Trainable<SubsetTI<A>> trainable) {
    trainable.train(trainingData);
  }

  public Tree toTree() {
    return new Tree(getClass())
      .add("trainingData", trainingData);
  }

  public SubsetTrainer(Tree tree) {
    trainingData = tree.getObject("trainingData");
  }
}