/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe01;

import drjava.util.MultiCoreUtil;
import liburbi.call.UCallbackListener;
import liburbi.call.URBIEvent;
import prophecy.common.Flag;

public class ConnectionCheck {
  private Aibo aibo;
  private int seconds = 5;
  private volatile boolean pingReceived;
  private volatile boolean running;
  private Flag connectionLostFlag = new Flag();

  public ConnectionCheck(Aibo aibo) {
    this.aibo = aibo;
  }

  public void start() {
    running = true;
    aibo.setCallback(new UCallbackListener() {
      public void actionPerformed(URBIEvent event) {
        pingReceived = true;
      }
    }, "idle");
    aibo.send("every (" + seconds + "s) idle: 1;");
    new Thread() {
      public void run() {
        while (running) {
          pingReceived = false;
          MultiCoreUtil.sleep((int) (seconds*1.5*1000));
          if (!pingReceived) {
            connectionLostFlag.raise();
            break;
          }
        }
      }
    }.start();
  }

  public Flag getConnectionLostFlag() {
    return connectionLostFlag;
  }
}