/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe01;

public class Head {
  private Aibo aibo;

  public Head(Aibo aibo) {
    this.aibo = aibo;
  }

  public void normalPosition() {
    aibo.send("stop head; " + normalPositionCmd() + ";");
  }

  public static String normalPositionCmd() {
    return "headTilt=15 accel: 20 & neck=-16 accel: 20 & headPan = 0 accel: 20";
  }

  public void normalYPosition() {
    aibo.send("stop head; headTilt=15 accel: 20 & neck=-16 accel: 20;");
  }

  public void randomMovement(int delay) {
    aibo.send("head: { loop { wait(random(1000)*" + delay + "); " +
      "headPan'n = headPan'n + ((random(200)-100)/200) accel: 1; } },");
  }

  public void stopMovement() {
    aibo.send("stop head;");
  }

  public void moveRelN(double pan, double tilt) {
    aibo.send("headTilt'n=headTilt'n+" + tilt + " & headPan'n=headPan'n+" + pan + ";");
  }

  public void panRelN(double pan, int accel) {
    String cmd = "headPan'n = headPan'n + (" + pan + ") accel: " + accel + ", ";
    aibo.send(cmd);
  }
}