/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe02;

import static drjava.util.MultiCoreUtil.sleep;
import prophecy.common.sound.Sound;
import prophecy.joe.joe01.Aibo;

public class TestSound {
  public static void main(String[] args) {
    Aibo aibo = new Aibo();
    SoundIn soundIn = new SoundIn(aibo);
    final RotatingSoundBuffer buffer = new RotatingSoundBuffer(5.0);
    soundIn.addListener(buffer);
    buffer.addListener(new SoundListener() {
      public void soundReceived(Sound sound) {
        System.out.println("Sound received");
      }
    });

    MusicDetector musicDetector = new MusicDetector(soundIn);
    musicDetector.setSaveChunks(true);
    musicDetector.addListener(new BPMListener() {
      public void bpmDetected(double bpm) {
        System.out.println("bpm: " + bpm);
      }
    });

    soundIn.startCapture();
    long startTime = System.currentTimeMillis();
    while (System.currentTimeMillis() < startTime + 60000) {
      musicDetector.work();
      sleep(100);
    }
    soundIn.stopCapture();
  }
}