/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe03;

import static drjava.util.MultiCoreUtil.sleep;
import static prophecy.common.InspectionUtil.inspect;
import prophecy.common.image.RGBImage;
import prophecy.joe.joe01.Aibo;

import java.util.ArrayList;
import java.util.List;

public class TestCamera {
  public static void main(String[] args) {
    Aibo aibo = new Aibo();
    Camera camera = new Camera(aibo);
    final List<RGBImage> images = new ArrayList<RGBImage>();
    camera.addCameraListener(new CameraListener() {
      long startTime = System.currentTimeMillis();

      public void imageReceived(RGBImage image) {
        images.add(image);
        int imagesPerSecond = (int) (images.size()*1000/(System.currentTimeMillis()-startTime));
        System.out.println(imagesPerSecond + " images/s, brightness=" + image.toBW().averageBrightness());
      }

      public void speedChanged() {
      }
    });
    camera.startCapture(1);

    sleep(30000);
    camera.stopCapture();

    inspect(images);
  }
}