/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe04;

import prophecy.joe.joe01.Aibo;

public abstract class Action {
  private boolean started;
  protected Aibo aibo;

  public boolean isStarted() {
    return started;
  }

  public Aibo getAibo() {
    return aibo;
  }

  public void setAibo(Aibo aibo) {
    this.aibo = aibo;
  }

  public final void start() {
    started = true;
    onStart();
  }

  protected void onStart() {
  }

  public final void stop() {
    started = false;
    onStop();
  }

  protected void onStop() {
  }
}