/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe05;

public class Joe05 extends WakeSleep {
  private PlayJoe playJoe;
  private IdleJoe idleJoe;

  public Joe05() {
    final Aibo05 aibo = new Aibo05();
    idleJoe = new IdleJoe(aibo);
    playJoe = new PlayJoe(aibo);

    aibo.getHead().normalPosition();

    addListener(new WakeSleepListener() {
      public void onWakeUp() {
        idleJoe.wakeUp();
      }

      public void onSleep() {
        idleJoe.sleep();
        playJoe.sleep();
        aibo.getHead().normalPosition();
      }
    });
  }
}