/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe05;

import prophecy.common.Visualizable;

import javax.swing.*;
import java.util.ArrayList;
import java.util.List;

public class WakeSleep implements Visualizable {
  private boolean awake;
  private List<WakeSleepListener> listeners = new ArrayList<WakeSleepListener>();

  public void addListener(WakeSleepListener listener) {
    listeners.add(listener);
  }

  public boolean isAwake() {
    return awake;
  }

  public final void wakeUp() {
    if (!awake) {
      awake = true;
      for (WakeSleepListener listener : listeners) listener.onWakeUp();
    }
  }

  public final void sleep() {
    if (awake) {
      awake = false;
      for (WakeSleepListener listener : listeners) listener.onSleep();
    }
  }

  public JComponent visualize() {
    return new WakeSleepUI(this);
  }

  public boolean isAsleep() {
    return !awake;
  }
}