/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe05;

import drjava.util.LetterLayout;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class WakeSleepUI extends JPanel {
  private JButton btnWake;
  private JButton btnSleep;
  private WakeSleep wakeSleep;

  public WakeSleepUI(final WakeSleep wakeSleep) {
    this.wakeSleep = wakeSleep;
    setLayout(LetterLayout.stalactite().setSpacing(10).setBorder(10));
    btnWake = new JButton("Wake up");
    btnSleep = new JButton("Sleep");
    update();
    btnWake.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        wakeSleep.wakeUp();
      }
    });
    btnSleep.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        wakeSleep.sleep();
      }
    });
    add(btnWake);
    add(btnSleep);
    wakeSleep.addListener(new WakeSleepListener() {
      public void onWakeUp() {
        update();
      }

      public void onSleep() {
        update();
      }
    });
  }

  private void update() {
    btnWake.setEnabled(this.wakeSleep.isAsleep());
    btnSleep.setEnabled(this.wakeSleep.isAwake());
  }
}