/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe06;

import liburbi.UClient;
import prophecy.common.Flag;
import prophecy.common.SurfaceUtil;
import prophecy.common.image.ImageSurface;
import prophecy.common.image.RGBImage;

public class AbstractJoe implements Actions06 {
  protected Aibo06 aibo;
  protected JoeUI ui;
  private Flag shutdownFlag = new Flag();

  public AbstractJoe(final JoeUI ui) {
    this.ui = ui;
    ui.setActions(this);
  }

  public AbstractJoe(final JoeUI ui, UClient client) {
    this(ui);
    aibo = new Aibo06(client);
  }

  public void captureImage() {
    RGBImage rgbImage = aibo.getCamera().getLastImage().get();
    if (rgbImage == null) return;
    SurfaceUtil.show(new ImageSurface(rgbImage));
  }

  public void shutDown() {
    aibo.disconnect();
    shutdownFlag.raise();
  }

  public Flag getShutdownFlag() {
    return shutdownFlag;
  }

  public Flag getConnectionLostFlag() {
    return aibo.getConnectionLostFlag();
  }
}