/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe06;

import drjava.util.StringUtil;
import liburbi.UClient;
import prophecy.joe.joe01.Aibo;
import prophecy.joe.joe01.Head;
import prophecy.joe.joe02.MarySpeech;
import prophecy.joe.joe03.Camera;

import java.util.ArrayList;
import java.util.List;

public class Aibo06 extends Aibo {
  private Head head;
  private Camera camera;
  private MarySpeech speech;

  public Aibo06() {
    init();
  }

  private void init() {
    head = new Head(this);
    camera = new Camera(this);
    head.normalPosition();
  }

  public Aibo06(UClient client) {
    super(client);
    init();
  }

  public Head getHead() {
    return head;
  }

  public synchronized MarySpeech getSpeech() {
    if (speech == null) {
      speech = new MarySpeech(this);
    }
    return speech;
  }

  public Camera getCamera() {
    return camera;
  }

  public String getHealth() {
    List<String> issues = new ArrayList<String>();
    speech.collectIssues(issues);
    return issues.isEmpty() ? "Fine" : StringUtil.join(" / ", issues);
  }

}