/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe06;

import prophecy.joe.joe04.BallListener;
import prophecy.joe.joe04.DetectBall;
import prophecy.joe.joe04.UiHuch;

import java.awt.geom.Point2D;

public class BallTracker {
  private DetectBall detectBall;

  BallTracker(final Aibo06 aibo, final BallTrackerEnvironment environment) {
    detectBall = new DetectBall(aibo.getCamera());
    detectBall.setAibo(aibo);
    detectBall.addListener(new UiHuch(aibo.getSpeech()));
    detectBall.addListener(new BallListener() {
      public void ballAppeared() {
        environment.requestHeadControl();
        environment.requestCameraSpeed(5);
        ballMoved();
      }

      public void ballDisappeared() {
        environment.yieldHeadControl();
        environment.yieldCameraSpeed();
      }

      public void ballMoved() {
        Point2D location = detectBall.getRelativeBallLocation();
        if (location != null)
          aibo.getHead().moveRelN(-(location.getX()-0.5)*0.25, -(location.getY()-0.5)*0.6);
      }
    });
  }

  public void start() {
    detectBall.start();
  }

  public void stop() {
    detectBall.stop();
  }
}