/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe07;

import liburbi.call.UCallbackListener;
import liburbi.call.URBIEvent;
import prophecy.joe.joe01.Aibo;

import java.util.ArrayList;
import java.util.List;

public class BackSensors {
  private Aibo aibo;
  private List<PettingListener> listeners = new ArrayList<PettingListener>();

  public BackSensors(Aibo aibo) {
    this.aibo = aibo;
  }

  public void addListener(PettingListener listener) {
    listeners.add(listener);
  }

  public void watchForPetting() {
    aibo.setCallback(new UCallbackListener() {
      public void actionPerformed(URBIEvent event) {
        for (PettingListener listener : listeners)
          listener.pet(event.getCmd().trim().startsWith("-"));
      }
    }, "pet");
    aibo.send(
      "at (backSensorF > 5) { stop petB; petB: timeout(1s) { waituntil(backSensorM > 5); waituntil(backSensorR > 5); pet: 1 } };" +
      "at (backSensorR > 5) { stop petF; petF: timeout(1s) { waituntil(backSensorM > 5); waituntil(backSensorF > 5); pet: -1 } };");
  }
}