/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe07;

import drjava.util.Randomizer;
import drjava.util.RealRandomizer;
import liburbi.UClient;
import liburbi.call.UCallbackListener;
import liburbi.call.URBIEvent;
import prophecy.joe.joe01.Eyes;
import prophecy.joe.joe01.Head;
import prophecy.joe.joe01.TailListener;
import prophecy.joe.joe01.WagTail;
import prophecy.joe.joe06.AbstractJoe;
import prophecy.joe.joe06.Aibo06;
import prophecy.joe.joe06.JoeUI;

import static java.lang.Math.min;

public class Joe07 extends AbstractJoe {
  private Randomizer randomizer = new RealRandomizer();

  public Joe07(final JoeUI ui, UClient client) {
    super(ui);
    init(client);
  }

  private void init(UClient client) {
    aibo = new Aibo06(client);
    aibo.getConnectionLostFlag().onRaise(new Runnable() {
      public void run() {
        ui.dispose();
      }
    });

    final WagTail tail = new WagTail(aibo);
    final Eyes eyes = new Eyes(aibo);
    eyes.off();
    /*aibo.getSpeech().say("Hi, ich bin Joe 07.");
    aibo.getSpeech().say("Ich mag es, gestreichelt zu werden.");*/
    //aibo.getSpeech().saySable("Hi, ich bin Joe. <break/> Ich <PITCH BASE=\"high\">mag</PITCH> <PITCH BASE=\"highest\">Bier</PITCH>.");
    aibo.getSpeech().saySable("Hi, ich bin Joe 07. <BREAK />" +
      "Ich mag es, gestreichelt zu werden.");
    aibo.getHead().normalPosition();

    BackSensors sensors = new BackSensors(aibo);
    sensors.addListener(new PettingListener() {
      public void pet(boolean forward) {
        tail.setSpeed(min(0.5, tail.getSpeed()+0.03));
        ui.showAction("Being pet");

        if (randomizer.oneIn(60)) {
          String text = "ui";
          while (randomizer.oneIn(2) && text.length() < 100)
            text += "ui";
          aibo.getSpeech().say(text);
        }

        aibo.send(/*"if (ledF1==0 && backSensorF+backSensorM+backSensorR > 0) { "*/
          "if (ledF1==0) {"
          + "stop petEnd; petEnd: { wait(5s); petEnd: 1; mouth.val'n = 1 smooth: 0.5s & " + Head.normalPositionCmd() + "},"
          + eyes.greenOuterCmd("1 smooth:0.5s") + ","
          + "mouth.val'n = 0.3 smooth:0.5s,"
          + "if (random(5)) { shake: headPan'n = 0.5 sin:0.2s ampli:0.02, wait(0.6s); stop shake; },"
          + "r=random(5); if (r == 0) { headTilt=40 smooth:1s & neck=-30 smooth: 1s },"
          + "if (r == 1) { headTilt=-16 smooth:1s & neck=-4 smooth:1s },"
          + "wait(2s);"
          + eyes.greenOuterCmd("0 smooth:1s") + ","
          + "mouth.val'n = 1 smooth:0.5s,"
          //+ "stop head; headPan'n = 0.5 smooth:0.4s"
          + "},");
        /*try {
          aibo.sendSound(Prophecy.dataDir() + "audio/aibosounds/dogpant2.wav");
        } catch (IOException e) {
          Errors.add(e);
        }*/
      }
    });
    aibo.setCallback(new UCallbackListener() {
      public void actionPerformed(URBIEvent event) {
        showIdleAction();
      }
    }, "petEnd");

    tail.addListener(new TailListener() {
      public void wagging() {
        tail.setSpeed(tail.getSpeed()-0.04);
        //System.out.println("speed: " + tail.getSpeed());
      }
    });

    ui.showHealth(aibo.getHealth());
    showIdleAction();
    tail.start(0);
    sensors.watchForPetting();
    //sleepForever();
  }

  private void showIdleAction() {
    ui.showAction("Waiting to be pet");
  }

}