/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe08;

import prophecy.common.Flag;

import java.net.Socket;

public class SocketConnector {
  private String ip;
  private int port;
  private Flag timeoutFlag = new Flag();
  private Flag successFlag = new Flag();
  private SocketConnectListener listener;

  public SocketConnector(String ip, int port) {
    this.ip = ip;
    this.port = port;
  }

  public void check() {
    new Thread() {
      public void run() {
        testConnectionImpl();
      }
    }.start();
  }

  private void raiseTimeout() {
    timeoutFlag.raise();
    if (!successFlag.isUp())
      timeout();
  }

  private void timeout() {
    if (listener != null)
      listener.timeout();
  }

  private void testConnectionImpl() {
    try {
      Socket socket = new Socket(ip, port);
      successFlag.raise();
      if (!timeoutFlag.isUp())
        success(socket);
    } catch (Throwable e) {
      raiseTimeout();
    }
  }

  private void success(Socket socket) {
    if (listener != null)
      listener.success(socket);
  }

  public SocketConnectListener getListener() {
    return listener;
  }

  public void setListener(SocketConnectListener listener) {
    this.listener = listener;
  }
}