/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe08;

import drjava.util.MultiCoreUtil;
import liburbi.UClient;
import prophecy.common.Flag;
import prophecy.joe.joe01.UrbiUtil;

public class UrbiConnector {
  private String ip;
  private int timeoutSeconds = 5;
  private Flag timeoutFlag = new Flag();
  private Flag successFlag = new Flag();
  private UrbiConnectEscape listener;

  public UrbiConnector(String ip) {
    this.ip = ip;
  }

  public void check() {
    new Thread() {
      public void run() {
        testConnectionImpl();
      }
    }.start();
    new Thread() {
      public void run() {
        MultiCoreUtil.sleep(timeoutSeconds *1000);
        timeoutFlag.raise();
        if (!successFlag.isUp())
          timeout();
      }
    }.start();
  }

  private void timeout() {
    if (listener != null)
      listener.timeout();
  }

  private void testConnectionImpl() {
    final UClient client = UrbiUtil.connect(successFlag, ip);
    successFlag.onRaise(new Runnable() {
      public void run() {
        if (!timeoutFlag.isUp())
          success(client);
      }
    });
  }

  private void success(UClient client) {
    if (listener != null)
      listener.success(client);
  }

  public int getTimeoutSeconds() {
    return timeoutSeconds;
  }

  public void setTimeoutSeconds(int timeoutSeconds) {
    this.timeoutSeconds = timeoutSeconds;
  }

  public UrbiConnectEscape getListener() {
    return listener;
  }

  public void setListener(UrbiConnectEscape listener) {
    this.listener = listener;
  }
}