/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe09;

import liburbi.UClient;
import prophecy.common.Prophecy;
import prophecy.common.Application;
import prophecy.common.SourceBrowser;
import prophecy.joe.joe02.SoundIn;
import prophecy.joe.joe06.AbstractJoe;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class Joe09 extends AbstractJoe {
  public Joe09(UClient client, Application application) {
    super(new DummyJoeUI(), client);

    SoundIn soundIn = new SoundIn(aibo);

    final Joe09Sheet soundSheet = new Joe09Sheet(soundIn, aibo);
    JFrame frame = soundSheet.asFrame();
    JMenuBar menuBar = new JMenuBar();
    JMenuItem miSources = new JMenuItem("Show sources");
    miSources.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        SourceBrowser sourceBrowser = Prophecy.makeSourceBrowser();
        sourceBrowser.selectPackage(getClass().getPackage().getName());
        sourceBrowser.show();
      }
    });
    menuBar.add(miSources);
    frame.setJMenuBar(menuBar);
    application.showFinalFrame(frame);

    soundIn.startCapture();
  }
}
