/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe09;

import drjava.util.RealRandomizer;
import prophecy.common.sound.Sound;
import prophecy.common.sound.SoundUtil;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class WordCollector {
  private final File dir;
  private List<File> words = new ArrayList<File>();
  private int counter = 1;

  public WordCollector(String dir) {
    this.dir = new File(dir);
    File file;
    while ((file = makeFile()).exists()) {
      words.add(file);
      ++counter;
    }
  }

  private File makeFile() {
    dir.mkdirs();
    return new File(dir, counter + ".wav");
  }

  public int size() {
    return words.size();
  }

  public void addWord(Sound sound) {
    File file = makeFile();
    ++counter;
    SoundUtil.save(sound, file.getPath());
    words.add(file);
  }

  public File randomWord() {
    return new RealRandomizer().oneOf(words);
  }
}