/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.joe10;

import liburbi.UClient;
import prophecy.joe.joe06.AbstractJoe;
import prophecy.joe.joe06.Aibo06;
import prophecy.joe.joe06.JoeUI;

public class Joe10 extends AbstractJoe {
  public Joe10(final JoeUI ui, UClient client) {
    super(ui);
    init(client);
  }

  private void init(UClient client) {
    aibo = new Aibo06(client);
    aibo.getConnectionLostFlag().onRaise(new Runnable() {
      public void run() {
        ui.dispose();
      }
    });

    new Petting(aibo, new PettingEnvironment() {
      public void setAction(String action) {
        if (action != null)
          ui.showAction(action);
        else
          showIdleAction();
      }
    });

    ui.showHealth(aibo.getHealth());
    showIdleAction();
    //sleepForever();
  }

  private void showIdleAction() {
    ui.showAction("Waiting to be pet");
  }

}