/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.joe.urbitest;

import static drjava.util.MultiCoreUtil.sleep;
import liburbi.UClient;
import liburbi.call.UCallbackListener;
import liburbi.call.URBIEvent;
import prophecy.joe.joe01.UrbiUtil;

import java.io.IOException;
import static java.lang.System.currentTimeMillis;

public class CallbackTest {
  public static void main(String[] args) throws IOException {
    System.out.println("connecting");
    UClient client = new UClient(UrbiUtil.getAiboIP());
    final long start = currentTimeMillis();

    client.setCallback(new UCallbackListener() {
      public void actionPerformed(URBIEvent event) {
        System.out.println((currentTimeMillis()-start) + ": callback received");
      }
    }, "mytag");

    System.out.println((currentTimeMillis()-start) + ": sending cmd");
    client.send("mytag: camera.val;");
    System.out.println((currentTimeMillis()-start) + ": cmd sent");

    sleep(5000);
    client.disconnect();
    System.out.println((currentTimeMillis()-start) + ": disconnected");
  }
}