/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m01;

import drjava.util.Log;
import drjava.util.RealRandomizer;

import java.net.ServerSocket;

public class SocketUtil {
  public static ServerSocket serverSocketAtRandomPort() {
    int tries = 0;
    while (tries++ < 1000) {
      int port = new RealRandomizer().random(1024, 65535);
      try {
        return new ServerSocket(port);
      } catch (Throwable e) {
        Log.info("Can't bind to port " + port + ", trying another one");
      }
    }
    throw new RuntimeException("Could not find free port to bind to (" + tries + " tries)");
  }

  public static ServerSocket serverSocketAtPortAbove(int start) {
    int port = start;
    while (port < 65536) {
      try {
        return new ServerSocket(port);
      } catch (Throwable e) {
        //Log.info("Can't bind to port " + port + ", trying another one");
      }
      ++port;
    }
    throw new RuntimeException("Could not find free port to bind to above " + start);
  }
}