/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m02;

public class BaseWatcher<A> implements Watcher<A> {
  private Model<A> model = emptyModel();

  public NoInput<A> emptyModel() {
    return new NoInput<A>();
  }

  public Model<A> getModel() {
    return model;
  }

  public void feed(A value) {
    model = model.plusExample(value);
  }

  public void describeYourself(Typewriter typewriter, String watchedObjectDesc) {
    getModel().describeYourself(typewriter, watchedObjectDesc);
  }

  public Prediction<A> predict() {
    return getModel().predict();
  }
}