/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m02;

import drjava.util.ObjectUtil;

public class ChangeWatcher<A> {
  Watcher<Boolean> boolWatcher = new SimpleBoolWatcher();
  private boolean hasLastValue;
  private A lastValue;

  public void setBoolWatcher(Watcher<Boolean> boolWatcher) {
    this.boolWatcher = boolWatcher;
  }

  public void feed(A value) {
    if (!hasLastValue) {
      hasLastValue = true;
      lastValue = value;
    } else {
      boolean change = !ObjectUtil.equal(lastValue, value);
      boolWatcher.feed(change);
      lastValue = value;
    }
  }

  public void describeYourself(Typewriter typewriter, String watchedObject) {
    boolWatcher.describeYourself(typewriter,
      watchedObject.length() == 0 ? "change" : "change in " + watchedObject);
  }

  public Prediction<Boolean> predict() {
    return boolWatcher.predict();
  }
}