/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m02;

public class CharsWatcher implements Watcher<String> {
  private StringWatcher[] watchers;

  public CharsWatcher(int length) {
    watchers = new StringWatcher[length];
    for (int i = 0; i < watchers.length; i++)
      watchers[i] = new StringWatcher();
  }

  public void feed(String s) {
    for (int i = 0; i < watchers.length; i++)
      watchers[i].feed(s.substring(i, i+1));
  }

  public void describeYourself(Typewriter typewriter, String watchedObjectDesc) {
    // TODO
  }

  public StringWatcher getCharWatcher(int position) {
    return watchers[position];
  }

  public int getLength() {
    return watchers.length;
  }

  public Prediction<String> predict() {
    StringBuilder stringBuilder = new StringBuilder();
    for (StringWatcher watcher : watchers) {
      Prediction<String> s = watcher.predict();
      stringBuilder.append(s == null || s.getValue().length() == 0 ? " " : s);
    }
    return new Prediction<String>(stringBuilder.toString());
  }
}