/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m02;

public class ImprovedRunlengthWatcher extends CombinedWatcher<Boolean> {
  private SimpleBoolWatcher simpleBoolWatcher = new SimpleBoolWatcher();
  private RunlengthWatcher durationWatcher = new RunlengthWatcher(false);
  private RunlengthWatcher pauseWatcher = new RunlengthWatcher(true);

  public ImprovedRunlengthWatcher() {
    addWatcherBack(simpleBoolWatcher);
    addWatcherBack(durationWatcher);
    addWatcherBack(pauseWatcher);
  }

  public Prediction<Boolean> predict() {
    if (simpleBoolWatcher.getModel().getExamples().size() == 1)
      return simpleBoolWatcher.predict();
    Prediction<Boolean> prediction = durationWatcher.predict();
    if (prediction != null) return prediction;
    return pauseWatcher.predict();
  }
}