/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m02;

public class StringWatcher extends BaseWatcher<String> {
  private IntWatcher lengthWatcher = new IntWatcher();

  public void feed(String value) {
    super.feed(value);
    lengthWatcher.feed(value == null ? 0 : value.length());
  }

  public Model<Integer> getLengthModel() {
    return lengthWatcher.getModel();
  }

  public CharsWatcher makeCharsWatcher() {
    if (!(getLengthModel() instanceof Stable))
      return null;
    int length = ((Stable<Integer>) getLengthModel()).getValue();
    CharsWatcher charsWatcher = new CharsWatcher(length);
    for (String s : getModel().getExamples()) {
      charsWatcher.feed(s);
    }
    return charsWatcher;
  }

  public Prediction<String> predict() {
    return getModel().predict();
  }

  public void describeYourself(Typewriter typewriter, String watchedObjectDesc) {
    super.describeYourself(typewriter, watchedObjectDesc);
    lengthWatcher.describeYourself(typewriter, "String length");
  }
}