/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m03;

import java.util.ArrayList;
import java.util.List;

public class Checklist {
  private List<Check> checks = new ArrayList<Check>();

  public MatchResult fullMatch() {
    boolean match = true;
    for (Check check : checks) {
      if (!check.isSuccess()) {
        match = false;
        break;
      }
    }
    return new MatchResult(/*new MethodCall(this, "fullMatch"),*/ match);
  }

  public static class Check {
    String description;
    boolean success;

    Check(String description, boolean success) {
      this.description = description;
      this.success = success;
    }

    public String getDescription() {
      return description;
    }

    public boolean isSuccess() {
      return success;
    }
  }

  public void addCheck(String description, boolean success) {
    checks.add(new Check(description, success));
  }

  public void addCheck(Check check) {
    checks.add(check);
  }

  public List<Check> getChecks() {
    return checks;
  }
}