/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m03;

import drjava.util.Tree;
import drjava.util.TreePersistable;

import java.util.Date;

public class DateRange implements TreePersistable {
  private Date startDate, endDate;

  public DateRange(Date startDate) {
    this.startDate = startDate;
  }

  public Date getStartDate() {
    return startDate;
  }

  public Date getEndDate() {
    return endDate;
  }

  public void setStartDate(Date startDate) {
    this.startDate = startDate;
  }

  public void setEndDate(Date endDate) {
    this.endDate = endDate;
  }

  public void fromTree(Tree tree) {
    startDate = tree.getObject("startDate");
    endDate = tree.getObject("endDate");
  }

  public Tree toTree() {
    return new Tree(getClass())
      .add("startDate", startDate);
  }
}