/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m03;

import drjava.util.Tree;
import prophecy.m.m02.Model;
import prophecy.m.m02.NoInput;

public class HistoricDiskWatcher implements IHistoricDiskWatcher {
  String rememberedName;
  Long rememberedSize;
  DateRange lifespan;
  Model<Long> freeSpace = new NoInput<Long>();

  public String getRememberedName() {
    return rememberedName;
  }

  public Long getRememberedSize() {
    return rememberedSize;
  }

  public Model<Long> getFreeSpaceModel() {
    return freeSpace;
  }

  public void fromTree(Tree tree) {
    rememberedName = tree.getString("rememberedName");
    rememberedSize = tree.getLong("rememberedSize");
    lifespan = tree.getObject("lifespan");
    freeSpace = tree.getObject("freeSpace");
  }

  public DateRange getLifespan() {
    return lifespan;
  }
}