/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m03;

import drjava.util.GUIUtil;
import prophecy.common.lifeform.Environment;
import prophecy.common.lifeform.Lifeform;

import javax.swing.*;
import java.awt.*;

public class LeaderView extends JPanel {
  private Environment environment;
  private Lifeform leader;
  private JComponent visualization;

  public LeaderView(prophecy.common.lifeform.Environment environment) {
    setLayout(new BorderLayout());
    this.environment = environment;
    if (environment.getLeader() != null) {
      leader = environment.getLeader();
      visualization = leader.visualize();
      if (visualization != null)
        add(BorderLayout.CENTER, GUIUtil.withTitle("Leader View", visualization));
    }
  }

  public JComponent getVisualization() {
    return visualization;
  }
}