/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m03;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;
import java.util.Arrays;

public class ObjectTransferable implements Transferable {
  private Object object;
  private String stringRepresentation;

  public ObjectTransferable(Object object, String stringRepresentation) {
    this.object = object;
    this.stringRepresentation = stringRepresentation;
  }

  public DataFlavor[] getTransferDataFlavors() {
    return new DataFlavor[] {
      localObjectDataFlavor(),
      DataFlavor.stringFlavor
    };
  }

  public static DataFlavor localObjectDataFlavor() {
    try {
      return new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType);
    } catch (ClassNotFoundException e) {
      throw new RuntimeException(e);
    }
  }

  public boolean isDataFlavorSupported(DataFlavor flavor) {
    /*return flavor.getMimeType().equals(DataFlavor.javaJVMLocalObjectMimeType)
      || flavor.equals(DataFlavor.stringFlavor);*/
    return Arrays.asList(getTransferDataFlavors()).contains(flavor);
  }

  public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
    if (flavor.equals(DataFlavor.stringFlavor))
      return stringRepresentation;
    else
      return object;
  }
}