/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m03;

import prophecy.common.lifeform.Lifeform;

public class Praise extends Lifeform {
  private Lifeform beneficiary;
  private String author;
  private String text;

  public Praise(Lifeform beneficiary, String author, String text) {
    this.beneficiary = beneficiary;
    this.author = author;
    this.text = text;
  }

  public Lifeform getBeneficiary() {
    return beneficiary;
  }

  public String getAuthor() {
    return author;
  }

  public String getText() {
    return text;
  }

  public String toString() {
    String s = "Praise for " + beneficiary;
    if (author != null && author.length() != 0)
      s += " from " + author;
    if (text != null && text.length() != 0)
      s += ": \"" + text + "\"";
    return s;
  }
}