/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m03;

import java.io.File;

public class RealDisk implements Disk {
  private File file;

  public RealDisk(String path) {
    file = new File(path);
  }

  public String getName() {
    return file.getPath();
  }

  public long getSize() {
    // call Java 6 method by reflection
    try {
      return (Long) file.getClass().getMethod("getTotalSpace").invoke(file);
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }

  public long getFreeSpace() {
    // call Java 6 method by reflection
    try {
      return (Long) file.getClass().getMethod("getFreeSpace").invoke(file);
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }
}