/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m04;

public class Msg {
  private String sender, text;

  public Msg(String sender, String text) {
    this.sender = sender;
    this.text = text;
  }

  public String getSender() {
    return sender;
  }

  public String getText() {
    return text;
  }

  public String toString() {
    return sender + ": " + text;
  }

  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;

    Msg msg = (Msg) o;

    if (!sender.equals(msg.sender)) return false;
    if (!text.equals(msg.text)) return false;

    return true;
  }

  public int hashCode() {
    int result;
    result = sender.hashCode();
    result = 31 * result + text.hashCode();
    return result;
  }

  public Msg replaceText(String newText) {
    return new Msg(sender, newText);
  }
}