/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m04;

import bsh.Interpreter;
import drjava.util.Errors;
import prophecy.common.SurfaceUtil;
import prophecy.common.lifeform.Environment;
import prophecy.common.lifeform.Lifeform;
import prophecy.common.lifeform.LiveEnvironment;
import prophecy.m.m03.HousePanel;

import java.io.FileReader;

public class ScriptedClock {
  public static Lifeform make() {
    try {
      Object evalResult = new Interpreter().eval(new FileReader("src/prophecy/m/m04/clock.bsh"));
      System.out.println("Result class: " + (evalResult == null ? "null" : evalResult.getClass().getName()));
      return (Lifeform) evalResult;
    } catch (Throwable e) {
      Errors.add(e);
      return null;
    }
  }

  public static void main(String[] args) {
    Environment environment = new LiveEnvironment();
    environment.addInhabitant(make());
    SurfaceUtil.showAsMain("ScriptedClock", new HousePanel(environment));
  }
}