/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m04;

import static drjava.util.ObjectUtil.nice;
import prophecy.common.lifeform.Lifeform;

public class Slot<A> extends Lifeform {
  private Class<A> requiredClass;
  private A occupant;

  public Slot(Class<A> requiredClass) {
    this.requiredClass = requiredClass;
  }

  public A getOccupant() {
    return occupant;
  }

  public void setOccupant(A occupant) {
    if (this.occupant != occupant) {
      log("New occupant: " + nice(occupant));
      this.occupant = occupant;
    }
  }

  public void introduce(Lifeform object) {
    super.introduce(object);
    if (occupant == null && requiredClass.isInstance(object))
      setOccupant((A) object);
  }
}