/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m05;

import java.io.File;

public class FileLF extends Carrier<File> {
  private boolean statsTaken;
  private Long fileSize;
  private boolean isFile;

  public FileLF() {
  }

  public FileLF(File load) {
    super(load);
  }

  public FileLF(String filename) {
    super(new File(filename));
  }

  public void idleImpl() {
    if (getFile() != null && !statsTaken) {
      logActivity("Taking stats");
      statsTaken = true;
      isFile = getFile().isFile();
      fileSize = isFile ? getFile().length() : null;
      setStatus("Stats taken");
    }
  }

  public File getFile() {
    return load;
  }

  public Long getFileSize() {
    return fileSize;
  }

  public boolean isFile() {
    return isFile;
  }

  public String toString() {
    if (getFile() == null)
      return super.toString();
    return "File " + getFile().getPath() + " (isFile: " + isFile + ", size: " + fileSize + ")";
  }
}