/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m05;

import prophecy.common.lifeform.Lifeform;

import java.util.ArrayList;
import java.util.List;

public class Question extends Lifeform implements IQuestion {
  private String question;
  private List<Carrier<String>> answers = new ArrayList<Carrier<String>>();

  public Question(String question) {
    this.question = question;
    updateStatus();
  }

  private void updateStatus() {
    if (answers.isEmpty())
      setStatus("Q: " + question);
    else
      setStatus("Q: " + question + " A: " + answers.get(0).getLoad()
        + (answers.size() == 1 ? ""
        : " [" + (answers.size()-1) + " more]"));
  }

  public String getQuestion() {
    return question;
  }

  public void answer(String answer) {
    logActivity("Saving answer #" + (answers.size() + 1) + ": " + answer);
    answers.add(new Carrier<String>(answer));
    updateStatus();
  }

  public List<Carrier<String>> getAnswers() {
    logActivity("getAnswers (" + answers.size() + ")");
    return answers;
  }
}