/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m05;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class Screenshot {
  public void captureFrame(JFrame frame, String jpegFileName) throws AWTException, IOException {
    BufferedImage image = captureFrame(frame);
    ImageIO.write(image, "jpeg", new File(jpegFileName));
    System.out.println("Saved screen shot (" + image.getWidth() +
      " x " + image.getHeight() + " pixels) to file \"" +
      jpegFileName + "\".");
  }

  public BufferedImage captureFrame(JFrame frame) throws AWTException {
    frame.toFront();
    Rectangle rect = frame.getBounds();
    Robot robot = new Robot();
    return robot.createScreenCapture(rect);
  }
}