/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m07;

import prophecy.common.lifeform.Lifeform;

import java.util.ArrayList;
import java.util.List;

public class Coin extends Lifeform implements ColoredToy {
  private boolean whiteUp;

  public Coin() {
    setWhiteUp(true);
  }

  private void setWhiteUp(boolean whiteUp) {
    this.whiteUp = whiteUp;
    setStatus(whiteUp ? "white" : "black");
  }

  /*public List<Sensor> getSensors() {
    List<Sensor> sensors = new ArrayList<Sensor>();
    sensors.add(new Sensor("side"));
    return sensors;
  }*/

  public Color getColor() {
    return whiteUp ? Color.white : Color.black;
  }

  public List<Action> getActions() {
    List<Action> actions = new ArrayList<Action>();
    actions.add(new Action("flip") {
      public void perform() {
        flip();
      }
    });
    return actions;
  }

  private void flip() {
    setWhiteUp(!whiteUp);
  }
}