/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m08;

import drjava.util.StringUtil;
import prophecy.common.lifeform.Lifeform;

import java.util.ArrayList;
import java.util.List;

public class CompositeLifeform extends Lifeform {
  private List<Lifeform> parts = new ArrayList<Lifeform>();

  public void addPart(Lifeform part) {
    part.setLogger(new MuxLogger(part.getLogger(), getLogger()));
    parts.add(part);
  }

  public List<Lifeform> getParts() {
    return parts;
  }

  public void idleImpl() {
    super.idleImpl();
    for (Lifeform part : parts) {
      part.idle();
    }
  }

  public String getStatus() {
    List<String> stati = new ArrayList<String>();
    for (Lifeform part : parts) {
      stati.add(part.getStatus());
    }
    return StringUtil.join("; ", stati);
  }
}