/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m09;

import static drjava.util.ObjectUtil.nice;
import prophecy.common.lifeform.Activity;
import prophecy.m.m02.BaseWatcher;
import prophecy.m.m02.Model;

import java.util.List;

public class ClassAnalyzer extends Worker {
  private List<Object> list;
  private Model<String> model;

  public ClassAnalyzer(List<Object> list) {
    this.list = list;
    setJobDescription("Analyze element classes");
    setActivity(new Analyze());
  }

  private class Analyze extends Activity {
    protected void runOnce() {
      BaseWatcher<String> watcher = new BaseWatcher<String>();
      for (Object o : list) {
        watcher.feed(o.getClass().getName());
      }
      model = watcher.getModel();
      setStatus(nice(model));
      setJobDone();
      setActivity(null);
    }
  }

  public Model<String> getModel() {
    return model;
  }
}