/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m09;

import drjava.util.SwingTimerHelper;
import prophecy.common.gui.SingleComponentPanel;
import prophecy.m.m02.Report;
import prophecy.m.m02.Typewriter;

public class JReport extends SingleComponentPanel {
  public JReport(final Report report) {
    setComponent(report.asComponent());
  }

  public JReport(final Reporter reporter) {
    setReporter(reporter);
  }

  public JReport() {
  }

  public void setReporter(final Reporter reporter) {
    final Typewriter typewriter = reporter.writeReport();
    setComponent(typewriter.asComponent());
    if (reporter != null)
      new SwingTimerHelper(new Runnable() {
        Typewriter currentTypewriter = typewriter;

        public void run() {
          Typewriter typewriter2 = reporter.writeReport();
          if (!typewriter2.resultEquals(currentTypewriter)) {
            currentTypewriter = typewriter2;
            setComponent(typewriter2.asComponent());
          }
        }
      }, 1000).installOn(this);
  }
}