/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m09;

import prophecy.common.lifeform.Activity;
import prophecy.common.lifeform.Lifeform;

public class Repeat extends Activity {
  private double seconds;
  private Activity activity;
  private long lastIdle;

  public Repeat(double seconds, Activity activity) {
    this.seconds = seconds;
    this.activity = activity;
  }

  protected void idleImpl() throws Exception {
    super.idleImpl();
    if (System.currentTimeMillis() >= lastIdle+seconds*1000) {
      try {
        activity.idle();
      } catch (Throwable e) {
        error(e);
      }
      lastIdle = System.currentTimeMillis();
    }
  }

  public void setLifeform(Lifeform lifeform) {
    super.setLifeform(lifeform);
    activity.setLifeform(lifeform);
  }
}