/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m10;

import drjava.util.Errors;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class IntIdMaker implements IdMaker {
  long maxID;

  public void fileFound(String name) {
    Matcher matcher = Pattern.compile("^\\d+").matcher(name);
    if (matcher.find())
      try {
        maxID = Math.max(maxID, Long.parseLong(matcher.group()));
      } catch (Throwable e) {
        Errors.add(e);
      }
  }

  public String makeID() {
    return String.valueOf(++maxID);
  }
}