/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m11;

import prophecy.common.lifeform.Lifeform;
import prophecy.common.lifeform.Reference;

public class CloneRequest extends Lifeform {
  private Lifeform original;
  private Reference processedBy = new Reference();

  public CloneRequest(Lifeform original) {
    this.original = original;
  }

  public Lifeform getOriginal() {
    return original;
  }

  public Lifeform getProcessedBy() {
    return processedBy.get();
  }

  public void setProcessedBy(Lifeform processor) {
    processedBy.set(processor);
    if (!processedBy.isNobody())
      setStatus("Being processed");
  }
}