/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m11;

import drjava.util.SwingTimerHelper;
import prophecy.common.Surface;
import prophecy.common.lifeform.Lifeform;

import javax.swing.*;
import java.awt.*;

public class StatusView extends Surface {
  private Lifeform lifeform;

  public StatusView(Lifeform lifeform) {
    this.lifeform = lifeform;
    setDoubleBuffered(true);
    new SwingTimerHelper(new Runnable() {
      public void run() {
        repaint();
      }
    }, 500).installOn(this);
  }

  public void render(int w, int h, Graphics2D g) {
    String text = lifeform.getStatus();
    g.setFont(new Font("Arial", Font.PLAIN, 60));
    int y = h/2 - g.getFontMetrics().getHeight()/2 + g.getFontMetrics().getAscent();
    int x = w/2 - g.getFontMetrics().stringWidth(text)/2;
    g.drawString(text, x, y);
  }

  public JFrame asFrame() {
    JFrame frame = new JFrame("Status");
    frame.getContentPane().add(this);
    frame.setSize(600, 300);
    return frame;
  }
}