/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m12;

import drjava.util.TreePersistence;
import prophecy.common.lifeform.Lifeform;

import java.util.List;

public class Counter extends Lifeform implements HasNeeds {
  private TreePersistence persistence;
  private int value;

  public Counter() {
  }

  public void getNeeds(List<Need> list) {
    if (persistence == null)
      list.add(new NeedsMember(this, "persistence", TreePersistence.class));
  }

  public TreePersistence getPersistence() {
    return persistence;
  }

  public void setPersistence(TreePersistence persistence) {
    this.persistence = persistence;
  }

  public int get() {
    return value;
  }

  public void set(int value) {
    this.value = value;
  }

  public void increment() {
    ++value;
  }

  public void increment(int diff) {
    value += diff;
  }
}