/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m12;

import prophecy.common.lifeform.Lifeform;

import java.util.ArrayList;
import java.util.List;

public class NeedFinder extends Lifeform {
  private List<Need> needs = new ArrayList<Need>();

  protected void idleImpl() {
    if (getEnvironment() != null) {
      List<Need> needs = new ArrayList<Need>();
      for (Lifeform lifeform : getEnvironment().getInhabitants()) {
        if (lifeform instanceof HasNeeds) {
          ((HasNeeds) lifeform).getNeeds(needs);
        }
      }
      setNeeds(needs);
    }
  }

  public void setNeeds(List<Need> needs) {
    this.needs = needs;
  }

  public List<Need> getNeeds() {
    return needs;
  }

  public String toString() {
    String s = "RequirementFinder [" + needs.size() + "]";
    if (!needs.isEmpty())
      s += " " + needs.get(0);
    return s;
  }
}