/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m12;

import prophecy.common.lifeform.Lifeform;

public class NeedsMember extends Need {
  private Lifeform lifeform;
  private String fieldName;
  private Class memberClass;

  public NeedsMember(Lifeform lifeform, String fieldName, Class memberClass) {
    this.lifeform = lifeform;
    this.fieldName = fieldName;
    this.memberClass = memberClass;
  }

  public Lifeform getLifeform() {
    return lifeform;
  }

  public String getFieldName() {
    return fieldName;
  }

  public Class getMemberClass() {
    return memberClass;
  }

  public String toString() {
    return lifeform + " needs a " + memberClass.getSimpleName() + " for field " + fieldName;
  }
}