/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m12;

import prophecy.common.lifeform.Lifeform;
import prophecy.m.m05.IQuestion;
import prophecy.m.m09.StringVar;

public class Question extends Lifeform implements IQuestion {
  private String question;
  private StringVar answer = new StringVar();

  public Question(String question) {
    this.question = question;
    updateStatus();
  }

  private void updateStatus() {
    if (answer.isEmpty())
      setStatus("Q: " + question);
    else
      setStatus("Q: " + question + " A: " + answer);
  }

  public String getQuestion() {
    return question;
  }

  public void answer(String answer) {
    if (this.answer.isEmpty())
      logActivity("Saving answer: " + answer);
    this.answer.set(answer);
    updateStatus();
  }

  public String getAnswer() {
    return answer.get();
  }

  public boolean isAnswered() {
    return !answer.isEmpty();
  }
}