/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m13;

import java.lang.reflect.Method;

public class Property {
  private String name;
  private Method method;

  public Property(String name, Method method) {
    this.name = name;
    this.method = method;
  }

  public String getName() {
    return name;
  }

  public Method getMethod() {
    return method;
  }

  public String getType() {
    return method.getReturnType().toString();
  }

  public Object getValue(Object object) {
    try {
      return method.invoke(object);
    } catch (Throwable e) {
      return null;
    }
  }
}