/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m14;

import drjava.util.Lizt;

import java.io.File;
import java.util.List;

public class DirUser extends Tool {
  protected File dir;

  public DirUser(String dir) {
    this(new File(dir));
  }

  public DirUser(File dir) {
    this.dir = dir;
  }

  protected void init() throws Exception {
    super.init();
    if (dir.isDirectory())
      logConfirmation(dir + " exists");
    else {
      if (dir.mkdirs())
        logConfirmation(dir + " created");
      else {
        throw new Failure("Could not create " + dir);
      }
    }
  }

  public File getDir() {
    return dir;
  }

  public List<String> getDefiningProperties() {
    return Lizt.of("dir");
  }
}