/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m14;

import prophecy.common.lifeform.Lifeform;

import javax.swing.*;

public class FrameIconUpdater extends Lifeform {
  private Lifeform iconSource;
  private Icon lastIcon;
  private JFrame frame;

  public FrameIconUpdater(Lifeform iconSource) {
    this.iconSource = iconSource;
  }

  public void setFrame(JFrame frame) {
    this.frame = frame;
  }

  protected void idleImpl() {
    if (frame != null) {
      ImageIcon icon = (ImageIcon) iconSource.getIcon();
      if (icon != lastIcon) {
        lastIcon = icon;
        frame.setIconImage(icon == null ? null : icon.getImage());
      }
    }
  }
}