/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m14;

import java.lang.reflect.Method;

public class Function {
  private Method method;

  public Function(Method method) {
    this.method = method;
  }

  public String getName() {
    return method.getName();
  }

  public Method getMethod() {
    return method;
  }

  public Object invoke(Object object, Object... arguments) {
    try {
      return method.invoke(object, arguments);
    } catch (Throwable e) {
      return null;
    }
  }
}