/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m14;

import prophecy.common.Prophecy;
import prophecy.common.Application;
import prophecy.m.m12.CalculatorEnv;
import prophecy.m.m12.CalculatorGUI;
import prophecy.m.m26.ProphecyJarMaker;

import javax.swing.*;
import java.io.IOException;

public class M14Calc extends Application {
  private CalculatorEnv env;

  public void start() {
    Prophecy.init();
    env = new CalculatorEnv(Prophecy.memoryDir() + "m14");
    CalculatorGUI gui = new CalculatorGUI(env.getCalculator(),
      env.getStats());
    gui.setTitle("M14: Loyal Calculator");
    FrameIconUpdater frameIconUpdater = new FrameIconUpdater(env.getStats());
    env.add(frameIconUpdater);
    JFrame frame = gui.asFrame();
    frameIconUpdater.setFrame(frame);
    showFinalFrame(frame);
  }

  public void retire() {
    env.retire();
    super.retire();
  }

  public static void main(String[] args) {
    M14Calc m14Calc = new M14Calc();
    m14Calc.asMainApplication();
    m14Calc.start();
  }

  public static class MakeJar {
    public static void main(String[] args) throws IOException {
      ProphecyJarMaker.makeJar("standalone/m14calc.jar", M14Calc.class);
    }
  }
}