/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m14;

import prophecy.common.Prophecy;
import prophecy.common.lifeform.Lifeform;

import javax.swing.*;

public class ToolIcon extends Lifeform {
  private Tool tool;
  private ToolStatus lastStatus;

  public ToolIcon(Tool tool) {
    this.tool = tool;
  }

  public Icon makeIcon() {
    if (tool == null) return null;
    ToolStatus status = tool.getToolStatus();
    if (status instanceof Ready)
      return Prophecy.happyIcon();
    if (status instanceof OutOfOrder)
      return Prophecy.flatIcon();
    if (status instanceof ShuttingDown)
      return Prophecy.ghostIcon();
    return null;
  }

  public Tool getTool() {
    return tool;
  }

  protected void idleImpl() {
    super.idleImpl();
    if (tool != null && tool.getToolStatus() != lastStatus) {
      lastStatus = tool.getToolStatus();
      setIcon(null);
    }
  }
}