/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m15;

public class Snippet {
  // these are supposed to be 0 or 1 char, non-null
  private String frontSeparator, backSeparator;

  private String text;

  public Snippet(String fullText, int start, int end) {
    frontSeparator = fullText.substring(Math.max(0, start-1), start);
    if (end >= fullText.length())
      backSeparator = "";
    else
      backSeparator = fullText.substring(end, end+1);
    this.text = fullText.substring(start, end);
  }

  public Snippet(String frontSeparator, String text, String backSeparator) {
    this.frontSeparator = frontSeparator;
    this.backSeparator = backSeparator;
    this.text = text;
  }

  public String getFrontSeparator() {
    return frontSeparator;
  }

  public String getBackSeparator() {
    return backSeparator;
  }

  public String getText() {
    return text;
  }
}