/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m15;

import java.util.ArrayList;
import java.util.List;

public class WhitespaceSplitter {
  private List<Range> ranges = new ArrayList<Range>();

  public WhitespaceSplitter(String text) {
    int i = 0;
    int len = text.length();
    while (i < len) {
      int j = i;
      while (j < len && !Character.isWhitespace(text.charAt(j)))
        ++j;
      if (j > i)
        ranges.add(new Range(text, i, j));
      while (j < len && Character.isWhitespace(text.charAt(j)))
        ++j;
      i = j;
    }
  }

  public List<Range> getRanges() {
    return ranges;
  }
}