/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m16;

import prophecy.common.lifeform.Lifeform;

public class TailMatcher extends Lifeform {
  public void introduce(Lifeform lifeform) {
    super.introduce(lifeform);
    if (lifeform instanceof StringPair && !lifeform.hasAttachment(Tested.class)) {
      StringPair pair = (StringPair) lifeform;
      String a = pair.getA();
      String b = pair.getB();
      if (!a.equals(b)) {
        String match = tailMatch(a, b);
        if (match.length() != 0)
          pair.addAttachment(new TailMatch(match));
      }
    }
  }

  private String tailMatch(String a, String b) {
    int l = Math.min(a.length(), b.length());
    int i = 0;
    while (i < l && a.charAt(a.length()-1-i) == b.charAt(b.length()-1-i))
      ++i;
    return a.substring(a.length()-i, a.length());
  }

  public class Tested {}
}