/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m16;

import prophecy.common.lifeform.Lifeform;
import prophecy.m.m15.Range;
import prophecy.m.m15.WhitespaceSplitter;

public class ToWords extends Lifeform {
  public void introduce(Lifeform lifeform) {
    super.introduce(lifeform);
    if (lifeform instanceof StringLF) {
      String string = ((StringLF) lifeform).getString();
      if (string.indexOf(' ') >= 0) {
        WhitespaceSplitter splitter = new WhitespaceSplitter(string);
        for (Range range : splitter.getRanges()) {
          release(new StringLF(range.getText()));
        }
      }
    }
  }
}