/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m17;

import static drjava.util.StringUtil.formatDouble;
import static drjava.util.StringUtil.n;

public class Timing {
  private int idleCycles;
  private double cpuTime;

  public Timing(int idleCycles, double cpuTime) {
    this.idleCycles = idleCycles;
    this.cpuTime = cpuTime;
  }

  public int getIdleCycles() {
    return idleCycles;
  }

  public double getCpuTime() {
    return cpuTime;
  }

  public String toString() {
    return n(idleCycles, "icycle") + ", " + formatDouble(cpuTime, 1) + " s CPU";
  }
}