/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m17;

import java.util.TreeSet;

public class UlfReport {
  private String subjectClass;
  private boolean defaultConstructorOK;
  private boolean isLifeform;
  private Throwable exception;
  private TreeSet<String> triggerClasses = new TreeSet<String>();
  private TreeSet<String> nonTriggerClasses = new TreeSet<String>();
  private TreeSet<String> productClasses = new TreeSet<String>();
  private Timing outputTiming;

  public void setSubjectClass(String subjectClass) {
    this.subjectClass = subjectClass;
  }

  public void setDefaultConstructorOK(boolean defaultConstructorOK) {
    this.defaultConstructorOK = defaultConstructorOK;
  }

  public void setLifeform(boolean lifeform) {
    isLifeform = lifeform;
  }

  public String getSubjectClass() {
    return subjectClass;
  }

  public boolean isDefaultConstructorOK() {
    return defaultConstructorOK;
  }

  public boolean isLifeform() {
    return isLifeform;
  }

  public void setException(Throwable throwable) {
    this.exception = throwable;
  }

  public Throwable getException() {
    return exception;
  }

  public void addProductClass(String productClass) {
    productClasses.add(productClass);
  }

  public TreeSet<String> getProductClasses() {
    return productClasses;
  }

  public void addTriggerClass(String className) {
    triggerClasses.add(className);
  }

  public TreeSet<String> getTriggerClasses() {
    return triggerClasses;
  }

  public void addNonTriggerClass(String className) {
    nonTriggerClasses.add(className);
  }

  public TreeSet<String> getNonTriggerClasses() {
    return nonTriggerClasses;
  }

  public Timing getOutputTiming() {
    return outputTiming;
  }

  public void setOutputTiming(Timing outputTiming) {
    this.outputTiming = outputTiming;
  }
}