/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m17;

import prophecy.common.lifeform.Environment;
import prophecy.common.lifeform.Lifeform;

import java.util.ArrayList;
import java.util.List;

public class UlfState {
  private String status;
  private List<Lifeform> products = new ArrayList<Lifeform>();

  public UlfState(Lifeform ulf, Environment environment,
    List<Lifeform> ignoreList) {
    status = ulf.getStatus();
    for (Lifeform inhabitant : environment.getInhabitants()) {
      if (!ignoreList.contains(inhabitant))
        products.add(inhabitant);
    }
  }

  public String getStatus() {
    return status;
  }

  public List<Lifeform> getProducts() {
    return products;
  }
}