/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m18;

import bsh.Interpreter;
import static drjava.util.StringUtil.firstToUpper;
import prophecy.common.lifeform.Lifeform;

public class LifeformMaker {
  StringBuilder fields = new StringBuilder();
  StringBuilder methods = new StringBuilder();

  public void addField(String fieldName, Class fieldClass) {
    fields.append("private " + fieldClass.getName() + " " + fieldName + ";\n");
    methods.append("public " + fieldClass.getName() + " get" + firstToUpper(fieldName) + "() {\n")
      .append("  return " + fieldName + ";\n")
      .append("}\n\n");
    methods.append("public void set" + firstToUpper(fieldName)
      + "(" + fieldClass.getName() + " " + fieldName + ") {\n")
      .append("  this." + fieldName + " = " + fieldName + ";\n")
      .append("}\n\n");
  }

  public Lifeform make() {
    String src = makeSource();
    //System.out.println(src);
    Interpreter interpreter = new Interpreter();
    try {
      Class newClass = (Class) interpreter.eval(src);
      return (Lifeform) newClass.newInstance();
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }

  private String makeSource() {
    return "public class SomeLifeform extends " + Lifeform.class.getName() + " {\n"
      + fields + "\n" + methods + "}";
  }
}