/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m18;

import drjava.util.XTestCase;
import prophecy.common.lifeform.Lifeform;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class LifeformMakerTest extends XTestCase {
  public void testAddField() throws NoSuchMethodException, IllegalAccessException, InvocationTargetException {
    LifeformMaker maker = new LifeformMaker();
    maker.addField("brother", Lifeform.class);
    Lifeform lifeform = maker.make();

    Method getBrother = lifeform.getClass().getMethod("getBrother");
    assertEquals(Lifeform.class, getBrother.getReturnType());

    Method setBrother = lifeform.getClass().getMethod("setBrother", Lifeform.class);
    assertEquals(Void.TYPE, setBrother.getReturnType());

    assertEquals(null, getBrother.invoke(lifeform));
    Lifeform brother = new Lifeform();
    setBrother.invoke(lifeform, brother);
    assertEquals(brother, getBrother.invoke(lifeform));
  }
}