/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m19;

import drjava.util.FileUtil;
import drjava.util.XTestCase;

import java.io.File;
import java.io.IOException;

public class DirMonitorTest extends XTestCase {
  public void testExternalChange() throws IOException {
    File dir = new File("temp/DirMonitorTest");
    rmDir(dir);
    DirMonitor dirMonitor = new DirMonitor(dir);
    dirMonitor.update();
    assertFalse(dirMonitor.getChangeDetected());
    dir.mkdir();
    dirMonitor.update();
    assertTrue(dirMonitor.getChangeDetected());
    dirMonitor.setChangeDetected(false);
    FileUtil.saveTextFile(new File(dir, "hello.txt"), "world");
    dirMonitor.update();
    assertTrue(dirMonitor.getChangeDetected());
  }

  private void rmDir(File dir) {
    if (!dir.exists()) return;
    for (File file : dir.listFiles()) {
      delete(file);
    }
    delete(dir);
  }

  private void delete(File file) {
    if (!file.delete())
      throw new RuntimeException("Could not delete " + file);
    System.out.println("Deleted " + file);
  }
}