/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m19;

import prophecy.common.Prophecy;
import prophecy.common.image.RGBImage;
import prophecy.common.lifeform.Introducer;
import prophecy.common.lifeform.ProphecyEnv;
import prophecy.m.m05.Screenshot;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;

public class ImageCollectorTest {
  public static void main(String[] args) {
    ProphecyEnv env = new ProphecyEnv("M19: Image Collector");
    env.add(new Introducer());
    ImageCollector imageCollector = new ImageCollector(Prophecy.memoryDir() + "m19");
    env.add(imageCollector);
    final JFrame frame = env.showMainFrame();
    env.add(new ButtonLF("Take screenshot!") {
      public void pressed() {
        try {
          BufferedImage bufferedImage = new Screenshot().captureFrame(frame);
          release(new ImageLF(new RGBImage(bufferedImage)));
        } catch (AWTException e) {
          error(e);
        }
      }
    });
  }
}