/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m19;

import prophecy.common.image.ImageProcessing;
import prophecy.common.image.RGBImage;

import java.util.HashSet;
import java.util.Set;

public class ImageIDSet {
  private Set<Long> hashes = new HashSet<Long>();

  public boolean contains(RGBImage image) {
    return hashes.contains(hash(image));
  }

  private long hash(RGBImage image) {
    return ImageProcessing.hash(image);
  }

  public void add(RGBImage image) {
    hashes.add(hash(image));
  }
}