/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m20;

public class BeginsWith extends Assertion {
  private String text;

  public BeginsWith(String text) {
    this.text = text;
  }

  public String getText() {
    return text;
  }

  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;

    BeginsWith that = (BeginsWith) o;

    if (text != null ? !text.equals(that.text) : that.text != null)
      return false;

    return true;
  }

  public int hashCode() {
    return (text != null ? text.hashCode() : 0);
  }

  public String toString() {
    return "Text begins with \"" + text + "\"";
  }

  public boolean holdsFor(String text) {
    return text != null && text.startsWith(this.text);
  }
}