/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m20;

import prophecy.common.lifeform.Lifeform;

public class BestTheory extends Lifeform {
  private TheoryLF bestTheory;

  protected void idleImpl() {
    super.idleImpl();
    for (TheoryLF theory : getPeers(TheoryLF.class)) {
       if (bestTheory == null
         || (theory != bestTheory
             && theory.getExamples().size() > bestTheory.getExamples().size()))
        setBestTheory(theory);
    }
  }

  public TheoryLF getBestTheory() {
    return bestTheory;
  }

  public void setBestTheory(TheoryLF bestTheory) {
    this.bestTheory = bestTheory;
    log("New best theory: " + bestTheory);
  }
}