/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m20;

public class HeadMatcher implements PairMatcher {
  public Assertion match(SourceFile source1, SourceFile source2) {
    String match = headMatch(source1.getText(), source2.getText());
    if (match.length() != 0)
      return new BeginsWith(match);
    return null;
  }

  private String headMatch(String a, String b) {
    int l = Math.min(a.length(), b.length());
    int i = 0;
    while (i < l && a.charAt(i) == b.charAt(i))
      ++i;
    return a.substring(0, i);
  }
}