/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m20;

import static drjava.util.StringUtil.n;
import prophecy.common.lifeform.Activity;
import prophecy.common.lifeform.Lifeform;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Arrays;
import java.util.List;

public class JavaSrcDir extends Lifeform {
  private File dir;
  private List<File> files;

  public JavaSrcDir(File dir) {
    this.dir = dir;
    setActivity(new Scanning());
  }

  public List<File> getFiles() {
    return files;
  }

  private class Scanning extends Activity {
    protected void runOnce() throws Exception {
      files = Arrays.asList(dir.listFiles(new FilenameFilter() {
        public boolean accept(File dir, String name) {
          return name.endsWith(".java");
        }
      }));
      setStatus("done");
      done();
    }
  }

  public String toString() {
    return dir.getPath() + (files == null ? ""
      : " [" + n(files.size(), "Java source") + "]");
  }
}