/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m20;

import static drjava.util.StringUtil.formatDouble;
import prophecy.common.lifeform.ReleaseEvent;
import prophecy.common.lifeform.Time;

public class NewTheories extends FlagLF implements ReleaseListener {
  private Time lastEvent;

  public NewTheories(SourcesAnalyzer analyzer) {
    analyzer.addReleaseListener(this);
  }

  public void lifeformReleased(ReleaseEvent evt) {
    if (evt.getProduct() instanceof TheoryLF)
      noteChange();
  }

  private void noteChange() {
    lastEvent = getCurrentTime();
  }

  protected void idleImpl() {
    super.idleImpl();
    Time time = getCurrentTime();
    if (lastEvent == null)
      lastEvent = time;
  }

  public String toString() {
    return lastEvent == null ? "NewTheories" : "NewTheories | "
      + formatDouble(getCurrentTime().getSeconds()-lastEvent.getSeconds(), 1) + " s";
  }
}