/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m21;

import prophecy.m.m02.Typewriter;

import java.util.ArrayList;
import java.util.List;

public class DataSheet {
  private List<DataItem> items = new ArrayList<DataItem>();

  public void addItem(DataItem item) {
    items.add(item);
  }

  public void render(Typewriter typewriter) {
    StringBuilder html = new StringBuilder();
    html.append("<table border=0 cellpadding=0 cellspacing=0>\n");
    for (DataItem item : items) {
      html.append("<tr><td style='margin-right: 10px'>" + item.getProperty() + "</td>"
        + "<td>" + item.getValue() + "</td></tr>\n");
    }
    html.append("</table>\n");
    typewriter.addHTML(html.toString());
  }

  public void addItem(String property, String value) {
    addItem(new DataItem(property, value));
  }
}