/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m21;

import prophecy.common.lifeform.Lifeform;
import prophecy.m.m20.SourcesList;
import prophecy.m.m20.TheoryLF;

public class TheoryReporter extends Lifeform {
  private SourcesList sources;

  public TheoryReporter(SourcesList sources) {
    this.sources = sources;
  }

  public void introduce(Lifeform lifeform) {
    super.introduce(lifeform);
    if (lifeform instanceof TheoryLF && !reportExists((TheoryLF) lifeform)) {
      release(new TheoryReport(sources, (TheoryLF) lifeform));
    }
  }

  private boolean reportExists(TheoryLF theory) {
    for (Lifeform peer : getPeers()) {
      if (peer instanceof TheoryReport
        && ((TheoryReport) peer).getTheory().equals(theory))
        return true;
    }
    return false;
  }
}