/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m22;

import drjava.util.TextView;
import prophecy.m.m04.Msg;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

public abstract class ChatPanel extends JPanel {
  private JTextField tfInput = new JTextField();
  private TextView chat = new TextView();
  private StringBuilder log = new StringBuilder();
  private List<Msg> messages = new ArrayList<Msg>();
  private ChatRenderer renderer = new DefaultChatRenderer();

  public ChatPanel() {
    super(new BorderLayout());
    add(BorderLayout.CENTER, chat);
    add(BorderLayout.SOUTH, tfInput);

    tfInput.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent actionEvent) {
        String text = tfInput.getText();
        tfInput.setText("");
        text = text.trim();
        if (text.length() != 0)
          userInput(text);
      }
    });
  }

  public void userInput(String text) {
    logAppend("User", text);
  }

  public void logAppend(String text) {
    log.append(text).append("<br>");
    chat.setText(log.toString());
    chat.scrollDown();
  }

  public void logAppend(String nick, String text) {
    messages.add(new Msg(nick, text));
    logAppend(renderer.renderMessage(nick, text));
  }

  public List<Msg> getMessages() {
    return messages;
  }

  public void setChatFont(Font font) {
    chat.setTextFont(font);
  }

  public ChatRenderer getRenderer() {
    return renderer;
  }

  public void setRenderer(ChatRenderer renderer) {
    this.renderer = renderer;
  }

  public void setInset(int inset) {
    chat.setInset(inset);
  }

  public void focus() {
    tfInput.requestFocus();
  }
}