/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m23;

import prophecy.common.lifeform.Lifeform;

public class ConversionTask extends Lifeform {
  private Object input;
  private Class sourceClass;
  private Class destinationClass;
  private Object proposedSolution;

  public ConversionTask(Object input, Class destinationClass) {
    this.input = input;
    sourceClass = input.getClass();
    this.destinationClass = destinationClass;
  }

  public Object getInput() {
    return input;
  }

  public Class getSourceClass() {
    return sourceClass;
  }

  public Class getDestinationClass() {
    return destinationClass;
  }

  public String toString() {
    return "ConversionTask" + (proposedSolution == null ? "" : "[p]")
      + " | " + sourceClass.getName() + " -> " + destinationClass.getName();
  }

  public Object getProposedSolution() {
    return proposedSolution;
  }

  public void setProposedSolution(Object proposedSolution) {
    if (this.proposedSolution == null && destinationClass.isInstance(proposedSolution)) {
      this.proposedSolution = proposedSolution;
      fireSolutionProposed();
    }
  }

  protected void fireSolutionProposed() {
  }
}