/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m23;

import drjava.util.*;
import prophecy.m.m19.DirMonitor;

import javax.swing.*;
import java.util.*;

public class DirView extends JPanel implements Updatable {
  private DirMonitor dirMonitor;
  private JList list;

  public DirView(DirMonitor dirMonitor) {
    this.dirMonitor = dirMonitor;

    list = new JList();
    setLayout(new LetterLayout("L"));
    add("L", GUIUtil.withTitle(dirMonitor.getDir().getPath(), new JScrollPane(list)));

    new SwingTimerHelper(this, 1000).installOn(this);
  }

  public void update() {
    List<String> entries = new ArrayList<String>();
    TreeSet<String> fileNames = dirMonitor.getFileNames();
    for (String fileName : fileNames) {
      entries.add(fileName);
    }

    entries = polishEntries(entries);
    Vector vector = new Vector(entries); // how oldschool!

    ListModel listModel = list.getModel();
    if (anyChange(listModel, vector))
      list.setListData(vector);
  }

  private List<String> polishEntries(List<String> entries) {
    List<String> result = new ArrayList<String>();
    for (String entry : entries) {
      if (!entry.equals("."))
        result.add(entry);
    }
    Collections.sort(result, new SmartStringComparator());
    return result;
  }

  private boolean anyChange(ListModel listModel, Vector entries) {
    if (listModel == null) return true;
    if (listModel.getSize() != entries.size()) return true;
    for (int i = 0; i< entries.size(); i++)
      if (!ObjectUtil.equal(entries.get(i), listModel.getElementAt(i)))
        return true;
    return false;
  }
}