/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m23;

import drjava.util.Errors;

import java.util.Comparator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class SmartStringComparator implements Comparator<String> {
  public int compare(String a, String b) {
    Long numberA = findNumber(a), numberB = findNumber(b);
    return numberA != null && numberB != null && !numberA.equals(numberB)
      ? numberA.compareTo(numberB) : a.compareTo(b);
  }

  private Long findNumber(String s) {
    Matcher matcher = Pattern.compile("^\\d+").matcher(s);
    if (matcher.find())
      try {
        return new Long(matcher.group());
      } catch (Throwable e) {
        Errors.add(e);
      }
    return null;
  }
}