/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m23;

import static drjava.util.ObjectUtil.nice;
import drjava.util.Updatable;
import prophecy.common.lifeform.Activity;
import prophecy.common.lifeform.Lifeform;
import prophecy.m.m09.Repeat;

public class Updater extends Lifeform {
  private Updatable updatable;

  public Updater(Updatable updatable, double delay) {
    this.updatable = updatable;
    setActivity(new Repeat(delay, new Update()));
  }

  public class Update extends Activity {
    protected void idleImpl() throws Exception {
      logActivity("Updating");
      updatable.update();
    }
  }

  public String toString() {
    return "Updater | " + nice(updatable);
  }
}