/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m25;

import prophecy.common.lifeform.Activity;
import prophecy.common.lifeform.Lifeform;
import prophecy.common.lifeform.ProphecyEnv;

import java.io.File;

public class FindBaseDirectory extends Lifeform {
  private String expectedLocation;
  private File realLocation;
  private Step step;

  public FindBaseDirectory(String expectedLocation) {
    step = new Step();
    step.setDescription("Find base directory");
    this.expectedLocation = expectedLocation;
    setActivity(new Searching());
  }

  private class Searching extends Activity {
    protected void runOnce() throws Exception {
      File file = new File(expectedLocation);
      if (file.isDirectory()) {
        realLocation = file;
        step.success("found at " + realLocation.getAbsolutePath());
      } else
        step.failure("not found: " + file.getAbsolutePath());
    }
  }

  public static void main(String[] args) {
    ProphecyEnv.test(new FindBaseDirectory("memory"));
  }

  public Step getStep() {
    return step;
  }
}