/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m25;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Steps {
  private List<Step> steps = new ArrayList<Step>();

  public Steps(Step... steps) {
    this.steps.addAll(Arrays.asList(steps));
  }

  public void add(Step step) {
    steps.add(step);
  }

  public int size() {
    return steps.size();
  }

  public int getNumberOfStepsDone() {
    int done = 0;
    for (Step step : steps) {
      if (step.isDone())
        ++done;
    }
    return done;
  }

  public Step getFirstIncompleteStep() {
    for (Step step : steps) {
      if (!step.isDone())
        return step;
    }
    return null;
  }

  public boolean isDone() {
    return getNumberOfStepsDone() == steps.size();
  }
}