/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m26;

import drjava.util.StringUtil;
import prophecy.common.lifeform.Lifeform;
import prophecy.m.m08.MuxLogger;

import java.util.ArrayList;
import java.util.List;

// GENERATED FROM MIXINS - DO NOT EDIT DIRECTLY

public class CompositeStep extends prophecy.common.lifeform.Lifeform {

// BEGIN MIXIN Step

  private String description;
  private boolean done, success;
  private String comment;

  public String toString() {
    String s = description != null ? description : super.toString();
    if (done) s += success ? " (OK)" : " (FAILED)";
    return s;
  }

  public boolean isDone() {
    return done;
  }

  public void setDone(boolean done) {
    this.done = done;
  }

  public void success(String comment) {
    done = true;
    success = true;
    setComment(comment);
    setStatus("OK - " + comment);
  }

  public void setComment(String comment) {
    this.comment = comment;
  }

  public void failure(String comment) {
    done = true;
    success = false;
    setComment(comment);
    setStatus("FAILED - " + comment);
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

// END MIXIN Step


// BEGIN MIXIN CompositeLifeform

  private List<Lifeform> parts = new ArrayList<Lifeform>();

  public void addPart(Lifeform part) {
    part.setLogger(new MuxLogger(part.getLogger(), getLogger()));
    parts.add(part);
  }

  public List<Lifeform> getParts() {
    return parts;
  }

  public void idleImpl() {
    super.idleImpl();
    for (Lifeform part : parts) {
      part.idle();
    }
  }

  public String getStatus() {
    List<String> stati = new ArrayList<String>();
    for (Lifeform part : parts) {
      stati.add(part.getStatus());
    }
    return StringUtil.join("; ", stati);
  }

// END MIXIN CompositeLifeform

}