/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m26;

import java.util.ArrayList;
import java.util.List;

public class Merger {
  public static Mixin merge(Mixin mixin1, Mixin mixin2, String destClass) {
    Mixin result = new Mixin();
    int idx = destClass.lastIndexOf('.');
    result.setPackageName(destClass.substring(0, idx));
    result.setClassName(destClass.substring(idx+1));
    List<String> lines = new ArrayList<String>();
    paste(mixin1, lines);
    paste(mixin2, lines);
    result.setLines(lines);

    result.getImports().addAll(mixin1.getImports());
    result.getImports().addAll(mixin2.getImports());
    importPkg(mixin1, result);
    importPkg(mixin2, result);
    return result;
  }

  private static void importPkg(Mixin mixin, Mixin result) {
    if (mixin.getPackageName() != null)
      result.getImports().add("import " + mixin.getPackageName() + ".*;");
  }

  private static void paste(Mixin mixin1, List<String> lines) {
    lines.add("");
    lines.add("// BEGIN MIXIN " + mixin1.getClassName());
    lines.add("");
    lines.addAll(mixin1.getLines());
    lines.add("");
    lines.add("// END MIXIN " + mixin1.getClassName());
    lines.add("");
  }
}