/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m26;

import prophecy.m.m33.ClassPath;

import java.io.IOException;

public class ProphecyJarMaker {
  public static void makeJar(String jarPath, Class mainClass) throws IOException {
    ClassPath classPath = ProphecyClassPath.get();
    makeJar(jarPath, mainClass, classPath);
  }

  public static void makeJar(String jarPath, Class mainClass, ClassPath classPath) throws IOException {
    JarMaker maker = new JarMaker(jarPath, mainClass == null ? null : mainClass.getName());
    maker.begin();
    fillJar(classPath, maker);
    maker.end();
  }

  public static void fillJar(ClassPath classPath, JarMaker maker) throws IOException {
    processClassPath(classPath, maker);
    maker.dirToJar("img", "img");
  }

  public static void processClassPath(ClassPath classPath, JarMaker maker) throws IOException {
    for (String path : classPath.getPaths()) {
      if (path.endsWith(".jar"))
        maker.jarToJar(path);
      else
        maker.dirToJar(path);
    }
  }

  public static void makeJar(Class mainClass) throws IOException {
    makeJar("standalone/" + mainClass.getSimpleName() + ".jar", mainClass);
  }

  public static void makeJar(String jarFile) throws IOException {
    makeJar(jarFile, null);
  }
}