/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m26;

import drjava.util.FileUtil;
import drjava.util.StringUtil;
import prophecy.common.lifeform.Lifeform;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Writer {
  public static void save(String srcDir, Mixin mixin) throws IOException {
    File file = new File(srcDir, mixin.getPackageName().replace('.', '/')
      + "/" + mixin.getClassName() + ".java");
    FileUtil.saveTextFile(file, StringUtil.stringFromLines(genSource(mixin)));
  }

  public static List<String> genSource(Mixin mixin) {
    List<String> lines = new ArrayList<String>();
    lines.add("package " + mixin.getPackageName() + ";");
    lines.add("");
    lines.addAll(mixin.getImports());
    lines.add("");
    lines.add("// GENERATED FROM MIXINS - DO NOT EDIT DIRECTLY");
    lines.add("");
    lines.add("public class " + mixin.getClassName() + " extends " + Lifeform.class.getName() + " {");
    lines.addAll(mixin.getLines());
    lines.add("}");
    return lines;
  }
}