/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m27;

import static drjava.util.ObjectUtil.nice;
import drjava.util.StringUtil;
import drjava.util.SwingTimerHelper;

import java.util.ArrayList;
import java.util.List;

public class CEExtensionsTooltip extends CExtension {
  public void postInstall() {
    new SwingTimerHelper(new Runnable() {
      public void run() {
        List<String> list = new ArrayList<String>();
        for (CExtension extension : ExtensionRegistry.getExtensions(component).getExtensions()) {
          list.add(nice(extension));
        };
        component.setToolTipText(list.isEmpty() ? "No extensions"
          : "Extensions: " + StringUtil.join(", ", list));
      }
    }, 1000).installOn(component);
  }

  public CExtension clone() {
    return new CEExtensionsTooltip();
  }
}