/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m27;

import static drjava.util.ObjectUtil.nice;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ContainerEvent;
import java.awt.event.ContainerListener;

public class CEInheritance extends CExtension {
  private CExtension payload;

  public CEInheritance(CExtension payload) {
    this.payload = payload;
  }

  public void postInstall() {
    for (Component child : component.getComponents()) {
      if (child instanceof JComponent)
        spreadTo((JComponent) child);
    }

    component.addContainerListener(new ContainerListener() {
      public void componentAdded(ContainerEvent e) {
        if (e.getComponent() instanceof JComponent) {
          JComponent child = (JComponent) e.getComponent();
          spreadTo(child);
        }
      }

      public void componentRemoved(ContainerEvent e) {
      }
    });

    //System.out.println("Payload: " + payload);
    if (payload != null)
      payload.installOn(component);
  }

  public void spreadTo(JComponent child) {
    //System.out.println("Spreading to " + child);
    clone().installOn(child);
  }

  public CEInheritance clone() {
    return new CEInheritance(payload.clone());
  }

  public String toString() {
    return "inherit<" + nice(payload) + ">";
  }
}