/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m27;

import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class CERollOver extends CExtension {
  private boolean lit;
  private Color originalBackground;
  private MouseAdapter mouseListener;

  public void postInstall() {
    originalBackground = component.getBackground();
    component.setOpaque(true);

    mouseListener = new MouseAdapter() {
      public void mouseEntered(MouseEvent e) {
        setLit(true);
      }

      public void mouseExited(MouseEvent e) {
        setLit(false);
      }

      public void mousePressed(MouseEvent e) {
      }
    };
    component.addMouseListener(mouseListener);
  }

  public void uninstall() {
    component.removeMouseListener(mouseListener);
    component.setBackground(originalBackground);
    super.uninstall();
  }

  public void setLit(boolean lit) {
    this.lit = lit;
    updateComponent();
  }

  protected void updateComponent() {
    if (component != null)
      component.setBackground(getBackground());
  }

  protected Color getBackground() {
    return this.lit ? Color.yellow : originalBackground;
  }


}