/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m27;

import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class CESelectable extends CERollOver implements Selectable {
  private boolean selected;
  private SelectionGroup selectionGroup;

  public CESelectable(final SelectionGroup selectionGroup) {
    this.selectionGroup = selectionGroup;
  }

  public void postInstall() {
    selectionGroup.add(this);
    component.addMouseListener(new MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        selectionGroup.select(CESelectable.this);
      }
    });
  }

  public void uninstall() {
    selectionGroup.remove(this);
    super.uninstall();
  }

  public void setSelected(boolean selected) {
    this.selected = selected;
    updateComponent();
  }

  protected Color getBackground() {
    return selected ? Color.blue : super.getBackground();
  }

  public boolean replaces(CExtension extension) {
    return extension instanceof CERollOver;
  }

  public CExtension clone() {
    return new CESelectable(selectionGroup);
  }
}