/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m27;

import javax.swing.*;

public class CExtension {
  protected JComponent component;

  public final void installOn(JComponent component) {
    CExtensions extensions = ExtensionRegistry.getExtensions(component);
    if (extensions.canInstall(this)) {
      this.component = component;
      extensions.add(this);
      postInstall();
    }
  }

  protected void postInstall() {
  }

  public void uninstall() {
    this.component = null;
  }

  public CExtension clone() {
    return null;
  }

  public boolean replaces(CExtension extension) {
    return false;
  }
}