/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m27;

import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;

public class CExtensions {
  private List<CExtension> extensions = new ArrayList<CExtension>();

  public void add(CExtension extension) {
    ListIterator<CExtension> it = extensions.listIterator();
    while (it.hasNext()) {
      CExtension e = it.next();
      if (extension.replaces(e))
        it.remove();
    }
    extensions.add(extension);
  }

  public List<CExtension> getExtensions() {
    return extensions;
  }

  public boolean canInstall(CExtension extension) {
    for (CExtension e : extensions) {
      if (e.replaces(extension))
        return false;
    }
    return true;
  }
}