/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m27;

import java.util.ArrayList;
import java.util.List;

public class SelectionGroup {
  private List<Selectable> elements = new ArrayList<Selectable>();

  public void add(Selectable selectable) {
    elements.add(selectable);
  }

  public void select(Selectable selectable) {
    for (Selectable element : elements) {
      element.setSelected(element == selectable);
    }
  }

  public void remove(Selectable selectable) {
    elements.remove(selectable);
  }
}