/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m28;

import drjava.util.Errors;
import drjava.util.SwingTimerHelper;
import prophecy.m.m27.CExtension;

import java.io.IOException;

public class CEAutoSave extends CExtension {
  private CEChangeMarker changeMarker;

  public CEAutoSave(CEChangeMarker changeMarker) {
    this.changeMarker = changeMarker;
  }

  protected void postInstall() {
    new SwingTimerHelper(new Runnable() {
      public void run() {
        if (changeMarker.isChanged()) {
          try {
            save();
            changeMarker.markSaved();
          } catch (Throwable e) {
            Errors.add(e);
          }
        }
      }
    }, 5000).installOn(component);
  }

  public void save() throws IOException {
  }
}