/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m28;

import prophecy.m.m27.CExtension;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class CEChangeMarker extends CExtension {
  private JFrame frame;
  private boolean changed;

  public CEChangeMarker(JFrame frame) {
    this.frame = frame;
  }

  protected void postInstall() {
    if (component instanceof JEditorPane) {
      JEditorPane editorPane = (JEditorPane) component;
      editorPane.getDocument().addDocumentListener(new DocumentListener() {
        public void insertUpdate(DocumentEvent e) {
          markChanged();
        }

        public void removeUpdate(DocumentEvent e) {
          markChanged();
        }

        public void changedUpdate(DocumentEvent e) {
          markChanged();
        }
      });
    }
  }

  public void markChanged() {
    changed = true;
    String title = frame.getTitle();
    if (!title.endsWith("*"))
      frame.setTitle(title + "*");
  }

  public void markSaved() {
    changed = false;
    String title = frame.getTitle();
    if (title.endsWith("*"))
      frame.setTitle(title.substring(0, title.length()-1));
  }

  public boolean isChanged() {
    return changed;
  }
}