/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m28;

import drjava.util.FileUtil;

import java.io.File;
import java.io.IOException;

public class DiaryModel {
  private PreparedDir dir;

  public DiaryModel() {
  }

  public void init(PreparedDir dir) {
    this.dir = dir;
  }

  public void saveEntry(Date date, String text) throws IOException {
    File file = file(date);
    FileUtil.saveTextFile(file, text);
  }

  private File file(Date date) {
    String fileName = date.yyyymmdd() + ".txt";
    return new File(dir.getDir(), fileName);
  }

  public String loadEntry(Date date) throws IOException {
    return FileUtil.loadTextFile(file(date).getPath(), "");
  }
}