/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m28;

import drjava.util.Errors;
import drjava.util.LetterLayout;
import prophecy.common.Prophecy;
import prophecy.m.m26.ProphecyJarMaker;
import prophecy.m.m27.CEExtensionsTooltip;
import prophecy.m.m27.CEInheritance;

import javax.swing.*;
import java.io.File;
import java.io.IOException;

public class M28Diary {
  public static void main(String[] args) {
    Prophecy.init();

    final DiaryModel model = new DiaryModel();
    model.init(new PreparedDir(new File("memory/m28"), true));

    JFrame frame = new JFrame("M28: Diary");
    frame.setSize(400, 400);
    frame.getContentPane().setLayout(new LetterLayout("C", "E", "E").setBorder(10));

    JLabel lblDate = new JLabel("Today");
    CenteredLine controlPane = new CenteredLine(lblDate);
    frame.getContentPane().add("C", controlPane);

    final JEditorPane editorPane = new JEditorPane();
    try {
      editorPane.setText(model.loadEntry(Date.today()));
    } catch (IOException e) {
      Errors.add(e);
    }
    CEChangeMarker changeMarker = new CEChangeMarker(frame);
    changeMarker.installOn(editorPane);
    new CEAutoSave(changeMarker) {
      public void save() throws IOException {
        model.saveEntry(Date.today(), editorPane.getText());
      }
    }.installOn(editorPane);

    JScrollPane scrollPane = new JScrollPane(editorPane);
    frame.getContentPane().add("E", scrollPane);

    new CEInheritance(new CEExtensionsTooltip()).installOn(scrollPane);
    frame.setVisible(true);
  }

  public static class MakeJar {
    public static void main(String[] args) throws IOException {
      ProphecyJarMaker.makeJar("standalone/m28diary.jar", M28Diary.class);
    }
  }
}