/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m28;

import prophecy.m.m14.Failure;

import java.io.File;

public class PreparedDir {
  private File dir;
  private boolean autoCreate;

  public PreparedDir(File dir, boolean autoCreate) {
    this.autoCreate = autoCreate;
    this.dir = dir;
    if (!dir.isDirectory())
      notFound();
  }

  private void notFound() {
    if (autoCreate)
      dir.mkdirs();
    if (!dir.isDirectory())
      throw new Failure(dir.getPath() + " is not a directory");
  }

  public File getDir() {
    return dir;
  }
}