/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m30;

import static drjava.util.ObjectUtil.nice;

import java.util.Enumeration;

public class Expander implements Enumeration<Object> {
  private Object o;
  private boolean oReturned;
  private boolean oExpanded;

  public Expander(Object o) {
    this.o = o;
  }

  public Object getO() {
    return o;
  }

  public boolean hasMoreElements() {
    return !oReturned || (!oExpanded && o instanceof Expandable);
  }

  public Object nextElement() {
    if (!oReturned) {
      oReturned = true;
      return o;
    }
    if (!oExpanded) {
      oExpanded = true;
      if (o instanceof Expandable) {
        try {
          Object expansion = ((Expandable) o).expand();
          o = expansion;
          oExpanded = false;
          return expansion;
        } catch (Throwable e) {
          return e;
        }
      }
    }
    return null;
  }

  public String toString() {
    return "TreeSearch " + nice(o);
  }
}