/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m30;

import java.util.ArrayList;
import java.util.List;

public class Pipe implements Feedable {
  private List<Feedable> receivers = new ArrayList<Feedable>();

  public void feed(Object object) {
    for (Feedable receiver : receivers) {
      receiver.feed(object);
    }
  }

  public void addReceiver(Feedable receiver) {
    receivers.add(receiver);
  }
}