/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m30;

import drjava.util.Lizt;
import prophecy.common.lifeform.Lifeform;
import prophecy.m.m05.ICalculator;

import java.util.List;

public class RCalcExample extends Lifeform implements Requirement, Expandable {
  private ICalculator calculator;
  private String question, answer;

  public ICalculator getCalculator() {
    return calculator;
  }

  public void setCalculator(ICalculator calculator) {
    this.calculator = calculator;
  }

  public String getQuestion() {
    return question;
  }

  public void setQuestion(String question) {
    this.question = question;
  }

  public String getAnswer() {
    return answer;
  }

  public void setAnswer(String answer) {
    this.answer = answer;
  }

  public Object expand() {
    return new Equals(answer, new Eval() {
      public Object expand() {
        return calculator.calculate(question);
      }
    });
  }

  public boolean isMet() {
    return ExUtil.toBoolean(this);
  }

  public List<String> getCoreFunctions() {
    return Lizt.of("unfold");
  }
}