/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m31;

import jazz.retroui.Cursor;
import jazz.retroui.FancyScreen;

public class RollingScreen {
  private FancyScreen screen;

  public RollingScreen(FancyScreen screen) {
    this.screen = screen;
  }

  public void print(String s) {
    int i = s.indexOf('\n');
    if (i >= 0) {
      println(s.substring(0, i));
      print(s.substring(i+1));
      return;
    }
    Cursor cursor = getCursor();
    s = s.substring(0, Math.min(screen.getWidth()-cursor.getX(), s.length()));
    screen.print(cursor.getX(), cursor.getY(), s);
    screen.setCursor(new Cursor(cursor.getX()+s.length(), cursor.getY()));
  }

  public void println(String s) {
    Cursor cursor = getCursor();
    screen.print(cursor.getX(), cursor.getY(), s);
    screen.setCursor(new Cursor(0, cursor.getY()+1));
  }

  private Cursor getCursor() {
    Cursor cursor = screen.getCursor();
    if (cursor == null)
      screen.setCursor(cursor = new Cursor(0, 0));
    return cursor;
  }
}