/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m31;

import prophecy.common.Prophecy;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SystemTrayTest {
  public static void main(String[] args) throws AWTException {
    if (!SystemTray.isSupported())
      throw new RuntimeException("System tray not supported");
    SystemTray tray = SystemTray.getSystemTray();

    PopupMenu popup = new PopupMenu();
    MenuItem miExit = new MenuItem("Exit");
    miExit.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        System.exit(0);
      }
    });
    popup.add(miExit);

    TrayIcon trayIcon = new TrayIcon(Prophecy.happyIcon().getImage(),
      "SystemTrayTest", popup);
    trayIcon.setImageAutoSize(true);
    tray.add(trayIcon);

    /*MultiCoreUtil.sleep(5000);
    tray.remove(trayIcon);*/
  }
}