/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m32;

import drjava.util.Tree;
import prophecy.common.comments.TreeRequest;
import prophecy.common.comments.Treelet;

public class JBLTreelet implements Treelet {
  public void serve(Tree question, TreeRequest request) {
    Tree answer = makeAnswer(question);
    if (answer != null)
      request.answer(answer);
  }

  Tree makeAnswer(Tree question) {
    TreeletQuestion tq = new TreeletQuestion(question);
    ConvertTo convert = new ConvertTo(tq, TreeletAnswer.class);
    TreeletAnswer answer = (TreeletAnswer) convert.solve();
    return answer != null ? answer.getAnswer() : null;
  }
}