/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m33;

import drjava.util.ObjectUtil;
import drjava.util.Randomizer;
import drjava.util.RealRandomizer;
import drjava.util.Tree;
import prophecy.common.comments.TreeRequest;
import prophecy.common.comments.TreeServer;
import prophecy.common.comments.Treelet;
import prophecy.m.m01.SocketUtil;

import java.io.IOException;
import java.net.ServerSocket;

public class Father {
  private ServerSocket socket = SocketUtil.serverSocketAtRandomPort();
  private String codeword;

  public void setRandomCodeword() {
    Randomizer randomizer = new RealRandomizer();
    StringBuilder builder = new StringBuilder();
    for (int i = 0; i < 10; i++)
      builder.append((char) ('a' + randomizer.random(26)));
    codeword = builder.toString();
  }

  public void listen(final Runnable onSonCalled) throws IOException {
    TreeServer server = new TreeServer(socket, new Treelet() {
      public void serve(Tree question, TreeRequest request) {
        if (ObjectUtil.equal(codeword, question.getString("codeword"))) {
          request.answer(new Tree("hello son"));
          if (onSonCalled != null)
            onSonCalled.run();
        } else
          request.answer(new Tree("go away"));
      }
    });
    server.start();
  }

  public int getPort() {
    return socket.getLocalPort();
  }

  public String getCodeword() {
    return codeword;
  }
}