/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m33;

import drjava.util.Tree;
import prophecy.common.comments.TreeClient;
import prophecy.common.lifeform.Lifeform;

import java.io.IOException;

public class Son extends Lifeform {
  private int fatherPort;

  public Son(int fatherPort) {
    this.fatherPort = fatherPort;
  }

  public void contactFather(String codeword) {
    if (fatherPort != 0) {
      log("Contacting father at port " + fatherPort);
      try {
        Tree question = new Tree("hello").setString("codeword", codeword);
        Tree answer = new TreeClient("localhost", fatherPort).ask(question);
        log("Answer from father: " + answer);
      } catch (IOException e) {
        error(e.toString());
      }
    }
  }

  public void contactFather() {
    contactFather(null);
  }
}