/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m33;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class StreamCopy {
  private volatile boolean done;

  public StreamCopy(final InputStream inputStream, final OutputStream outputStream) {
    new Thread() {
      public void run() {
        try {
          int ch;
          while ((ch = inputStream.read()) >= 0) {
            outputStream.write(ch);
          }
        } catch (IOException e) {
        } finally {
          done = true;
        }
      }
    }.start();
  }

  public boolean isDone() {
    return done;
  }
}