/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m33;

import java.io.OutputStream;

public class VM {
  private Process process;

  public VM(Process process) {
    this.process = process;
  }

  public boolean isRunning() {
    try {
      process.exitValue();
      return false;
    } catch (IllegalThreadStateException e) {
      return true;
    }
  }

  public StreamCopy copyErrTo(OutputStream outputStream) {
    return new StreamCopy(process.getErrorStream(), outputStream);
  }
  
  public StreamCopy copyOutTo(OutputStream outputStream) {
    return new StreamCopy(process.getInputStream(), outputStream);
  }

  public int waitForExit() {
    try {
      process.waitFor();
    } catch (InterruptedException e) {
      throw new RuntimeException(e);
    }
    return process.exitValue();
  }
}