/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m33;

import drjava.util.MultiCoreUtil;
import drjava.util.XTestCase;

import java.io.IOException;

public class VMStarterTest extends XTestCase {
  public void testHelloWorld() throws IOException {
    String jarPath = HelloWorld.MakeJar.makeIt();

    VMStarter starter = new VMStarter();
    starter.appendToClassPath(jarPath);
    VM vm = starter.newVM(HelloWorld.class);
    VMWatcher watcher = new VMWatcher(vm);
    watcher.waitForProcessDeath();
    assertEquals("hello world", watcher.getOutput().trim());
  }

  /*
  public void testGroovy() {
    GroovyRunner groovyRunner = new GroovyRunner();
    VM vm = groovyRunner.runScript("println(\"hello world\")");
    assertOutput(vm, "hello world");
  }
  */

  private void assertOutput(VM vm, String expectedOutput) {
    VMWatcher watcher = new VMWatcher(vm);
    watcher.waitForProcessDeath();
    MultiCoreUtil.sleep(1000);
    assertEquals(expectedOutput, watcher.getOutput().trim());
  }

  /*public void testFatherSonComm() throws IOException {
    Father father = new Father();
    father.setRandomCodeword();
    final Flag flag = new Flag();
    father.listen(flag);

    String script = "new " + Son.class.getName() + "(" + father.getPort()
      + ").contactFather(\"" + father.getCodeword() + "\")";
    GroovyRunner runner = new GroovyRunner();
    runner.getVMStarter().appendToClassPath(ProphecyClassPath.get());
    VM vm = runner.runScript(script);
    VMWatcher watcher = new VMWatcher(vm);
    watcher.waitForProcessDeath();
    MultiCoreUtil.sleep(1000);
    assertTrue(flag.isUp());
  }*/

  /* this test fails */
  /*public void testSandbox() {
    GroovyRunner runner = new GroovyRunner();
    runner.getVMStarter().appendToClassPath(ProphecyClassPath.get());
    String script = "System.setSecurityManager(new " + ForbidAll.class.getName() + "()); "
      + "println('hello sandbox')";
    VM vm = runner.runScript(script);
    assertOutput(vm, "hello sandbox");
  }*/

  /*public void testLogAll() {
    GroovyRunner runner = new GroovyRunner(ProphecyClassPath.get());
    String script = "System.setSecurityManager(new " + LogAll.class.getName() + "()); "
      + "println('hello logall')";
    VM vm = runner.runScript(script);
    assertOutput(vm, "hello logall");
  }*/
}