/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m33;

import drjava.util.MultiCoreUtil;

import java.io.ByteArrayOutputStream;

public class VMWatcher {
  private VM vm;
  private ByteArrayOutputStream out = new ByteArrayOutputStream();

  public VMWatcher(VM vm) {
    this.vm = vm;
    vm.copyErrTo(System.err);
    vm.copyOutTo(out);
  }

  public void waitForProcessDeath() {
    while (vm.isRunning())
      MultiCoreUtil.sleep(100);
    //MultiCoreUtil.sleep(200); // allow StreamCopy to complete
  }

  public String getOutput() {
    return out.toString();
  }
}