/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m34;

import static drjava.util.ObjectUtil.nice;
import drjava.util.SwingTimerHelper;
import drjava.util.Updatable;
import prophecy.common.gui.SingleComponentPanel;
import prophecy.m.m25.Step;
import prophecy.m.m25.Steps;

import javax.swing.*;
import java.awt.*;

public class StepsProgressBar extends SingleComponentPanel implements Updatable {
  private JProgressBar bar = new JProgressBar();
  private Steps steps;

  public StepsProgressBar(Steps steps) {
    this.steps = steps;
    bar.setMaximum(steps.size());
    bar.setStringPainted(true);
    setComponent(bar);
    new SwingTimerHelper(this, 250).installOn(this);
    update();
  }

  public void update() {
    bar.setValue(steps.getNumberOfStepsDone());
    Step step = steps.getFirstIncompleteStep();
    bar.setString(step == null ? "All done." : nice(step));
  }

  public void setFont(Font font) {
    super.setFont(font);
    if (bar != null)
      bar.setFont(font);
  }
}