/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m35;

import javax.swing.text.BadLocationException;
import javax.swing.text.JTextComponent;
import java.awt.*;

public class Outline {
  private JTextComponent textComponent;
  private String sourceText;
  int start;
  int end;

  public Outline(JTextComponent textComponent, String sourceText, int start, int end) {
    this.textComponent = textComponent;
    this.sourceText = sourceText;
    this.start = start;
    this.end = end;
  }

  public int getStart() {
    return start;
  }

  public int getEnd() {
    return end;
  }

  public Shape getShape() {
    try {
      Rectangle r1 = textComponent.getUI().modelToView(textComponent, getStart());
      Rectangle r2 = textComponent.getUI().modelToView(textComponent, getEnd());
      if (r1.y == r2.y)
        return new Rectangle(r1.x-1, r1.y, r2.x-r1.x+1, r1.height-2);
    } catch (BadLocationException e) {
      //Errors.add(e);
      System.err.println(e);
    }
    return null;
  }

  public String getText() {
    return sourceText.substring(start, end);
  }
}