/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m35;

import drjava.util.Errors;
import prophecy.m.m15.Associator;
import prophecy.m.m15.M15Util;

public class OutlineAnalyzer implements IOutlineAnalyzer {
  private Associator associator;

  public void setAssociator(Associator associator) {
    this.associator = associator;
  }

  public String analyze(IOutlines source) {
    String analysis = "";
    try {
      Outline outline = source.getActiveOutline();
      if (outline != null) {
        analysis = analyzeOutline(outline);
      }
    } catch (Throwable e) {
      Errors.add(e);
    }
    return analysis;
  }

  protected String analyzeOutline(Outline outline) {
    String text = outline.getText();
    String analysis = "" + M15Util.quote(text) + "\n\n";
    String className = associator.get(text);
    if (className != null)
      analysis += "Class: " + className + "\n";
    return analysis;
  }
}