/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m35;

import javax.swing.*;
import java.awt.*;

public class XEditorPane extends JEditorPane {
  private PaintHook paintHook = new PaintHook();

  // custom editor kit to remove \r on D&D imports
  // -- turns out this is already done in
  // BasicTextUI. We only have to take care of the remaining case where
  // the import is done via replaceSelection()
  /*public void installCustomEditorKit() {
    final EditorKit original = createDefaultEditorKit();
    setEditorKit(new EditorKit() {
      public void install(JEditorPane c) {
        original.install(c);
      }

      public void deinstall(JEditorPane c) {
        original.deinstall(c);
      }

      public String getContentType() {
        return original.getContentType();
      }

      public ViewFactory getViewFactory() {
        return original.getViewFactory();
      }

      public Action[] getActions() {
        return original.getActions();
      }

      public Caret createCaret() {
        return original.createCaret();
      }

      public Document createDefaultDocument() {
        return original.createDefaultDocument();
      }

      public void read(InputStream in, Document doc, int pos) throws IOException, BadLocationException {
        System.out.println("read1");
        original.read(in, doc, pos);
      }

      public void write(OutputStream out, Document doc, int pos, int len) throws IOException, BadLocationException {
        original.write(out, doc, pos, len);
      }

      public void read(Reader in, Document doc, int pos) throws IOException, BadLocationException {
        System.out.println("read2");
        original.read(in, doc, pos);
      }

      public void write(Writer out, Document doc, int pos, int len) throws IOException, BadLocationException {
        original.write(out, doc, pos, len);
      }
    });
  }*/

  /*public void replaceSelection(String content) {
    System.out.println("replaceSelection, \r=" + content.contains("\r"));
    super.replaceSelection(content);
  }*/

  public void paint(Graphics g) {
    super.paint(g);
    paintHook.paint(g);
  }

  public PaintHook getPaintHook() {
    return paintHook;
  }

  public String getText() {
    return super.getText().replace("\r", "");
  }
}