/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m36;

import drjava.util.Result;
import drjava.util.StringUtil;

import java.util.List;

public class OutlineScriptLanguage extends Language {
  public OutlineScriptLanguage() {
    setName("OutlineScript");
  }

  public Result<Parse> parse(String src) {
    List<String> lines = StringUtil.toLines(src);
    for (String line : lines) {
      Result<Parse> parseResult = new TreeParser().parse(src);
      if (!parseResult.isSuccess())
        return parseResult;
    }
    return new Result<Parse>(new Parse(src, "Syntax OK"));
  }
}