/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m37;

import drjava.util.Result;
import drjava.util.Tree;
import drjava.util.TreeUtil;
import drjava.util.Treeifier;
import prophecy.m.m13.Property;
import prophecy.t.t12.SpecialTreeifier;

import java.util.List;

public class AutoPersister implements SpecialTreeifier {
  public Result<Tree> objectToTree(Object object, Treeifier mainTreeifier) {
    try {
      return new Result<Tree>(TreeUtil.objectToTree(object));
    } catch (RuntimeException e) {
      return new Result<Tree>(toTreeImpl(object));
    }
  }

  public Tree toTreeImpl(Object object) {
    Tree tree = new Tree(AutoUnpersist.class);
    tree.add("class", new Tree(object.getClass()));
    List<Property> properties = PropertyFinder.getProperties(object);
    Tree attributes = new Tree();
    for (Property property : properties) {
      Object value = property.getValue(object);
      attributes.add(new Tree().add(property.getName()).add(objectToTree(value, new StandardTreeifier())));
    }
    tree.add("attributes", attributes);
    return tree;
  }
}