/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m37;

import drjava.util.Tree;
import drjava.util.TreeUtil;
import drjava.util.XTestCase;

public class PersistenceTest extends XTestCase {
  // one field
  public void testPersistText() {
    AutoPersister autoPersister = new AutoPersister();
    Text original = new Text("hello");
    Tree tree = autoPersister.objectToTree(original, new StandardTreeifier()).get();
    System.out.println(tree);
    Text clone = TreeUtil.treeToObject(tree);
    assertEquals(original.getText(), clone.getText());
  }

  // three fields - has to figure out order of constructor arguments
  public void testPersistSelection() {
    AutoPersister autoPersister = new AutoPersister();
    Selection original = new Selection("hello", 1, 3);
    Tree tree = autoPersister.objectToTree(original, new StandardTreeifier()).get();
    System.out.println(tree);
    Selection clone = TreeUtil.treeToObject(tree);
    assertEquals(original, clone);
  }

  private void assertEquals(Selection original, Selection clone) {
    assertEquals(original.getFullText(), clone.getFullText());
    assertEquals(original.getStart(), clone.getStart());
    assertEquals(original.getEnd(), clone.getEnd());
  }

  // nested auto-persistable object
  public void testPersistTextOutline() {
    AutoPersister autoPersister = new AutoPersister();
    TextOutline original = new TextOutline(new Selection("text", 1, 3));
    Tree tree = autoPersister.objectToTree(original, new StandardTreeifier()).get();
    System.out.println(tree);
    TextOutline clone = TreeUtil.treeToObject(tree);
    assertEquals(original.getSelection(), clone.getSelection());
  }
}