/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m37;

import drjava.util.StringUtil;
import prophecy.m.m13.Property;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

public class PropertyFinder {
  public static List<Property> getProperties(Object object) {
    List<Property> properties = new ArrayList<Property>();
    if (object == null) return properties;
    Method[] methods = object.getClass().getDeclaredMethods();
    for (final Method method : methods) {
      String prefix = null;
      if (method.getName().startsWith("get")) prefix = "get";
      else if (method.getName().startsWith("is")) prefix = "is";
      if (prefix != null && method.getParameterTypes().length == 0
        /*&& !method.getName().equals("getClass")*/
        && !method.getName().equals("isEmpty")) {
        String propertyName = StringUtil.firstToLower(method.getName().substring(prefix.length()));
        properties.add(new Property(propertyName, method));
      }
    }
    return properties;
  }

}