/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m38;

import prophecy.m.m37.BagUtil;
import prophecy.m.m37.Text;
import prophecy.t.t08.Bag;

public class EditorObjectsBridge {
  private IEditor editor;
  private Bag<Object> objects;

  public EditorObjectsBridge(IEditor editor, Bag<Object> objects) {
    this.editor = editor;
    this.objects = objects;

    editor.addChangeListener(new Runnable() {
      public void run() {
        updateObjectsFromEditor();
      }
    });
  }

  public void updateObjectsFromEditor() {
    BagUtil.removeAll(objects, Text.class);
    objects.add(new Text(editor.getText()));
  }
}