/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m38;

import drjava.util.Lizt;
import drjava.util.XTestCase;
import prophecy.common.SequenceNumber;

public class HistoryTest extends XTestCase {
  public void test() {
    Object object = new Object();
    Object event = new Object();
    assertNull(HistoryUtil.getHistory(object));
    HistoryUtil.record(object, event);
    assertNull(HistoryUtil.getHistory(object));

    HistoryUtil.startRecording(object);
    assertEquals("events", 0, HistoryUtil.getHistory(object).getEvents().size());
    HistoryUtil.record(object, event);
    Lizt<Object> events = HistoryUtil.getHistory(object).getEvents();
    assertEquals("events", 1, events.size());
    assertEquals(event, events.get(0));

    HistoryUtil.forgetHistory(object);
    assertNull(HistoryUtil.getHistory(object));
  }

  public void testSequenceNumber() {
    History history = new History();
    Object event1 = new Object(), event2 = new Object();
    history.addEvent(event1);
    history.addEvent(event2);
    SequenceNumber sequenceNumber1 = SequenceNumber.get(event1);
    SequenceNumber sequenceNumber2 = SequenceNumber.get(event2);
    assertTrue(sequenceNumber1.getNumber() < sequenceNumber2.getNumber());
  }
}