/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m38;

import drjava.util.Attachments;

public class HistoryUtil {
  public static History getHistory(Object object) {
    return Attachments.get(object, History.class);
  }

  public static void startRecording(Object object) {
    if (getHistory(object) == null)
      Attachments.add(object, new History());
  }

  public static void record(Object object, Object event) {
    History history = getHistory(object);
    if (history != null)
      history.addEvent(event);
  }

  public static void forgetHistory(Object object) {
    Attachments.remove(object, History.class);
  }
}