/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m38;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class RealEditor implements IEditor {
  private JEditorPane editorPane;

  public RealEditor(JEditorPane editorPane) {
    this.editorPane = editorPane;
  }

  public String getText() {
    return editorPane.getText();
  }

  public void setText(String text) {
    editorPane.setText(text);
  }

  public void addChangeListener(final Runnable listener) {
    editorPane.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        listener.run();
      }

      public void removeUpdate(DocumentEvent e) {
        listener.run();
      }

      public void changedUpdate(DocumentEvent e) {
        listener.run();
      }
    });
  }
}