/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m39;

import drjava.util.Errors;
import drjava.util.FileUtil;
import drjava.util.GUIUtil;
import drjava.util.LetterLayout;
import prophecy.common.Prophecy;

import javax.swing.*;
import java.io.File;
import java.io.FileNotFoundException;

public class FileViewer {
  public static void main(String[] args) {
    Errors.setPopup(true);
    Prophecy.init();

    try {
      if (args.length == 0)
        throw new RuntimeException("Need file name as argument");
      String fileName = args[0];
      /*if (!fileName.endsWith(".tree"))
        throw new RuntimeException("Expected .tree file: " + fileName);*/
      File file = new File(fileName);
      if (!file.isFile())
        throw new FileNotFoundException(file.getAbsolutePath());

      String text = FileUtil.loadTextFile(fileName);

      JFrame frame = new JFrame(file.getName() + " - M39 File Viewer");
      frame.setSize(400, 400);
      frame.getContentPane().setLayout(new LetterLayout("L", "E", "E").setBorder(10));

      JLabel label = new JLabel(file.getAbsolutePath());
      label.setToolTipText(label.getText());
      frame.getContentPane().add("L", label);

      final JEditorPane editorPane = new JEditorPane();
      editorPane.setText(text);
      editorPane.setEditable(false);

      JScrollPane scrollPane = new JScrollPane(editorPane);
      frame.getContentPane().add("E", scrollPane);

      GUIUtil.showMainFrame(frame);
    } catch (Throwable e) {
      Errors.add(e);
    }
  }
}