/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m40;

import drjava.util.MultiCoreUtil;

import java.lang.management.CompilationMXBean;
import java.lang.management.ManagementFactory;
import java.lang.management.ThreadMXBean;

public class TestVMInspection {
  public static void main(String[] args) {
    /*System.out.println("classpath: " + ManagementFactory.getRuntimeMXBean().getClassPath());
    System.out.println("bootclasspath: " + ManagementFactory.getRuntimeMXBean().getBootClassPath());*/
    ThreadMXBean threadMXBean = ManagementFactory.getThreadMXBean();
    System.out.println("user time: " + threadMXBean.getThreadUserTime(Thread.currentThread().getId())*1e-9);
    System.out.println("cpu time: " + threadMXBean.getThreadCpuTime(Thread.currentThread().getId())*1e-9);
    System.out.println("total started threads: " + threadMXBean.getTotalStartedThreadCount());
  }

  private static void compilationTime() {
    System.out.println("name: " + ManagementFactory.getCompilationMXBean().getName());
    for (int i = 0; i < 50; i++) {
      CompilationMXBean compilationMXBean = ManagementFactory.getCompilationMXBean();
      System.out.println("total compilation time: " + compilationMXBean.getTotalCompilationTime());
      MultiCoreUtil.sleep(1000);
    }
  }

  private static void setGCVerbose() {
    ManagementFactory.getMemoryMXBean().setVerbose(true);
    System.gc();
  }

  private static void systemLoad() {
    for (int i = 0; i < 50; i++) {
      System.out.println("System load average: "
        + ManagementFactory.getOperatingSystemMXBean().getSystemLoadAverage());
      MultiCoreUtil.sleep(1000);
    }
  }
}