package prophecy.marathon.ma01;

import org.mortbay.jetty.Handler;
import org.mortbay.jetty.Server;
import prophecy.common.Flag;
import prophecy.m.m01.SocketUtil;
import prophecy.p.p02.SelfTestable;
import prophecy.p.p02.SelfTestResult;

import java.net.ServerSocket;

public class Marathon1 implements SelfTestable {
  private int port;
  private transient Server server;

  public Marathon1(int port) {
    this.port = port;
  }

  public static void main(String[] args) throws Exception {
    int port = 80;

    for (int i = 0; i < args.length; i++) {
      if (args[i].equals("-port"))
        port = Integer.parseInt(args[++i]);
      else if (args[i].equals("-ping"))
        new Ping("http://www.fluesterstern.de/php/jazz/marathonping.php").start();
    }

    new Marathon1(port).run();
  }

  public void run() throws Exception {
    Handler handler = new FileServer();
    server = new Server(port);
    server.setHandler(handler);
    server.start();
  }

  public SelfTestResult selfTest() {
    int realPort = port;
    try {
      ServerSocket socket = SocketUtil.serverSocketAtRandomPort();
      port = socket.getLocalPort();
      socket.close();
      run();
      Ping ping = new Ping("http://localhost:" + port + "/");
      Flag flag = new Flag();
      ping.getPongTrigger().addListener(flag);
      ping.start();
      flag.waitUntilUp();
      ping.stop();
      server.stop();
      return SelfTestResult.passed(this);
    } catch (Throwable e) {
      return SelfTestResult.failed(this, e);
    } finally {
      port = realPort;
    }
  }
}
