package prophecy.marathon.ma01;

import drjava.util.StreamUtil;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Timer;
import java.util.TimerTask;

import prophecy.common.Trigger;

public class Ping {
  private String url;
  private Timer timer = new Timer();
  private Trigger pongTrigger = new Trigger();

  public Ping(String url) {
    this.url = url;
  }

  public void start() throws IOException {
    pingForever(60*1000); // every minute
  }

  private void pingForever(long period) throws IOException {
    timer.scheduleAtFixedRate(new TimerTask() {
      public void run() {
        try {
          ping();
        } catch (Throwable e) {
          e.printStackTrace();
        }
      }
    }, 0, period);
  }

  private void ping() throws IOException {
    System.out.println(url);
    URLConnection connection = new URL(url).openConnection();
    String response = StreamUtil.readFully(connection.getInputStream());
    System.out.println("Server response: " + response);
    pongTrigger.trigger();
  }

  public void stop() {
    timer.cancel();
  }

  public Trigger getPongTrigger() {
    return pongTrigger;
  }
}
