package prophecy.mcos.mcos01;

import prophecy.common.FrozenObject;
import prophecy.m.m13.Unfreezer;
import drjava.util.Tree;
import drjava.util.TreeUtil;

public class CounterProcess extends ProcessImpl {
  private int counterValue;

  public void step() {
    ++counterValue;
    env.print("Counter value: " + counterValue);
    env.idleFor(1.0);
  }

  // persistence methods follow

  private Tree toTree() {
    return new Tree().add("counterValue", counterValue);
  }

  protected void fromTree(Tree tree) {
    counterValue = tree.getInt("counterValue");
  }

  public FrozenObject freeze() {
    return new FrozenObject(Unfreeze.class, toTree());
  }

  public static class Unfreeze implements Unfreezer {
    public Object unfreeze(String data) {
      Tree tree = TreeUtil.textToTree(data);
      CounterProcess counter = new CounterProcess();
      counter.fromTree(tree);
      return counter;
    }
  }

  // other methods

  public int getCounterValue() {
    return counterValue;
  }
}