package prophecy.mcos.mcos01;

import prophecy.common.FrozenObject;
import prophecy.common.Var;
import prophecy.common.SequenceNumber;

public abstract class ProcessImpl implements Process {
  protected Env env;
  private Var<String> name = new Var<String>("");
  protected Var<Boolean> running = new Var<Boolean>(false);
  protected boolean dead;
  protected long id;

  public ProcessImpl() {
    // we use global ids for simplicity
    id = SequenceNumber.newSequenceNumber();
  }

  public void init(Env env) {
    this.env = env;
  }

  public FrozenObject freeze() {
    return null;
  }

  public boolean isRunning() {
    return running.get();
  }

  public void setRunning(boolean running) {
    this.running.set(running);
  }

  public String getName() {
    return name.get();
  }

  public void setName(String name) {
    this.name.set(name);
  }

  public boolean isDead() {
    return dead;
  }

  protected void diePeacefully() {
    dead = true;
    env.requestTermination();
  }

  public void doStep() {
    if (dead)
      throw new RuntimeException("Trying to step dead process: " + this);
    step();
  }

  public long getId() {
    return id;
  }

  public void setId(long id) {
    this.id = id;
  }

  public abstract void step();
}
