package prophecy.mcos.mcos02;

import prophecy.common.FrozenObject;
import prophecy.m.m13.Unfreezer;

import java.awt.*;

import drjava.util.Tree;
import drjava.util.TreeUtil;
import drjava.util.LetterLayout;

import javax.swing.*;

public class ExampleGuiProcess extends SingleFrameGui implements GuiProcess {
  Rectangle frameBounds;

  public void makeFrame() {
    frame = guiEnv.makeFrame(getName() + " [ExampleGuiProcess]");

    JPanel panel = new JPanel(LetterLayout.centeredRow());
    JLabel hello = new JLabel("Hello world!");
    hello.setFont(new Font("Arial", Font.PLAIN, 24));
    panel.add(hello);
    guiEnv.getContentPane(frame).add(panel);

    if (frameBounds != null)
      frame.setBounds(frameBounds);
    else {
      frame.setSize(250, 140);
      guiEnv.centerOnScreen(frame);
      int ofs = (int) (Math.random()*40)-20;
      frame.setLocation(frame.getX()+ofs, frame.getY()+ofs);
    }
  }

  // persistence methods follow

  private Tree toTree() {
    Tree tree = new Tree();
    if (frame != null)
      tree.set("bounds", boundsToTree(frame.getBounds()));
    tree.set("name", getName());
    return tree;
  }

  private Tree boundsToTree(Rectangle r) {
    return new Tree().set("x", r.x).set("y", r.y).set("w", r.width).set("h", r.height);
  }

  private Rectangle boundsFromTree(Tree tb) {
    return new Rectangle(tb.getInt("x"), tb.getInt("y"), tb.getInt("w"), tb.getInt("h"));
  }

  protected void fromTree(Tree t) {
    setName(t.getString("name", ""));
    Tree tb = t.get("bounds");
    if (tb != null) {
      frameBounds = boundsFromTree(tb);
      guiVisibleOnStartup = true;
    }
  }

  public FrozenObject freeze() {
    return new FrozenObject(Unfreeze.class, toTree());
  }

  public static class Unfreeze implements Unfreezer {
    public Object unfreeze(String data) {
      Tree tree = TreeUtil.textToTree(data);
      ExampleGuiProcess sgp = new ExampleGuiProcess();
      sgp.fromTree(tree);
      return sgp;
    }
  }
}
