/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.mcos.mcos02;

import drjava.util.SwingTimerHelper;
import drjava.util.Updatable;

import javax.swing.*;
import java.awt.*;

public abstract class JCounter extends JLabel implements Updatable {
  private long lastValue = -1;
  private static final int refreshInterval = 100;

  public JCounter() {
    super(" ", JLabel.CENTER);
    setFont(new Font("Courier New", Font.BOLD, 48));

    new SwingTimerHelper(this, refreshInterval).installOn(this);
  }

  public void update() {
    long currentNumber = getValue();
    if (currentNumber != lastValue) {
      lastValue = currentNumber;
      setNumber(currentNumber);
    }
  }

  public abstract long getValue();

  protected void setNumber(long currentNumber) {
    setText(String.valueOf(currentNumber));
  }
}