package prophecy.mcos.mcos02;

import drjava.util.GUIUtil;

import javax.swing.*;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.*;

public class TopLevelGuiEnv implements GuiEnv {
  public Container makeFrame(String title) {
    return new JFrame(title);
  }

  public void showFrame(Container frame) {
    GUIUtil.showFrame((JFrame) frame);
  }

  public void disposeFrame(Container frame) {
    ((JFrame) frame).dispose();
  }

  public void centerOnScreen(Container frame) {
    GUIUtil.centerOnScreen((JFrame) frame);
  }

  public void onClosing(Container frame, final Runnable runnable) {
    ((JFrame) frame).addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent e) {
        runnable.run();
      }
    });
  }

  public Container getContentPane(Container frame) {
    return ((JFrame) frame).getContentPane();
  }


  public void setClosable(Container frame, boolean closable) {
    // we ignore this, there is no JFrame.setClosable()
  }

  public void pack(Container frame) {
    ((JFrame) frame).pack();
  }
}
