package prophecy.mcos.mcos03;

import drjava.util.LetterLayout;
import prophecy.mcos.mcos02.SingleFrameGui;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class GPBootDialog extends SingleFrameGui {
  private BootDialogListener listener;
  private boolean continueEnabled;

  public GPBootDialog(BootDialogListener listener, boolean continueEnabled) {
    this.listener = listener;
    this.continueEnabled = continueEnabled;
    setTerminateOnWindowClose(true);
  }

  @Override
  protected void makeFrame() {
    frame = guiEnv.makeFrame("Boot Dialog");
    guiEnv.setClosable(frame, false);
    frame.setSize(300, 100);
    JPanel panel = new JPanel(new LetterLayout("AA BB").setBorder(10));
    JButton btnNew = new JButton("New session");
    panel.add("A", btnNew);
    JButton btnContinue = new JButton("Continue session");
    btnContinue.setEnabled(continueEnabled);
    panel.add("B", btnContinue);
    btnNew.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        listener.selectionMade(0);
      }
    });
    btnContinue.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        listener.selectionMade(1);
      }
    });
    guiEnv.getContentPane(frame).add(panel);
    guiEnv.pack(frame);
    guiEnv.centerOnScreen(frame);
  }
}