package prophecy.mcos.mcos03;

import drjava.util.NoResult;
import drjava.util.Result;
import prophecy.common.FrozenObject;
import prophecy.common.Var;
import prophecy.mcos.mcos01.ProcessImpl;
import prophecy.mcos.mcos02.ProcessArray;

public class HibernaterProcess extends ProcessImpl {
  private ProcessArray array;
  private Var<Result<FrozenObject>> result = new Var<Result<FrozenObject>>();

  public HibernaterProcess(ProcessArray array) {
    this.array = array;
  }

  // just one step, then terminate
  public void step() {
    try {
      FrozenObject frozenObject = array.freeze();
      result.set(new Result<FrozenObject>(frozenObject));
    } catch (Throwable t) {
      result.set(new NoResult<FrozenObject>(t));
    }
    diePeacefully();
  }

  public Result<FrozenObject> getResult() {
    return result.get();
  }

  public boolean done() {
    return result.get() != null;
  }

  /** convert hibernater to empty process on unfreezing */
  public FrozenObject freeze() {
    return new EmptyProcess().freeze();
  }
}
