package prophecy.mcos.mcos04;

import drjava.util.TextView;
import drjava.util.SwingTimerHelper;
import prophecy.mcos.mcos02.SingleFrameGui;
import prophecy.mcos.mcos02.JCounter;

import javax.swing.*;
import java.lang.management.ThreadMXBean;
import java.lang.management.ManagementFactory;
import java.awt.*;
import java.text.DecimalFormat;

public class GPCPUMeter extends SingleFrameGui {
  private Thread threadToMonitor;

  public GPCPUMeter(Thread threadToMonitor) {
    this.threadToMonitor = threadToMonitor;
    setTerminateOnWindowClose(true);
  }

  @Override
  protected void makeFrame() {
    frame = guiEnv.makeFrame("CPU Meter");
    frame.setSize(300, 100);

    final JLabel display = new JLabel(" ", JLabel.CENTER);
    //display.setFont(new Font("Courier New", Font.BOLD, 12));

    new SwingTimerHelper(new Runnable() {
      public void run() {
        if (threadToMonitor == null) return;
        ThreadMXBean threadMXBean = ManagementFactory.getThreadMXBean();
        double time = threadMXBean.getThreadUserTime(threadToMonitor.getId()) * 1e-9;
        display.setText("user time: " + new DecimalFormat("#.####").format(time) + " s");
      }
    }, 100).installOn(display);

    guiEnv.getContentPane(frame).add(display);
    guiEnv.centerOnScreen(frame);
  }
}