package prophecy.mcos.mcos04;

import drjava.util.Attachments;

import java.awt.*;
import java.awt.event.KeyEvent;

public class KeyEventHelper {
  private static boolean installed;

  public static void install() {
    if (!installed) {
      KeyboardFocusManager.getCurrentKeyboardFocusManager().addKeyEventPostProcessor(new KeyEventPostProcessor() {
        public boolean postProcessKeyEvent(KeyEvent e) {
          Window window = KeyboardFocusManager.getCurrentKeyboardFocusManager().getActiveWindow();
          KeyEventPostProcessor postProcessor = Attachments.get(window, KeyEventPostProcessor.class);

          if (postProcessor != null)
            return postProcessor.postProcessKeyEvent(e);
          else
            return false;
        }
      });
      installed = true;
    }
  }
}
