package prophecy.mcos.mcos05;

import prophecy.mcos.mcos02.SingleFrameGui;
import prophecy.common.Var;
import prophecy.common.gui.SexyTableModel;
import prophecy.common.gui.SexyColumn;

import javax.swing.*;

import drjava.util.SwingTimerHelper;
import drjava.util.Updatable;
import drjava.util.Lizt;

import java.util.List;

/**
 * A task monitor application. Relies on PTaskReporter for gathering information.
 */
public class GPTaskMonitor extends SingleFrameGui implements Updatable {
  private final static int refreshInterval = 500;
  private Var<Lizt<TaskInfo>> reportInput = new Var<Lizt<TaskInfo>>();
  private SexyTableModel<TaskInfo> tableModel;
  private JTable table;

  public GPTaskMonitor() {
    setTerminateOnWindowClose(true);
    // TODO: dispose task reporter on window close
  }

  protected void makeFrame() {
    setName("Task monitor");
    frame = guiEnv.makeFrame("Task monitor");
    frame.setSize(500, 400);

    tableModel = new SexyTableModel<TaskInfo>(
      new ColId(), new ColName(), new ColMainClass());

    table = new JTable(tableModel);
    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    table.getColumnModel().getColumn(0).setPreferredWidth(70); // process id
    table.getColumnModel().getColumn(1).setPreferredWidth(150); // process name
    table.getColumnModel().getColumn(2).setPreferredWidth(300); // class name

    new SwingTimerHelper(this, refreshInterval).installOn(table);

    guiEnv.getContentPane(frame).add(new JScrollPane(table));
    guiEnv.centerOnScreen(frame);
  }

  /** this is called in Swing thread */
  public void update() {
    List<TaskInfo> list = reportInput.get();
    tableModel.setList(list);
  }

  public Var<Lizt<TaskInfo>> getReportInput() {
    return reportInput;
  }

  class ColId extends SexyColumn<TaskInfo> {
    public String getName() {
      return "ID";
    }

    public Object getCell(int row, TaskInfo entry) {
      return entry.id;
    }
  }

  class ColName extends SexyColumn<TaskInfo> {
    public String getName() {
      return "Name";
    }

    public Object getCell(int row, TaskInfo entry) {
      return entry.name;
    }
  }

  class ColMainClass extends SexyColumn<TaskInfo> {
    public String getName() {
      return "Main class";
    }

    public Object getCell(int row, TaskInfo entry) {
      return entry.mainClass;
    }
  }
}
