package prophecy.mcos.mcos05;

import prophecy.mcos.mcos01.*;
import prophecy.mcos.mcos01.Process;
import prophecy.mcos.mcos02.ProcessArray;
import prophecy.common.Var;
import drjava.util.Lizt;

import java.util.List;
import java.util.ArrayList;

/**
 * A non-GUI process that makes an up-to-date task list and reports it to GPTaskMonitor
 */
public class PTaskReporter extends ProcessImpl {
  /** a bit more often than GPTaskMonitor reads it - yes, we're generous */
  private final double refreshInterval = 0.4;

  private Var<Lizt<TaskInfo>> reportTarget;
  private ProcessArray processArray;

  public Var<Lizt<TaskInfo>> getReportTarget() {
    return reportTarget;
  }

  public void setReportTarget(Var<Lizt<TaskInfo>> reportTarget) {
    this.reportTarget = reportTarget;
  }

  public ProcessArray getProcessArray() {
    return processArray;
  }

  public void setProcessArray(ProcessArray processArray) {
    this.processArray = processArray;
  }

  public void step() {
    if (processArray != null && reportTarget != null) {
      List<TaskInfo> list = new ArrayList<TaskInfo>();

      // assume that process array and task reporter run in same thread
      Lizt<Process> processes = processArray.getProcesses();
      for (Process process : processes) {
        TaskInfo info = new TaskInfo(process.getId(), process.getName());
        info.setProcess(process);
        info.mainClass = process.getClass().getName();
        list.add(info);
      }

      reportTarget.set(new Lizt<TaskInfo>(list));
    }

    env.idleFor(refreshInterval);
  }
}
