package prophecy.mcos.mcos05;

import drjava.util.Errors;
import prophecy.mcos.mcos04.InheritableMain;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class TwinOS extends InheritableMain {
  public static void main(String[] args) {
    Errors.setPopup(true);
    TwinOS os1 = new TwinOS(1);
    TwinOS os2 = new TwinOS(2);
    os1.start();
    int spacing = 40, shiftY = -80;
    os1.getFrame().setLocation(os1.getFrame().getX()-(os1.getFrame().getWidth()+spacing)/2,
      os1.getFrame().getY()-shiftY/2);
    os2.start();
    os2.getFrame().setLocation(os1.getFrame().getX()+os1.getFrame().getWidth()+spacing,
      os2.getFrame().getY()+shiftY/2);
  }

  public TwinOS(int twinNr) {
    setVersion("0.2" + " - twin " + twinNr);
  }

  @Override
  protected void fillStartMenu(JPopupMenu menu) {
    super.fillStartMenu(menu);
    if (isBootScreen()) return;

    // add the stuff backwards, on top of the menu
    menu.add(new JPopupMenu.Separator(), 0);

    JMenuItem mi = new JMenuItem("Task monitor");
    mi.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try {
          startTaskMonitor();
        } catch (Throwable t) {
          Errors.report(t);
        }
      }
    });
    menu.add(mi, 0);
  }

  private void startTaskMonitor() {
    GPTaskMonitor taskMonitor = new GPTaskMonitor();
    PTaskReporter taskReporter = new PTaskReporter();
    taskReporter.setReportTarget(taskMonitor.getReportInput());
    taskReporter.setProcessArray(getProcessArray());
    startGuiProcess(taskMonitor);
    startProcess(taskReporter);
  }
}