/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.setup;

import drjava.util.ObjectUtil;
import static drjava.util.ObjectUtil.nice;

public class ExpectedValue extends TestResult {
  private Object expectedValue;
  private Object subjectProvidedValue;

  public ExpectedValue(Object test, Object subject, Object expectedValue, Object subjectProvidedValue) {
    super(test, subject, ObjectUtil.equal(expectedValue, subjectProvidedValue));
    this.expectedValue = expectedValue;
    this.subjectProvidedValue = subjectProvidedValue;
  }

  public String toString() {
    return super.toString() + " (expected: " + nice(expectedValue) + ", was: " + nice(subjectProvidedValue) + ")";
  }
}