/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.setup;

import drjava.util.Lizt;

public class OperationModellingTest implements Test<OperationModellingSubject> {
  private WorkspaceFactory factory = new WorkspaceFactory();
  private Lizt<Operation> allOperations;
  private final Lizt<Operation> operations;

  public OperationModellingTest(Lizt<Operation> allOperations, Lizt<Operation> operations) {
    this.allOperations = allOperations;
    this.operations = operations;
  }

  public TestResult test(OperationModellingSubject subject) {
    subject.setWorkspaceFactory(factory);
    subject.setAllOperations(allOperations);
    Model model = subject.createModel();

    Workspace workspace = factory.make();
    for (Operation operation : operations)
      operation.run(workspace);
    String realValue = workspace.getValue();
    try {
      WorkspaceImpl.workspacesEnabled = false;
      String value = model.predictValue(operations);
      return new ExpectedValue(this, subject, realValue, value);
    } finally {
      WorkspaceImpl.workspacesEnabled = true;
    }
  }
}