/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.setup;

import drjava.util.Display;
import drjava.util.Displayable;
import drjava.util.Lizt;

public class TestBatteryResult extends TestResult implements Displayable {
  private final Lizt<TestResult> testResults;

  TestBatteryResult(Object test, Object subject, Lizt<TestResult> testResults) {
    super(test, subject, allPassed(testResults));
    this.testResults = testResults;
  }

  private static boolean allPassed(Lizt<TestResult> testResults) {
    for (TestResult testResult : testResults) {
      if (!testResult.isPassed())
        return false;
    }
    return true;
  }

  public void display(Display display) {
    display.putnl(toString());
    display.indent();
    for (TestResult testResult : testResults) {
      display.putnl(testResult);
    }
    display.unindent();
  }
}