/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.setup;

import static drjava.util.ObjectUtil.nice;

public class TestResult {
  private Object subject;
  private Object test;
  private boolean passed;

  TestResult(Object test, Object subject, boolean passed) {
    this.subject = subject;
    this.test = test;
    this.passed = passed;
  }

  public Object getSubject() {
    return subject;
  }

  public Object getTest() {
    return test;
  }

  public boolean isPassed() {
    return passed;
  }

  public String toString() {
    return (passed ? "PASSED" : "FAILED") + ": " + nice(subject) + " in " + nice(test);
  }
}