/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.setup;

public class WorkspaceImpl implements Workspace {
  private String value = "";
  private static Operation clear = new Clear();
  private static Operation appendR = new AppendR();
  static boolean workspacesEnabled = true;

  WorkspaceImpl() {
    checkEnabled();
  }

  WorkspaceImpl(String value) {
    checkEnabled();
    this.value = value;
  }

  public String getValue() {
    return value;
  }

  public void setValue(String value) {
    checkEnabled();
    this.value = value;
  }

  private void checkEnabled() {
    if (!workspacesEnabled)
      throw new RuntimeException("disabled");
  }

  public Workspace clone() {
    return new WorkspaceImpl(value);
  }
}