/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.subject2;

import drjava.util.Lizt;
import prophecy.common.StdOutRecorder;
import prophecy.n.n01.setup.Model;
import prophecy.n.n01.setup.Operation;
import prophecy.n.n01.setup.N01Tests;
import prophecy.n.n01.setup.Workspace;
import prophecy.n.n01.subject3.AbstractOperationModellingSubject;

import java.util.HashMap;
import java.util.Map;

public class Subject2 extends AbstractOperationModellingSubject implements Model {
  private String emptyWorkspaceValue;
  private Map<Class, String> operationResults = new HashMap<Class, String>();

  public Model createModel() {
    Workspace workspace = workspaceFactory.make();
    emptyWorkspaceValue = workspace.getValue();
    for (Operation operation : allOperations) {
      workspace = workspaceFactory.make();
      operation.run(workspace);
      operationResults.put(operation.getClass(), workspace.getValue());
    }
    return this;
  }

  public String predictValue(Lizt<Operation> operationSequence) {
    if (operationSequence.isEmpty())
      return emptyWorkspaceValue;
    else
      return operationResults.get(operationSequence.get(0).getClass());
  }

  public static void main(String[] args) {
    StdOutRecorder.recordAndFileUnder(Subject2.class);
    N01Tests.runTests(new Subject2());
  }
}