/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.subject3;

import java.util.Map;

public class DuplexWeb<Node, Via> extends Web<Node, Via> {
  private Web<Node, Via> reverseWeb = new Web<Node,Via>();

  public void link(Node src, Via via, Node dest) {
    super.link(src, via, dest);
    reverseWeb.link(dest, via, src);
  }

  public Node followReverseLink(Node dest, Via via) {
    return reverseWeb.followLink(dest, via);
  }

  public Map<Via, Node> getReverseLinkMap(Node dest) {
    return reverseWeb.getLinkMap(dest);
  }
}