package prophecy.n.n01.subject3;

import drjava.util.Lizt;
import prophecy.n.n01.setup.Model;
import prophecy.n.n01.setup.Operation;

import java.util.Map;
import java.util.HashMap;

public class S3Model implements Model {
  String emptyWorkspaceValue;
  DuplexWeb<String, Class> web = new DuplexWeb<String, Class>();
  Map<String, DynamicState> dynamicStates = new HashMap<String, DynamicState>();

  public String predictValue(Lizt<Operation> operationSequence) {
    String state = emptyWorkspaceValue;
    for (Operation operation : operationSequence) {
      String newState = web.followLink(state, representOperation(operation));
      if (newState == null) {
        DynamicState dynamicState = dynamicStates.get(state);
        if (dynamicState != null)
          newState = dynamicState.getLinkMap().get(representOperation(operation));
      }
      if (newState == null)
        return null;
      state = newState;
    }
    return state;
  }

  static Class representOperation(Operation operation) {
    return operation.getClass();
  }

  public DuplexWeb<String, Class> getWeb() {
    return web;
  }
}
