/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.subject3;

import prophecy.t.t12.Event;
import prophecy.common.Trigger;

import java.util.List;
import java.util.ArrayList;

import drjava.util.Lizt;
import static drjava.util.ObjectUtil.nice;

public class SequenceAnalysisRequest extends Event {
  private Lizt<String> sequence;
  private List<SequenceModel> models = new ArrayList<SequenceModel>();
  private Trigger newModelTrigger = new Trigger();

  public SequenceAnalysisRequest(List<String> sequence) {
    this.sequence = new Lizt<String>(sequence);
  }

  public Lizt<String> getSequence() {
    return sequence;
  }

  public String toString() {
    return nice(getClass()) + " " + nice(sequence);
  }

  public void addModel(SequenceModel model) {
    models.add(model);
    newModelTrigger.trigger();
  }

  public List<SequenceModel> getModels() {
    return models;
  }

  public Trigger getNewModelTrigger() {
    return newModelTrigger;
  }
}