package prophecy.n.n01.subject3;

import drjava.util.Lizt;
import drjava.util.Port;

import java.util.Set;
import java.util.TreeSet;

public class SequenceAnalyzer implements Port<SequenceAnalysisRequest> {
  public void receive(SequenceAnalysisRequest sequenceAnalysisRequest) {
    Lizt<String> sequence = sequenceAnalysisRequest.getSequence();
    if (sequence.size() < 3) return;
    System.out.println("Analyzing sequence");
    Set<String> suffixSet = new TreeSet<String>();
    for (int i = 0; i < sequence.size()-1; i++) {
      String a = sequence.get(i), b = sequence.get(i+1);
      if (!b.startsWith(a)) return;
      suffixSet.add(b.substring(a.length()));
    }
    if (suffixSet.size() == 1) {
      String suffix = suffixSet.iterator().next();
      System.out.println("Append sequence found (suffix=" + suffix + ")");
      sequenceAnalysisRequest.addModel(new AppendSequence(sequence.get(0), suffix));
    }
  }
}
