/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.n.n01.subject3;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class Web<Node, Via> {
  private Map<Node, Map<Via, Node>> map = new HashMap<Node, Map<Via,Node>>();

  public void link(Node src, Via via, Node dest) {
    Map<Via, Node> linkMap = map.get(src);
    if (linkMap == null)
      map.put(src, linkMap = new HashMap<Via,Node>());
    linkMap.put(via, dest);
  }

  public Node followLink(Node src, Via via) {
    Map<Via, Node> linkMap = map.get(src);
    if (linkMap != null)
      return linkMap.get(via);
    return null;
  }

  public Map<Via, Node> getLinkMap(Node src) {
    Map<Via, Node> linkMap = map.get(src);
    return linkMap != null ? Collections.unmodifiableMap(linkMap)
      : Collections.<Via, Node> emptyMap();
  }
}