package prophecy.n.n04;

import static drjava.util.ObjectUtil.nice;

import javax.script.ScriptContext;
import javax.script.ScriptEngine;
import javax.script.ScriptException;

public class BshTextMapperRunner {
  private String script;
  private TextMapper textMapper;

  public BshTextMapperRunner(String script) {
    this.script = script;

    Object result;
    try {
      result = ScriptLanguage.getBeanShell().eval(
        "import " + TextMapper.class.getName() + ";\n" + script);
    } catch (Throwable e) {
      return;
    }

    if (result instanceof TextMapper)
      textMapper = (TextMapper) result;
    else if (result instanceof Class)
      try {
        textMapper = (TextMapper) ((Class) result).newInstance();
      } catch (Exception e) {
        throw new RuntimeException(e);
      }
  }

  public TextMapper getTextMapper() {
    if (textMapper != null)
      return textMapper;

    return new TextMapper() {
      public String get(String input) {
        try {
          ScriptEngine scriptEngine = ScriptLanguage.getBeanShell().makeEngine();
          scriptEngine.getBindings(ScriptContext.ENGINE_SCOPE).put("input", input);
          final Object result = scriptEngine.eval(
            "import " + TextMapper.class.getName() + ";\n" + script);
          if (!(result instanceof String))
            throw new RuntimeException("Unknown result type: " + nice(result));
          return (String) result;
        } catch (ScriptException e) {
          throw new RuntimeException(e);
        }
      }
    };
  }
}
