package prophecy.n.n04;

import drjava.util.XTestCase;

public class BshTextMapperRunnerTest extends XTestCase {
  public void testStringConst() {
    TextMapper textMapper = new BshTextMapperRunner("\"bla\"").getTextMapper();
    assertEquals("bla", textMapper.get("hallo"));
    assertEquals("bla", textMapper.get("schwallo"));
  }

  public void testAnonymousClass() {
    TextMapper textMapper = new BshTextMapperRunner("new TextMapper() {" +
      "public String get(String input) { return input + input; } }").getTextMapper();
    assertEquals("hallohallo", textMapper.get("hallo"));
    assertEquals("schwalloschwallo", textMapper.get("schwallo"));
  }

  public void testClassDecl() {
    TextMapper textMapper = new BshTextMapperRunner("class Mappy implements TextMapper {" +
      "public String get(String input) { return input + input; } }").getTextMapper();
    assertEquals("hallohallo", textMapper.get("hallo"));
    assertEquals("schwalloschwallo", textMapper.get("schwallo"));
  }

  public void testInputVar() {
    TextMapper textMapper = new BshTextMapperRunner("input + \"*\"").getTextMapper();
    assertEquals("hallo*", textMapper.get("hallo"));
    assertEquals("schwallo*", textMapper.get("schwallo"));
  }

  public void testInputVar2() {
    TextMapper textMapper = new BshTextMapperRunner("input + input").getTextMapper();
    assertEquals("hallohallo", textMapper.get("hallo"));
    assertEquals("schwalloschwallo", textMapper.get("schwallo"));
  }
}
