package prophecy.n.n04;

import prophecy.common.gui.SexyTable;
import prophecy.common.gui.SexyColumn;

import javax.swing.table.TableModel;
import javax.swing.event.TableModelListener;
import javax.swing.event.TableModelEvent;

public class EditableInOutTable extends SexyTable<InOutPair> {
  public EditableInOutTable() {
    setColumns(new ColIn(), new ColOut());
    addEmptyRow();
  }

  private class ColIn extends SexyColumn<InOutPair> {
    public String getName() {
      return "Input";
    }

    public Object getCell(int row, InOutPair inOutPair) {
      return inOutPair.getInput();
    }

    public boolean isCellEditable(int row, InOutPair entry) {
      return true;
    }

    public void setValueAt(int row, InOutPair item, Object value) {
      getModel().setItem(row, new InOutPair((String) value, item.getOutput()));
    }
  }

  private class ColOut extends SexyColumn<InOutPair> {
    public String getName() {
      return "Output";
    }

    public Object getCell(int row, InOutPair inOutPair) {
      return inOutPair.getOutput();
    }

    public boolean isCellEditable(int row, InOutPair entry) {
      return true;
    }

    public void setValueAt(int row, InOutPair item, Object value) {
      getModel().setItem(row, new InOutPair(item.getInput(), (String) value));
    }
  }

  private void addEmptyRow() {
    if (getModel().getRowCount() == 0
      || !isEmpty(getModel().getItem(getModel().getRowCount()-1)))
      getModel().addItem(new InOutPair("", ""));
  }

  private boolean isEmpty(InOutPair inOutPair) {
    return "".equals(inOutPair.getInput()) && "".equals(inOutPair.getOutput());
  }

  public void setModel(TableModel dataModel) {
    super.setModel(dataModel);
    getModel().addTableModelListener(new TableModelListener() {
      public void tableChanged(TableModelEvent e) {
        addEmptyRow();
      }
    });
  }
}
