package prophecy.n.n04;

import prophecy.common.PersistentTree;

import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.awt.*;
import java.io.File;

public class LoadSaveAgent {
  private PersistentTree persistentTree;
  private String extension;

  public LoadSaveAgent(PersistentTree persistentTree, String extension) {
    this.persistentTree = persistentTree;
    this.extension = extension;
  }

  public File showOpenDialog(Component parent) {
    JFileChooser fileChooser = makeFileChooser();
    if (fileChooser.showOpenDialog(parent) == JFileChooser.APPROVE_OPTION) {
      return fileSelected(fileChooser);
    }
    return null;
  }

  private JFileChooser makeFileChooser() {
    String dir = persistentTree.getString("lastDir", new File("").getAbsolutePath());
    JFileChooser fileChooser = new JFileChooser(dir);
    fileChooser.setFileFilter(makeFileFilter());
    return fileChooser;
  }

  public File showSaveDialog(Component parent) {
    JFileChooser fileChooser = makeFileChooser();
    if (fileChooser.showSaveDialog(parent) == JFileChooser.APPROVE_OPTION) {
      return fileSelected(fileChooser);
    }
    return null;
  }

  private File fileSelected(JFileChooser fileChooser) {
    File file = fileChooser.getSelectedFile();
    if (file != null) {
      persistentTree.setString("lastDir", file.getParent());
      persistentTree.save();
    }
    return file;
  }

  private FileFilter makeFileFilter() {
    return new FileNameExtensionFilter(extension, extension);
  }
}
