package prophecy.n.n04;

import prophecy.p.p02.SelfTestable;
import prophecy.p.p02.SelfTestResult;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

public class ScriptLanguage implements SelfTestable {
  private String jsr223Name;
  private String publicName;
  private String fileExtension;
  private String testScript;

  public ScriptLanguage(String jsr223Name, String publicName, String fileExtension,
                        String testScript) {
    this.jsr223Name = jsr223Name;
    this.publicName = publicName;
    this.fileExtension = fileExtension;
    this.testScript = testScript;
  }

  public String getJsr223Name() {
    return jsr223Name;
  }

  public String getPublicName() {
    return publicName;
  }

  public String getFileExtension() {
    return fileExtension;
  }

  public Object eval(String source) {
    try {
      return makeEngine().eval(source);
    } catch (ScriptException e) {
      throw new RuntimeException(e);
    }
  }

  public ScriptEngine makeEngine() throws ScriptException {
    ScriptEngine engine = new ScriptEngineManager().getEngineByName(jsr223Name);
    if (engine == null)
      throw new ScriptException("Engine \"" + jsr223Name + "\" not found");
    return engine;
  }

  public static ScriptLanguage getJavaScript() {
    return new ScriptLanguage("js", "JavaScript", "js", "5");
  }

  public static ScriptLanguage getBeanShell() {
    return new ScriptLanguage("beanshell", "BeanShell", "bsh", "return 5;");
  }

  public SelfTestResult selfTest() {
    try {
      return new SelfTestResult(this, new Integer(5).equals(makeEngine().eval(testScript)));
    } catch (ScriptException e) {
      return new SelfTestResult(this, e);
    }
  }

  public String toString() {
    return publicName;
  }
}
