/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.omnivore.o.o01;

import drjava.util.GUIUtil;

public class AskUserFinder implements Finder {
  private ScriptEnv scriptEnv;

  public AskUserFinder(ScriptEnv scriptEnv) {
    this.scriptEnv = scriptEnv;
  }

  /** current thread must be blockable (e.g., not Swing event thread) 
   * @param search*/
  public Object find(Search search) {
    FinderFrame finderFrame = new FinderFrame(search);
    GUIUtil.showFrame(finderFrame);

    search.getDoneFlag().waitUntilUp();
    if (search.getImplementation() == null)
      throw new SearchCancelledException(search);
    return search.getImplementation();
  }
}