/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.omnivore.o.o01;

import drjava.util.MultiMap;

import java.util.List;

public class Finder1 implements Finder {
  private MultiMap<String, Finder> findersByClass = new MultiMap<String, Finder>();

  public Object find(Search search) {
    Class specClass = search.getClass();
    List<Finder> finders = findersByClass.get(specClass.getName());
    for (Finder finder : finders) {
      Object result = finder.find(search);
      if (result != null)
        return result;
    }
    return null;
  }
}