/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.omnivore.o.o01;

import drjava.util.GUIUtil;
import drjava.util.Line;
import drjava.util.Errors;
import prophecy.common.gui.Form;
import prophecy.common.gui.JObject;
import prophecy.common.gui.Sheet;
import prophecy.m.m37.JBag;
import prophecy.t.t08.Bag;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class FinderFrame extends JFrame {
  private JButton btnAccept;
  private JReplaceableObject impl;
  private Search search;

  public FinderFrame(final Search search) {
    this.search = search;
    setTitle("Help!");
    Sheet sheet = new Sheet();
    Form form = new Form();
    form.addRow("Asker:", new JObject(search.getRequestor()));
    form.addRow("Question:", new JObject(search.getSpec()));
    impl = new JReplaceableObject();
    form.addSpacer();
    form.addRow("Your answer:", impl);
    form.addSpacer();
    btnAccept = new JButton("Submit answer");
    impl.getNewObjectTrigger().addListener(new Runnable() {
      public void run() {
        update();
      }
    });
    btnAccept.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        search.submitAnswer(impl.getObject());
        dispose();
      }
    });

    JButton btnCancel = new JButton("Cancel");
    btnCancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        search.cancel();
        dispose();
      }
    });

    form.addRow(null, new Line(btnAccept, btnCancel));
    sheet.addComponent(form);

    JBag suggestions = new JBag(getSuggestions());
    sheet.addComponent(GUIUtil.withTitle("Suggestions",
      GUIUtil.setMinimumHeight(new JScrollPane(suggestions), 100)));

    JComponent sheetComponent = sheet.asComponent();
    GUIUtil.setMinimumWidth(sheetComponent, 300);
    getContentPane().add(sheetComponent);
    update();
    pack();
  }

  private Bag<Object> getSuggestions() {
    try {
      return StandardAdvisor.getInstance().getSuggestions(search);
    } catch (Throwable e) {
      Errors.add(e);
      return new Bag<Object>();
    }
  }

  private void update() {
    //btnAccept.setEnabled(impl.getObject() != null);
  }
}