/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.omnivore.o.o01;

import java.util.ArrayList;
import java.util.List;

public class MultiFinder implements Finder {
  private List<Finder> finders = new ArrayList<Finder>();

  public void addFinder(Finder finder) {
    finders.add(finder);
  }

  public Object find(Search search) {
    for (Finder finder : finders) {
      Object result = finder.find(search);
      if (result != null)
        return result;
    }
    return null;
  }
}