/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.omnivore.o.o01;

public class OmnivoreScript {
  private Finder finder;

  public OmnivoreScript(ScriptEnv env) {
    finder = env.getDefaultFinder();
  }

  public Object find(Spec spec) {
    return finder.find(new Search(spec, this));
  }
  
  public Object run(Object object) {
    return find(new RunSpec(object));
  }

  public <C> C cast(Object object, Class<C> targetClass) {
    return (C) find(new CastSpec(object, targetClass));
  }
}