/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.omnivore.o.o01;

import prophecy.common.Flag;

public class Search {
  private Spec spec;
  private Object requestor;
  private Flag doneFlag = new Flag();
  private Object implementation;
  private boolean hasImplementation;

  public Search(Spec spec, Object requestor) {
    this.spec = spec;
    this.requestor = requestor;
  }

  public Spec getSpec() {
    return spec;
  }

  public Object getRequestor() {
    return requestor;
  }

  public void submitAnswer(Object implementation) {
    this.implementation = implementation;
    hasImplementation = true;
    doneFlag.raise();
  }

  public Flag getDoneFlag() {
    return doneFlag;
  }

  public Object getImplementation() {
    return implementation;
  }

  public void cancel() {
    doneFlag.raise();
  }

  public boolean hasImplementation() {
    return hasImplementation;
  }
}