package prophecy.omnivore.o.o02;

import drjava.util.Bus;
import drjava.util.Sender;

public class ReplaceableObject implements Replaceable {
  private Object replacement;
  private Bus<ReplacementEvent> replacementEventBus = new Bus<ReplacementEvent>();
  private boolean invalid;

  public void setReplacement(Object replacement) {
    this.replacement = replacement;
    replacementEventBus.receive(new ReplacementEvent(this, replacement));
  }

  public Object getReplacement() {
    return replacement;
  }

  public Sender<ReplacementEvent> getReplacementEventSender() {
    return replacementEventBus;
  }

  /** check object validity */
  public void check() {
    if (invalid)
      throw new InvalidObjectException(this);
  }

  public void invalidate() {
    invalid = true;
  }

  public boolean isInvalid() {
    return invalid;
  }
}
