package prophecy.p.p02;

import drjava.util.Tree;
import drjava.util.TreeUtil;
import drjava.util.XTestCase;

public class HashTest extends XTestCase {
  public void testHashSelfTest() {
    Tree tree = new Tree("tree");
    Hash hash = new Hash(tree);
    assertTrue(hash.selfTest().isPassed());
    tree.add("something");
    assertFalse(hash.selfTest().isPassed()); // This may theoretically fail due to hash collision
  }

  public void testHashToTreeFromTree() {
    Hash hash = new Hash("test");
    Tree tree = TreeUtil.objectToTree(hash);
    Hash hash2 = TreeUtil.treeToObject(tree);
    assertEquals(hash.getObject(), hash2.getObject());
    assertEquals(hash.getStoredHashCode(), hash2.getStoredHashCode());
    assertTrue(hash2.selfTest().isPassed());
  }
}
