package prophecy.p.p02;

import static drjava.util.ObjectUtil.nice;

public class SelfTestResult {
  private SelfTestable testedObject;
  private final boolean passed;
  private Throwable exception;

  public SelfTestResult(SelfTestable testedObject, boolean passed) {
    this.testedObject = testedObject;
    this.passed = passed;
  }

  public SelfTestResult(SelfTestable testedObject, Throwable exception) {
    this.testedObject = testedObject;
    passed = false;
    this.exception = exception;
    exception.printStackTrace();
  }

  public SelfTestable getObject() {
    return testedObject;
  }

  public boolean isPassed() {
    return passed;
  }

  public Throwable getException() {
    return exception;
  }

  public static SelfTestResult passed(SelfTestable testedObject) {
    return new SelfTestResult(testedObject, true);
  }

  public static SelfTestResult failed(SelfTestable testedObject) {
    return new SelfTestResult(testedObject, false);
  }

  public static SelfTestResult failed(SelfTestable testedObject, String message) {
    return new SelfTestResult(testedObject, new Throwable(message));
  }

  public static SelfTestResult failed(SelfTestable testedObject, Throwable exception) {
    return new SelfTestResult(testedObject, exception);
  }

  public String toString() {
    return nice(testedObject) + " self-test " + (passed ? "PASSED" : "FAILED");
  }
}