package prophecy.p.p03;

import drjava.util.Errors;
import prophecy.common.Prophecy;
import prophecy.p.p02.ObjectDatabase;

import java.io.File;
import java.io.FileNotFoundException;

public class P03ObjectLoader {
  public static void main(String[] args) {
    Errors.setPopup(true);
    Prophecy.init();

    try {
      if (args.length == 0)
        throw new RuntimeException("Need file name as argument");
      String fileName = args[0];
      File file = new File(fileName);
      if (!file.isFile())
        throw new FileNotFoundException(file.getAbsolutePath());

      loadObject(file);
    } catch (Throwable e) {
      Errors.add(e);
    }
  }

  private static void loadObject(File file) {
    String dbPath = file.getParent();
    ObjectDatabase objectDB = new ObjectDatabase(dbPath);
    String objectName = file.getName();
    Object object = objectDB.loadObject(objectName);
    new ObjectLoadedSheet(object, dbPath, objectName).showFrame();
  }

}
