package prophecy.p.p03;

import prophecy.common.Prophecy;
import prophecy.p.p01.Jar;
import prophecy.p.p01.JarClassLoader;
import prophecy.p.p02.ObjectDatabase;

import java.io.IOException;

public class TestClassUnloading {
  public static void main(String[] args) throws IOException {
    Prophecy.initHeadless();

    /*String jarFile = "temp/p03.jar";
    ProphecyJarMaker.makeJar(jarFile);*/
    ObjectDatabase objectDB = new ObjectDatabase("memory/p02/ObjectDatabase") {
      protected JarClassLoader makeClassLoader(Jar jar) {
        JarClassLoader classLoader = new FinalizingJarClassLoader(jar);
        System.out.println("Classloader " + classLoader + " created");
        return classLoader;
      }
    };

    // If we keep a reference, class loader is not GCed
    /*Object hash =*/ objectDB.loadObject("hash");
    System.gc();
  }

  private static class FinalizingJarClassLoader extends JarClassLoader {
    public FinalizingJarClassLoader(Jar jar) {
      super(jar);
    }

    protected void finalize() throws Throwable {
      super.finalize();
      System.out.println("Classloader " + this + " finalizing");
    }
  }
}
