package prophecy.p.p04;

import drjava.util.GUIUtil;
import static drjava.util.ObjectUtil.nice;
import prophecy.common.ClassData;
import prophecy.common.gui.Form;
import prophecy.common.gui.Sheet;
import prophecy.common.PersistentTree;

import javax.swing.*;

public class ObjectInfoSheet extends Sheet {
  private Converter<JComponent> valueRenderer;

  public ObjectInfoSheet(ObjectInfo objectInfo) {
    createValueRenderer();
    setTitle(nice(objectInfo.getObject()) + " - Object Info");
    Form form = new Form();
    for (ObjectInfo.Item item : objectInfo.getItems()) {
      form.addRow(item.getKey(), valueRenderer.get(item.getValue()));
    }
    GUIUtil.setMinimumWidth(form, 400);
    addComponent(form);
  }

  private void createValueRenderer() {
    PersistentTree tree = ClassData.get(this).subTree("valueRenderer");
    valueRenderer = new AutoConverter<JComponent>(tree, JComponent.class);
  }
}