/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t01;

import drjava.util.FileUtil;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.SocketCallable;
import prophecy.m.m14.Failure;
import prophecy.t.t04.ExUtil2;

import java.io.IOException;

/** a directory manager that talks to its siblings */
public class CooperativeDirManager implements SocketCallable {
  private DirectoryManager dirManager = new DirectoryManager();
  private String dir;

  public void setDir(String dir) {
    Owner.set(dirManager, this);
    this.dir = dir;
    dirManager.setDir(dir);
  }

  public Object install() {
    Object result = dirManager.install();
    if (UnionUtil.contains(result, AlreadyManaged.class)) {
      return new Union(result,
        new AbstractAction("contact") {
          public Object run() {
            return contact();
          }
        });
    }
    return result;
  }

  private Object contact() {
    try {
      String managerInf = FileUtil.loadTextFile(dirManager.getManagerFile());
      Hunter hunter = new Hunter();
      hunter.setInfo(managerInf);
      Object result = ExUtil2.runIfRunnable(hunter.go());
      System.out.println("Contacter result: " + result);
      SocketHandler socketHandler = ExUtil2.convert(result, SocketHandler.class);
      if (socketHandler == null)
        throw new Failure(result);

      // what now?
      return "Contact established (" + hunter.getURL() + ")";
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
  }

  public void takeCall(SocketHandler handler) {
    handler.println("Hi");
  }
}