/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t01;

import drjava.util.FileUtil;
import drjava.util.StringUtil;

import java.io.File;
import java.io.IOException;

public class DirectoryManager {
  private String dir;
  private boolean active;

  public void setDir(String dir) {
    this.dir = dir;
  }

  Object install() {
    File managerFile = getManagerFile();
    if (managerFile.exists())
      return new Union(
        new AlreadyManaged(),
        new Note("manager.inf exists"),
        new Choice(
          new AbstractAction("cancel") {
            public Object run() {
              return null;
            }
          },
          new AbstractAction("overwrite") {
            public Object run() {
              return install2();
            }
          }));
    return install2();
  }

  public File getManagerFile() {
    return new File(dir, "manager.inf");
  }

  Object install2() {
    String myAddress = AddressUtil.getAddress(this);
    try {
      FileUtil.saveTextFile(getManagerFile(), "This directory is managed by:\n"
        + StringUtil.indent(2, myAddress));
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
    active = true;
    return new Success();
  }

  public String getDir() {
    return dir;
  }

  public boolean isActive() {
    return active;
  }
}