/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t01;

/** an Omnivore script with no branching/looping */
public class SimpleScript implements RunnableC {
  private Object[] steps;
  private int ip;

  public SimpleScript(Object... steps) {
    this.steps = steps;
  }

  public Object step() {
    return ip < steps.length ? steps[ip++] : null;
  }

  public Object getExpansion() {
    return new AbstractAction("step") {
      public Object run() {
        return step();
      }
    };
  }

  public Object run(IRunner runner) {
    Object step, result = null;
    while ((step = step()) != null) {
      result = runner.run(step);
    }
    return result;
  }
}