/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t01;

import drjava.util.IRunnable;
import prophecy.t.t03.DialogClient;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class SocketCall implements IRunnable {
  private String head;

  public SocketCall(String head) {
    this.head = head;
  }

  public Object run() {
    DialogClient client;
    Matcher matcher = Pattern.compile("socket\\[(\\d+)\\]").matcher(head);
    if (matcher.matches()) {
      int port = Integer.parseInt(matcher.group(1));
      client = new DialogClient(port);
    } else {
      matcher = Pattern.compile("socket\\[([a-zA-Z0-9\\.\\-]+):(\\d+)\\]").matcher(head);
      if (matcher.matches()) {
        String host = matcher.group(1);
        int port = Integer.parseInt(matcher.group(2));
        client = new DialogClient(host, port);
      } else
        return new RuntimeException("Can't parse head: " + head);
    }

    try {
      return client.connect();
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
  }
}