package prophecy.t.t02;

import drjava.util.MultiCoreUtil;
import prophecy.m.m26.ProphecyJarMaker;

import java.io.IOException;

public class DNSUpdateDaemon {
  public static void main(String[] args) {
    Arguments arguments = new Arguments(args);
    final StatefulDNSUpdater updater = new StatefulDNSUpdater(arguments.getMandatory("host"),
      arguments.getMandatory("user"), arguments.getMandatory("pass"));
    updater.startSeries();
    long period = arguments.getInt("period", 60)*1000;

    while (true) {
      try {
        updater.continueSeries();
        MultiCoreUtil.sleep(period);
      } catch (Throwable e) {
        e.printStackTrace();
        MultiCoreUtil.sleep(period*10);
        updater.clearException();
      }
    }
  }

  public static class MakeJar {
    public static void main(String[] args) throws IOException {
      ProphecyJarMaker.makeJar("standalone/T02DNSUpdateDaemon.jar", DNSUpdateDaemon.class);
    }
  }
}
