/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t02;

import static drjava.util.ObjectUtil.nice;

import java.io.DataInputStream;
import java.net.URL;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class DynDNSCheckIP {
  public static Object getIP() {
    try {
      DataInputStream in = new DataInputStream(new URL("http://checkip.dyndns.com/").openStream());
      String line = in.readLine();
      Matcher matcher = Pattern.compile("(\\d+)\\.(\\d+)\\.(\\d+)\\.(\\d+)").matcher(line);
      if (!matcher.find())
        return new Obstacle("No IP address found: [" + line + "]");
      return matcher.group();
    } catch (Throwable e) {
      return new Obstacle(e);
    }
  }

  public static void main(String[] args) {
    System.out.println(nice(DynDNSCheckIP.getIP()));
  }
}