/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t03;

import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.SocketCallable;
import prophecy.common.socket.DialogServer;

import java.io.IOException;

public class ReceptionistTest {
  public static void main(String[] args) throws IOException {
    SocketCallable dialoglet = new SocketCallable() {
      public void takeCall(SocketHandler handler) {
        handler.println("you found me!");
      }
    };

    Receptionist receptionist = new Receptionist();
    String address = receptionist.addObject(dialoglet);
    System.out.println("Address: " + address);
    DialogServer server = new DialogServer(5000, receptionist);
    server.start();

    DialogClient client = new DialogClient(5000);
    SocketHandler handler = client.connect();
    String line = handler.readLine();
    System.out.println("recvd: " + line);
    if (!"This is the receptionist. Who would you like to speak to?".equals(line))
      throw new RuntimeException("Unexpected line, quitting");
    handler.println(address);
    line = handler.readLine();
    if ("you found me!".equals(line))
      System.out.println("found!!");
    else
      System.out.println("not found - " + line);
    handler.close();

    server.stop();
    System.exit(0);
  }
}