/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t04;

import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectURL;
import prophecy.common.omnivore.Omnivore;
import prophecy.t.t01.*;

public class Contacter {
  private ObjectURL url;

  public Contacter(ObjectURL url) {
    this.url = url;
  }

  /** call in Omnivore fashion
   *  (return object of expandable type; or return (not throw) exception) */
  public Object call() {
    String head = url.getHead(), tail = url.getTail();
    if (head.startsWith("socket[")) {
      if (tail.length() == 0)
        return new SocketCall(head);
      else {
        /*
        socketHandler = SocketCall(head)
        AskFor(socketHandler, tail)
        */
        ScriptVar socketHandler = new ScriptVar("socketHandler");
        return new SimpleScript(
          socketHandler.new Set(new SocketCall(head)),
          new AskFor(socketHandler.new Get(), tail)
        );
      }
    }

    return new Unimplemented("Call " + url);
  }

  /** call in Java fashion (return object of specific type or throw exception) */
  public SocketHandler callJ() {
    return Omnivore.runAndConvert(
      new Contacter(url).call(), SocketHandler.class);
  }
}