/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t04;

import drjava.util.GUIUtil;
import prophecy.m.m01.SocketUtil;
import prophecy.t.t01.CooperativeDirManager;
import prophecy.t.t01.RunnerSheet;
import prophecy.common.socket.ObjectServer;

import java.io.File;
import java.io.IOException;

// advanced test with object server
public class DirectoryManagerTest2 {
  public static void main(String[] args) throws IOException {
    String dir = "temp/managed";
    new File(dir).mkdirs();

    ObjectServer objectServer = new ObjectServer(SocketUtil.serverSocketAtRandomPort());
    objectServer.start();

    CooperativeDirManager directoryManager = new CooperativeDirManager();
    directoryManager.setDir(dir);
    objectServer.addObject(directoryManager);

    RunnerSheet runnerSheet = new RunnerSheet();
    runnerSheet.setTitle("Conquering directory");
    runnerSheet.addNote("Directory: " + dir);
    Object result = directoryManager.install();
    System.out.println("Result: " + result);
    //new ProphecyEnv(new Box(directoryManager), new Box(result)).showMainFrame();
    runnerSheet.setObject(result);
    GUIUtil.showMainFrame(runnerSheet.asFrame());
  }
}