/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t04;

import static drjava.util.ObjectUtil.nice;
import drjava.util.Result;
import prophecy.m.m30.ExUtil;
import prophecy.m.m30.Expandable;
import prophecy.m.m30.Expander;

public class ExUtil2 extends ExUtil {
  public static Object expandFully(Object o) {
    while (o instanceof Expandable) {
      Expandable expandable = (Expandable) o;
      o = expandable.expand();
    }
    return o;
  }

  public static String toString(Object o) {
    return convert(o, String.class);
  }

  public static <C> C convert(Object o, Class<C> aClass) {
    Expander search = new Expander(o);
    while (search.hasMoreElements()) {
      Object element = search.nextElement();
      if (aClass.isInstance(element))
        return (C) element;
    }
    //return null;
    throw new RuntimeException("Can't convert to " + aClass.getName() + ": " + nice(o));
  }

  public static <C> C runAndConvert(Object o, Class<C> aClass) {
    return convert(runIfRunnable(o), aClass);
  }

  public static Object runIfRunnable(Object o) {
    o = expandFully(o);
    Result<Object> result = new Runner().runB(o);
    return result.isSuccess() ? result.getValue() : o;
  }
}
