/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t04;

import drjava.util.XTestCase;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectServer;
import prophecy.common.socket.ObjectURL;

import java.io.IOException;
import java.net.ServerSocket;

public class ObjectServerTest extends XTestCase {
  private FixedMessageDialoglet messageDialoglet;
  private ObjectURL dialogletURL;
  private ObjectServer objectServer;

  public void testServer() throws IOException {
    startServer();
  }

  private void startServer() throws IOException {
    objectServer = new ObjectServer(new ServerSocket(12345));
    objectServer.start();
    System.out.println("Server URL: " + objectServer.getURL());
    messageDialoglet = new FixedMessageDialoglet("i am an object");
    objectServer.addObject(messageDialoglet);
    dialogletURL = ObjectURL.get(messageDialoglet);
    assertNotNull(dialogletURL);
    System.out.println("Dialoglet URL: " + dialogletURL);
  }

  public void testContacter() throws IOException {
    startServer();
    Object result = new Contacter(dialogletURL).call();
    System.out.println("call => " + result);
    result = new Runner().runWhileRunnable(result);
    System.out.println("run => " + result);
    SocketHandler socketHandler = ExUtil2.convert(result, SocketHandler.class);
    String line = socketHandler.readLine();
    assertEquals("i am an object", line);
  }

  public void tearDown() throws IOException {
    if (objectServer != null)
      objectServer.stop();
  }

  public void testURL() throws IOException {
    objectServer = new ObjectServer(12345);
    ObjectURL url = objectServer.addObject("test", new Object());
    assertEquals("obj:socket[12345]/test", url.getURL());
  }
}