/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t04;

import drjava.util.IRunnable;
import drjava.util.XTestCase;
import prophecy.m.m30.Expandable;
import prophecy.t.t01.ScriptVar;
import prophecy.t.t01.SimpleScript;

public class SimpleScriptTest extends XTestCase {
  public void test1Line() {
    ScriptVar v = new ScriptVar("v");
    SimpleScript script = new SimpleScript(
      v.new Set("hello"));
    new Runner().run(script);
    assertEquals("hello", v.getValue());
  }

  public void testAppend() {
    ScriptVar v = new ScriptVar("v");
    SimpleScript script = new SimpleScript(
      v.new Set("hello"),
      v.new Set(new Append(v.new Get(), " world")));
    new Runner().run(script);
    assertEquals("hello world", v.getValue());
  }

  public void testAppendR() {
    ScriptVar v = new ScriptVar("v");
    SimpleScript script = new SimpleScript(
      v.new Set("hello"),
      v.new Set(new AppendR(v.new Get(), " world")));
    new Runner().run(script);
    assertEquals("hello world", v.getValue());
  }

  private class Append implements Expandable {
    private Object a;
    private Object b;

    public Append(Object a, Object b) {
      this.a = a;
      this.b = b;
    }

    public Object expand() {
      return ExUtil2.toString(a) + ExUtil2.toString(b);
    }
  }

  private class AppendR implements IRunnable {
    private Object a;
    private Object b;

    public AppendR(Object a, Object b) {
      this.a = a;
      this.b = b;
    }

    public Object run() {
      return ExUtil2.toString(a) + ExUtil2.toString(b);
    }
  }
}