/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t05;

import drjava.util.Tree;
import drjava.util.TreeUtil;
import prophecy.common.Rand;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.SocketCallable;
import prophecy.common.socket.ObjectURL;
import prophecy.common.omnivore.Omnivore;
import prophecy.m.m14.Failure;
import prophecy.t.t04.Contacter;

public class AddressVerificationServer implements SocketCallable {
  public void takeCall(SocketHandler handler) {
    String line = handler.readLine();
    Tree tree = TreeUtil.textToTree(line);
    if (!tree.nameIs("verify address"))
      throw new Failure(line);
    ObjectURL url = new ObjectURL(tree.getString("url"));
    String key = Rand.eightDigits();
    String text = "Your address verification key is: " + key;
    sendMessage(url, text);
    handler.println("A message with a key has been sent. Please enter key.");
    System.out.println("Waiting for key from client");
    String keyFromClient = handler.readLine();
    System.out.println("key from client: " + keyFromClient);
    if (key.equals(keyFromClient))
      handler.println("OK, key is correct. Your address (" + url + ") has been verified!");
    else
      handler.println("Key is incorrect");
  }

  private void sendMessage(ObjectURL url, String text) {
    SocketHandler socketHandler = Omnivore.reduceTo(new Contacter(url).call(), SocketHandler.class);
    if (socketHandler == null)
      throw new Failure("no contact");
    System.out.println("socketHandler: " + socketHandler);

    socketHandler.println(new Tree("receive message").setString("text", text).toString());
    socketHandler.close();
  }
}