/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t05;

import drjava.util.GUIUtil;
import prophecy.common.omnivore.Omnivore;
import prophecy.common.socket.ObjectServer;
import prophecy.common.socket.ObjectURL;
import prophecy.t.t01.RunnerSheet;

import java.io.IOException;

public class AddressVerificationTest {
  public static void main(String[] args) throws IOException {
    ObjectServer objectServer = new ObjectServer();
    objectServer.start();
    Mailbox mailbox = new Mailbox();
    objectServer.addObject(mailbox);

    ObjectServer objectServer2 = new ObjectServer();
    objectServer2.start();
    AddressVerificationServer verifier = new AddressVerificationServer();
    objectServer2.addObject(verifier);

    AddressVerificationClient client = new AddressVerificationClient(mailbox);
    Object result = Omnivore.reduce(client.verifyWith(ObjectURL.get(verifier)));
    System.out.println(result);

    RunnerSheet runnerSheet = new RunnerSheet("T05: Address verification test");
    runnerSheet.setSize(500, 300);
    runnerSheet.setObject(result);
    GUIUtil.showMainFrame(runnerSheet.asFrame());

    /*MultiCoreUtil.sleep(2000);
    System.exit(0);*/
  }
}