/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t05;

import static drjava.util.ObjectUtil.nice;
import drjava.util.Tree;
import drjava.util.TreeUtil;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.SocketCallable;

import java.util.ArrayList;
import java.util.List;

public class Mailbox implements SocketCallable {
  private List<Message> messages = new ArrayList<Message>();

  public void takeCall(SocketHandler handler) {
    Tree tree = TreeUtil.textToTree(handler.readLine());
    if (tree.nameIs("receive message")) {
      Message message = new Message();
      message.setText(tree.getString("text"));
      message.setOrigin(handler.getInfo());
      System.out.println("Message received from " + message.getOrigin() + " >> " + nice(message.getText()));
      addMessage(message);
    }
  }

  public synchronized void addMessage(Message message) {
    messages.add(message);
  }

  public synchronized List<Message> getMessages() {
    return new ArrayList<Message>(messages);
  }
}