/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t06;

import drjava.util.Tree;
import drjava.util.TreeUtil;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectURL;
import prophecy.common.socket.SocketCallable;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

public class ServerList implements SocketCallable {
  private List<ObjectURL> servers = new ArrayList<ObjectURL>();

  public List<ObjectURL> getServers() {
    return servers;
  }

  public void takeCall(final SocketHandler handler) {
    TreeCLI cli = new TreeCLI();
    cli.addCmd(new Cmd("list") {
      public void run(Tree tree, SocketHandler handler) {
        handler.println(TreeUtil.objectToTree(servers).toString());
      }
    });

    cli.addCmd(new Cmd("addServer") {
      public void run(Tree input, SocketHandler handler) {
        String url = input.getString("url");
        if (checkURL(url)) {
          servers.add(new ObjectURL(url));
          handler.println("OK, server added");
        }
      }
    });

    cli.addStandardCmds();
    cli.loop(handler);
  }

  private boolean checkURL(String url) {
    /*
    final SocketHandler socketHandler = ExUtil2.runAndConvert(
      new Contacter(new ObjectURL(url)).call(), SocketHandler.class);
    return socketHandler != null;
    */
    return Pattern.matches("obj:socket\\[\\d+\\]", url);
  }

}
