/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t06;

import drjava.util.Tree;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectURL;
import prophecy.m.m14.Failure;
import prophecy.t.t04.Contacter;
import prophecy.t.t04.ExUtil2;

import java.util.ArrayList;
import java.util.List;

public class ServerListClient {
  private ObjectURL serverListURL;

  public ServerListClient(ObjectURL serverListURL) {
    this.serverListURL = serverListURL;
  }

  public void addServer(ObjectURL serverURL) {
    final SocketHandler socketHandler = ExUtil2.runAndConvert(
      new Contacter(serverListURL).call(), SocketHandler.class);
    try {
      socketHandler.println(
        new Tree("addServer").add("url", serverURL).toString());
      String line = socketHandler.readLine();
      if (!line.startsWith("OK"))
        throw new Failure(line);
    } finally {
      //socketHandler.println("bye");
      socketHandler.close();
    }
  }

  public List<ObjectURL> list() {
    final SocketHandler socketHandler = ExUtil2.runAndConvert(
      new Contacter(serverListURL).call(), SocketHandler.class);
    try {
      socketHandler.println("list");
      String line = socketHandler.readLine();
      Tree tree = Tree.parse(line);
      List<ObjectURL> list = new ArrayList<ObjectURL>();
      for (Tree child : tree.arguments()) {
        list.add(new ObjectURL(child));
      }
      return list;
    } finally {
      socketHandler.close();
    }
  }
}