/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t07;

import drjava.util.GUIUtil;
import prophecy.common.gui.Sheet;
import prophecy.common.LogView;
import prophecy.m.m25.Steps;
import prophecy.m.m34.StepsProgressBar;

import java.awt.*;

public class StepsProgressSheet extends Sheet {
  private LogView logView;
  private StepsProgressBar progressBar;

  public StepsProgressSheet(String title, Steps steps, boolean showLog) {
    setTitle(title);
    addSpacer();
    progressBar = new StepsProgressBar(steps);
    progressBar.setMinimumSize(new Dimension(200, 40));
    addComponent(progressBar);
    addSpacer();
    if (showLog) {
      logView = new LogView();
      GUIUtil.setMinimumHeight(logView, 200);
      addComponent(logView);
    }
  }

  public void setProgressBarWidth(int width) {
    GUIUtil.setMinimumWidth(progressBar, width);
  }

  public void logText(String text) {
    if (logView != null)
      logView.logText(text);
  }

  public void setLogFont(Font font) {
    logView.setTextFont(font);
  }

  public void setProgressBarFont(Font font) {
    progressBar.setFont(font);
  }

  public LogView getLogView() {
    return logView;
  }
}