/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t08;

import drjava.util.Lizt;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/** a threadsafe list */
public class Bag<A> {
  private List<A> objects = new ArrayList<A>();

  public synchronized void add(A object) {
    objects.add(object);
  }

  public synchronized Lizt<A> getSnapshot() {
    return new Lizt<A>(objects);
  }

  public synchronized void clear() {
    objects = new ArrayList<A>();
  }

  public synchronized void remove(A object) {
    objects.remove(object);
  }

  public synchronized int size() {
    return objects.size();
  }

  public synchronized A get(int i) {
    return objects.get(i);
  }

  public synchronized boolean contains(A object) {
    return objects.contains(object);
  }

  public synchronized void addAll(Collection<A> collection) {
    objects.addAll(collection);
  }
}