/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t08;

import drjava.util.Tree;
import prophecy.common.Immutable;

public class Packet implements Immutable {
  private final InOut direction;
  private final String contents;

  public Packet(InOut direction, String contents) {
    this.direction = direction;
    this.contents = contents;
  }

  public InOut getDirection() {
    return direction;
  }

  public String getContents() {
    return contents;
  }

  public String toString() {
    return direction + " " + Tree.quoteString(contents);
  }

  public Tree toTree() {
    return new Tree(getClass())
      .add("direction", new Tree(getDirection() == InOut.in ? "in" : "out"))
      .add("contents", getContents());
  }
}