/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t08;

import prophecy.m.m26.ProphecyJarMaker;
import prophecy.common.socket.ObjectServer;
import prophecy.t.t05.VMShutdown;

import java.io.IOException;

public class T08 extends ServerTrayIcon {
  public T08() {
    super("T08");
  }

  public static void main(String[] args) {
    T08 t08 = new T08();
    t08.install();
    t08.autoClose();
  }

  public ObjectServer makeObjectServer() {
    ObjectServer objectServer = new ObjectServer();
    objectServer.addObject("shutdown", new VMShutdown());
    Bag<RecordedConversation> conversations = new Bag<RecordedConversation>();
    objectServer.addObject("ConversationLogger", new ConversationLoggerMaker(conversations));
    objectServer.addObject("ConversationDB", new ConversationDB(conversations));
    return objectServer;
  }

  public static class MakeJar {
    public static void main(String[] args) throws IOException {
      ProphecyJarMaker.makeJar("standalone/t08.jar", T08.class);
    }
  }
}