/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t09;

import drjava.util.Tree;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.SocketCallable;

import java.net.InetAddress;

public class ServerInfo implements SocketCallable {
  public void takeCall(SocketHandler handler) {
    String hostname = getHostName();
    handler.println(new Tree()
      .add("hostname", hostname)
      .toString());
  }

  private String getHostName() {
    try {
      return InetAddress.getLocalHost().getHostName();
    } catch (Throwable e) {
      return "unknown";
    }
  }
}