/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t12;

import drjava.util.Tree;
import drjava.util.TreeUtil;
import drjava.util.Treeifier;

public class BasicCloneVerification implements Treeifier {
  private Treeifier baseTreeifier;

  public BasicCloneVerification(Treeifier baseTreeifier) {
    this.baseTreeifier = baseTreeifier;
  }

  public BasicCloneVerification() {
  }

  public Treeifier getBaseTreeifier() {
    return baseTreeifier;
  }

  public void setBaseTreeifier(Treeifier baseTreeifier) {
    this.baseTreeifier = baseTreeifier;
  }

  public Tree objectToTree(Object object) {
    Tree tree = baseTreeifier.objectToTree(object);
    try {
      Object restored = TreeUtil.treeToObject(tree);
      if (object.getClass() != restored.getClass()) {
        throw new Exception("Restored object has class " + restored.getClass().getName()
          + " instead of " + object.getClass().getName());
      }
    } catch (Throwable e) {
      throw new VerificationException(e);
    }
    return tree;
  }
}