/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t12;

import drjava.util.Bus;
import drjava.util.Port;
import prophecy.common.UncaughtEventsBus;

public class EventCatcher extends PersonalService {
  private Bus<Event> bus = new Bus<Event>();

  public static synchronized EventCatcher get(Object client) {
    return PersonalService.getService(client, EventCatcher.class);
  }

  public static void receive(Object source, Event event) {
    get(source).receive(event);
  }

  public void receive(Event event) {
    //System.out.println("Catcher.receive " + nice(getClient()) + " >> " + nice(object));
    if (bus.hasReceivers())
      bus.receive(event);
    else
      UncaughtEventsBus.receive(event);
  }

  public void addReceiver(Port<Event> port) {
    bus.addReceiver(port);
  }
}