/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t12;

import drjava.util.Bus;
import drjava.util.Port;
import drjava.util.Tree;
import drjava.util.Treeifier;
import prophecy.common.CodeQueue;

public class EventTreeifier {
  Port<Event> port;
  EventTreeifierSoup soup;
  Bus<Tree> treeBus = new Bus<Tree>();

  public EventTreeifier(CodeQueue codeQueue, Treeifier treeifier) {
    port = new ThreadSafePort<Event>(new Port<Event>() {
      public void receive(Event event) {
        receiveImpl(event);
      }
    }, codeQueue);
    soup = new EventTreeifierSoup(codeQueue, treeifier);
    soup.sendTreesTo(treeBus);
  }

  private void receiveImpl(Event event) {
    //System.out.println(nice(Thread.currentThread()) + " event: " + object);
    soup.newEvent(event);
  }

  /** returns a thread-safe port */
  public Port<Event> getPort() {
    return port;
  }

  public EventTreeifierSoup getSoup() {
    return soup;
  }

  public Bus<Tree> getTreeBus() {
    return treeBus;
  }
}