/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t12;

public class Heart {
  private double delay = 1.0;
  private int beatCount;

  public void start() {
    releaseEvent(new HeartStarted());
    TimerService.get(this).repeat(delay, new Runnable() {
      public void run() {
        releaseEvent(new HeartBeat(++beatCount));
      }
    });
  }

  public void stop() {
    TimerService.get(this).stopAll();
    releaseEvent(new HeartStopped());
  }

  private void releaseEvent(Event event) {
    EventCatcher.receive(this, event);
  }
}