/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t12;

import drjava.util.Result;
import drjava.util.Tree;
import drjava.util.TreeUtil;
import drjava.util.Treeifier;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class MultiTreeifier implements Treeifier {
  private List<SpecialTreeifier> specialTreeifiers = new ArrayList<SpecialTreeifier>();

  public MultiTreeifier(SpecialTreeifier... treeifiers) {
    specialTreeifiers.addAll(Arrays.asList(treeifiers));
  }

  public Tree objectToTree(Object object) {
    if (object == null) return null;
    
    for (SpecialTreeifier treeifier : specialTreeifiers) {
      Result<Tree> result = treeifier.objectToTree(object, this);
      if (result.isSuccess())
        return result.get();
    }
    return TreeUtil.objectToTree(object);
  }

  public void addSpecialTreeifier(SpecialTreeifier treeifier) {
    specialTreeifiers.add(treeifier);
  }
}