/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t12;

import drjava.util.Attachments;

import java.lang.ref.WeakReference;

public class PersonalService {
  private WeakReference<Object> client;

  public void setClient(Object client) {
    this.client = new WeakReference<Object>(client);
  }

  public Object getClient() {
    return client == null ? null : client.get();
  }

  public static synchronized <S extends PersonalService> S getService(Object client, Class<S> serviceClass) {
    S service = Attachments.get(client, serviceClass);
    if (service == null) {
      try {
        service = serviceClass.newInstance();
      } catch (Exception e) {
        throw new RuntimeException(e);
      }
      service.setClient(client);
      Attachments.add(client, service);
    }
    return service;
  }
}