/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t13;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;

public class FileAppender {
  private PrintStream printStream;
  private String file, encoding;

  public FileAppender(String file) {
    this.file = file;
  }

  public FileAppender(String file, String encoding) {
    this.file = file;
    this.encoding = encoding;
  }

  public void start() {
    try {
      FileOutputStream fos = new FileOutputStream(file, true);
      if (encoding != null)
        printStream = new PrintStream(fos, true, encoding);
      else
        printStream = new PrintStream(fos, true);
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
  }

  /** flushes file after write */
  public void println(String text) {
    printStream.println(text);
  }

  public void close() {
    printStream.close();
    printStream = null;
  }
}