/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t13;

import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectURL;
import prophecy.t.t04.Contacter;
import prophecy.t.t08.Packet;

public class RealCallLogger implements CallLogger {
  private ObjectURL monitorURL;

  public RealCallLogger(ObjectURL monitorURL) {
    if (monitorURL == null)
      throw new NullPointerException();
    this.monitorURL = monitorURL;
  }

  public PacketLogger makePacketLogger() {
    SocketHandler socketHandler = new Contacter(monitorURL).callJ();
    final LogOperatorClient client = new LogOperatorClient();
    client.startCommunication(socketHandler);
    client.openLog("call");

    return new PacketLogger() {
      public void logPacket(Packet packet) {
        client.log(packet.toTree());
      }

      public void closeLog() {
        //client.closeLog();
        client.closeConnection();
      }
    };
  }
}