/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t13;

import prophecy.common.socket.ObjectURL;
import prophecy.t.t04.Contacter;
import prophecy.common.socket.ObjectServer;

import java.io.IOException;

public class TestMonitoredServer {
  public static void main(String[] args) throws IOException {
    String url = args[0];
    if (!url.startsWith("obj:")) {
      if (url.indexOf(':') < 0)
        url += ":400";
      url = "obj:socket[" + url + "]/LogOperator";
    }
    ObjectURL monitorURL = new ObjectURL(url);
    System.out.println("Monitoring to: " + monitorURL);
    new Contacter(monitorURL).callJ().close();
    System.out.println("Monitor reachable");

    ObjectServer objectServer = new ObjectServer();
    //objectServer.setGuard(new CallMonitor(new DumpingCallLogger()));
    objectServer.addGuard(new CallMonitor(new RealCallLogger(monitorURL)));
    objectServer.start();
  }

}