/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t14;

import prophecy.common.socket.SocketCallable;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectServer;
import prophecy.common.socket.ObjectURL;
import prophecy.common.socket.DialogServer;
import prophecy.t.t11.LocalCallsOnly;
import prophecy.t.t13.CallLogger;
import prophecy.t.t13.CallMonitor;
import prophecy.t.t13.LogOperatorMaker;
import prophecy.t.t13.RealCallLogger;

import java.io.IOException;

public class EmbryonicWebServer {
  public static void main(String[] args) throws IOException {
    ObjectServer objectServer = new ObjectServer();
    objectServer.addGuard(new LocalCallsOnly()); // actually this should be in-VM only
    objectServer.start();
    ObjectURL monitorURL = objectServer.addObject("WebserverLog", new LogOperatorMaker("memory/t14"));

    DialogServer dialogServer = new DialogServer(80, new CallHandler());
    CallLogger callLogger = new RealCallLogger(monitorURL);
    dialogServer.addGuard(new CallMonitor(callLogger));
    dialogServer.start();
  }

  private static class CallHandler implements SocketCallable {
    public void takeCall(SocketHandler handler) {
      while (handler.readLine() != null) {
        // that's right, do nothing at all
      }
    }
  }
}