package prophecy.t.t14;

import prophecy.common.socket.SocketCallable;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectServer;
import prophecy.common.socket.DialogServer;
import prophecy.common.socket.ObjectURL;
import prophecy.t.t04.Contacter;
import prophecy.t.t11.LocalCallsOnly;
import prophecy.t.t13.CallLogger;
import prophecy.t.t13.CallMonitor;
import prophecy.t.t13.LogOperatorMaker;
import prophecy.t.t13.RealCallLogger;

import java.io.IOException;

public class T14Proxy {
  private String destinationHost = "www.fluesterstern.de";
  private int destinationPort = 8080;

  public static void main(String[] args) throws IOException {
    new T14Proxy().start();
  }

  private void start() throws IOException {
    ObjectServer objectServer = new ObjectServer();
    objectServer.addGuard(new LocalCallsOnly()); // actually this should be in-VM only
    objectServer.start();
    ObjectURL monitorURL = objectServer.addObject("ProxyLog", new LogOperatorMaker("memory/t14"));

    DialogServer dialogServer = new DialogServer(80, new CallHandler());
    CallLogger callLogger = new RealCallLogger(monitorURL);
    dialogServer.addGuard(new CallMonitor(callLogger));
    dialogServer.start();
  }

  private class CallHandler implements SocketCallable {
    public void takeCall(final SocketHandler handler) {
      ObjectURL url = new ObjectURL("obj:socket[" + destinationHost + ":" + destinationPort + "]");
      final SocketHandler handler2 = new Contacter(url).callJ();
      new Thread("Proxy") {
        public void run() {
          String line;
          while ((line = handler2.readLine()) != null) {
            handler.println(line);
          }
          handler.close();
        }
      }.start();

      String line;
      while ((line = handler.readLine()) != null) {
        handler2.println(line);
      }
      handler2.close();
    }
  }
}
