/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t15;

import static drjava.util.ObjectUtil.nice;
import drjava.util.Port;
import drjava.util.Tree;
import prophecy.common.CodeQueue;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.SocketCallable;
import prophecy.t.t06.Cmd;
import prophecy.t.t06.TreeCLI;
import prophecy.t.t12.*;

public class HeartOperator implements SocketCallable {
  private Heart heart;

  public HeartOperator(Heart heart) {
    this.heart = heart;
  }

  public void takeCall(SocketHandler handler) {
    handler.ok(new Tree(nice(this) + " ready"));
    TreeCLI cli = new TreeCLI();
    cli.addStandardCmds();
    cli.addCmd(new Listen());
    cli.loop(handler);
    while (handler.readLine() != null) {}
  }

  private class Listen extends Cmd {
    public void run(Tree input, final SocketHandler handler) {
      handler.setKeepOpen(true);
      CodeQueue codeQueue = new CodeQueue().startThread();
      Port<Event> port = new Port<Event>() {
        public void receive(Event event) {
          if (event instanceof HeartBeat) {
            // TODO: SocketHandler thread safety
            handler.println(new Tree("HeartBeat"));
          }
        }
      };
      EventCatcher.get(heart).addReceiver(new ThreadSafePort<Event>(port, codeQueue));
      TreeCLI.exitLoop();
      // TODO: clean up on connection close
    }
  }
}