/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t15;

import prophecy.common.AnimatingSurface;
import prophecy.common.image.PixelUtil;

import java.awt.*;

public class HeartSurface extends AnimatingSurface {
  volatile double brightness = 0.0;
  private double decay = 0.96;

  public void step(int w, int h) {
    brightness *= decay;
  }

  public void reset(int newwidth, int newheight) {
  }

  public void render(int w, int h, Graphics2D g) {
    g.setColor(PixelUtil.blend(Color.black, Color.green, brightness).getColor());
    g.fillRect(0, 0, w, h);
  }

  public void onHeartBeat() {
    brightness = 1.0;
  }
}