/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.t.t15;

import static drjava.util.ObjectUtil.nice;
import prophecy.common.SurfaceUtil;
import prophecy.common.socket.ObjectURL;
import prophecy.m.m26.ProphecyJarMaker;
import prophecy.t.t04.Contacter;

import javax.swing.*;
import java.io.IOException;

/** starts a server and visualizes its beating heart in green flashes */
public class T15GreenBeat {
  public static void main(String[] args) {
    try {
      ObjectURL heartURL = HeartServer.start();
      System.out.println(heartURL);

      final HeartSurface heartSurface = new HeartSurface();
      JFrame frame = SurfaceUtil.showAsMain("T15 Green Beat", heartSurface);
      frame.setSize(300, 300);
      heartSurface.start();

      HeartOperatorClient client = new HeartOperatorClient();
      client.getOnHeartBeat().addListener(new Runnable() {
        public void run() {
          heartSurface.onHeartBeat();
        }
      });

      //ObjectURL url = new ObjectURL("obj:socket[400]/heart");
      client.setSocketHandler(new Contacter(heartURL).callJ());
      client.listen(); // blocks
    } catch (Throwable e) {
      e.printStackTrace();
      JOptionPane.showMessageDialog(null, nice(e));
    }
  }

  public static class MakeJar {
    public static void main(String[] args) throws IOException {
      ProphecyJarMaker.makeJar(T15GreenBeat.class);
    }
  }
}