package prophecy.t.t16;

import drjava.util.ToTree;
import drjava.util.Tree;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectURL;
import prophecy.t.t04.Contacter;

import javax.swing.*;
import java.io.File;
import java.io.IOException;

public class TestAgentSender {
  public static void main(String[] args) throws IOException {
    ObjectURL url = T16AgentServer.startServer();

    HullMaker hullMaker = new HullMaker();
    String hullFile = "temp/hull.jar";
    Hull hull = hullMaker.makeHull(new HelloWorld());
    hull.makeJar(hullFile);

    SocketHandler socketHandler = new Contacter(url).callJ();
    AgentSender sender = new AgentSender();
    sender.startCommunication(socketHandler);
    sender.uploadAgent(hull.getObjectInfo(), new File(hullFile), "helloworld", "helloworld.jar");
    sender.closeConnection();

    System.exit(0);
  }

  public static class HelloWorld implements Runnable, ToTree {
    public void run() {
      JOptionPane.showMessageDialog(null, "Hello world!");
    }

    public Tree toTree() {
      return new Tree(getClass());
    }
  }
}
