package prophecy.t.t17;

import drjava.util.Errors;
import drjava.util.GUIUtil;
import prophecy.common.Prophecy;
import prophecy.common.gui.SexyColumn;
import prophecy.common.gui.SexyTableModel;

import javax.swing.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Comparator;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

public class JarTool {
  public static void main(String[] args) {
    Errors.setPopup(true);
    Prophecy.init();
    try {
      String jarPath = args[0];
      JarFile jar = new JarFile(jarPath);
      JFrame frame = new JFrame(jarPath + " - T17 JarTool");
      frame.setSize(500, 500);
      SexyTableModel<JarEntry> tableModel = new SexyTableModel<JarEntry>(new ColPath(), new ColName());
      ArrayList<JarEntry> entries = getEntries(jar);
      tableModel.setList(entries);
      JTable table = new JTable(tableModel);
      frame.getContentPane().add(new JScrollPane(table));
      GUIUtil.showMainFrame(frame);
    } catch (Throwable e) {
      Errors.add(e);
    }
  }

  private static ArrayList<JarEntry> getEntries(JarFile jar) {
    ArrayList<JarEntry> entries = new ArrayList<JarEntry>();
    Enumeration<JarEntry> e = jar.entries();
    while (e.hasMoreElements())
      entries.add(e.nextElement());
    Collections.sort(entries, new Comparator<JarEntry>() {
      public int compare(JarEntry o1, JarEntry o2) {
        return o1.getName().compareTo(o2.getName());
      }
    });
    return entries;
  }

  private static class ColPath extends SexyColumn<JarEntry> {
    public String getName() {
      return "Path";
    }

    public Object getCell(int row, JarEntry jarEntry) {
      String name = jarEntry.getName();
      int i = name.lastIndexOf('/');
      return name.substring(0, Math.max(0, i));
    }
  }

  private static class ColName extends SexyColumn<JarEntry> {
    public String getName() {
      return "Name";
    }

    public Object getCell(int row, JarEntry jarEntry) {
      String name = jarEntry.getName();
      int i = name.lastIndexOf('/');
      return name.substring(i+1);
    }
  }
}
