package prophecy.t.t17;

import drjava.util.ToTree;
import drjava.util.Tree;
import prophecy.common.socket.SocketHandler;
import prophecy.common.socket.ObjectURL;
import prophecy.t.t04.Contacter;
import prophecy.t.t16.HullMaker;
import prophecy.t.t16.Hull;
import prophecy.t.t16.AgentSender;

import java.io.File;
import java.io.IOException;

public class TestRunAgent {
  public static void main(String[] args) throws IOException {
    ObjectURL url = new ObjectURL("obj:socket[401]/AgentEntryPoint");

    HullMaker hullMaker = new HullMaker();
    String hullFile = "temp/hull.jar";
    Hull hull = hullMaker.makeHull(new HelloWorld());
    hull.makeJar(hullFile);

    SocketHandler socketHandler = new Contacter(url).callJ();
    PasswordClient passwordClient = new PasswordClient("t17");
    passwordClient.logIn(socketHandler);
    AgentSender sender = new AgentSender();
    sender.startCommunication(socketHandler);
    sender.runAgent(hull.getObjectInfo(), new File(hullFile), "helloworld");
    sender.closeConnection();

    System.exit(0);
  }

  public static class HelloWorld implements Runnable, ToTree {
    public void run() {
      //JOptionPane.showMessageDialog(null, "Hello world!");
      System.out.println("Hello world!");
    }

    public Tree toTree() {
      return new Tree(getClass());
    }
  }
}