/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v01;

import drjava.util.GUIUtil;
import prophecy.common.InspectionNode;
import prophecy.common.InspectionPanel;
import prophecy.common.Visualizable;
import prophecy.common.image.ImageSet;
import prophecy.common.image.ImageSurface;

import javax.swing.*;

public class ImagesPanel {
  JComponent makePanel(ImageSet imageSet, String title) {
    InspectionNode root = new InspectionNode(title);
    for (final ImageSet.Image image : imageSet.getImages()) {
      InspectionNode node = new InspectionNode(image.name);
      node.setVisualizable(new Visualizable() {
        public JComponent visualize() {
          return GUIUtil.withTitle(image.name, ImagesPanel.this.visualize(image));
        }
      });
      root.add(node);
    }
    return new InspectionPanel(root).getPanel();
  }

  protected JComponent visualize(ImageSet.Image image) {
    return new ImageSurface(image.image);
  }
}