/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v01;

import com.zonageek.jpeg.Jpeg;
import com.zonageek.jpeg.JpegBlock;
import com.zonageek.jpeg.JpegException;
import prophecy.common.Prophecy;

import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Vector;

public class JPEGCommentWriteTest {
  public static void main(String[] args) throws Exception {
    /*ImageWriter imageWriter = ImageIO.getImageWritersByFormatName("jpeg").next();
    System.out.println("imageWriter: " + imageWriter);
    ImageOutputStream imageOutputStream = ImageIO.createImageOutputStream(new File("temp/test.jpg"));
    imageWriter.setOutput(imageOutputStream);
    JPEGImageWriteParam writeParam = new JPEGImageWriteParam(Locale.ENGLISH);
    IIOMetadata metaData;
    IIOImage iioImage = new IIOImage();
    imageWriter.write(iioImage);
    imageWriter.replaceImageMetadata(0, metaData);*/
    testZonageek();
  }

  private static void load() throws IOException {
    ImageReader imageReader = ImageIO.getImageReadersByFormatName("jpeg").next();
    ImageInputStream iis = ImageIO.createImageInputStream(Prophecy.dataDir() + "v/ball1.jpg");
    imageReader.setInput(iis);
  }

  private static void testZonageek() throws IOException, JpegException {
    Jpeg jpeg = new Jpeg();
    Jpeg jpeg2 = new Jpeg();

    System.out.println("Reading...");
    jpeg.read(new FileInputStream(Prophecy.dataDir() + "v/test.jpg"));

    Vector blocks = jpeg.getBlocks();
    HashMap info;
    for (int i = 0; i < blocks.size(); i++) {
      JpegBlock block = (JpegBlock) blocks.elementAt(i);
      info = block.getInformation();

      System.out.println("Original Block at position " + i + ": ");
      System.out.println("  Marker " + info.get("Jpeg Block"));
      for (Object key : info.keySet()) {
        System.out.println("  - " + key + ": [" + info.get(key) + "]");
      }

      if (block.getMarker() == Jpeg.MARKER_COM) {
        String comment = new String(block.getData());
        System.out.println("Comment found: " + comment);
      }
    }


    System.out.println("Writing...");
    jpeg2.copyMinimumBlocksFrom(jpeg);

    JpegBlock commentBlock = new JpegBlock(Jpeg.MARKER_COM) {};
    commentBlock.setData("New comment".getBytes());
    jpeg2.addJpegBlock(commentBlock);

    jpeg2.write(new FileOutputStream("temp/test.jpg"));
  }
}