/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v01;

import com.zonageek.jpeg.Jpeg;
import com.zonageek.jpeg.JpegBlock;
import com.zonageek.jpeg.JpegException;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class JpegUtil {
  public static void changeComment(File file, String newComment) throws IOException {
    try {
      Jpeg jpeg = new Jpeg();
      Jpeg jpeg2 = new Jpeg();

      FileInputStream input = new FileInputStream(file);
      jpeg.read(input);
      input.close();

      jpeg2.copyMinimumBlocksFrom(jpeg);

      JpegBlock commentBlock = new JpegBlock(Jpeg.MARKER_COM) {
      };
      commentBlock.setData(newComment.getBytes());
      jpeg2.addJpegBlock(commentBlock);

      String tempFileName = file.getPath() + "_temp";
      FileOutputStream tempOut = new FileOutputStream(tempFileName);
      jpeg2.write(tempOut);
      tempOut.close();
      if (!file.delete())
        throw new IOException("Can't delete " + file.getPath());
      if (!new File(tempFileName).renameTo(file))
        throw new IOException("Can't rename " + tempFileName + " to " + file.getPath());
    } catch (JpegException e) {
      throw new IOException(e.toString());
    }
  }
}