/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v02;

import prophecy.common.Prophecy;
import prophecy.common.Trainer;
import prophecy.common.TrainerUtil;
import prophecy.common.image.ImageSet;

import java.util.List;

public class EyeDetectionContest1 extends EyeDetectionContest {
  public EyeDetectionContest1() {
    super(allImages());
    init();
  }

  public static ImageSet allImages() {
    return ImageSet.allImages(Prophecy.dataDir() + "v");
  }

  protected void init() {
    if (getImages() != null)
      setTrainer(new Trainer<EyeDetector>() {
        List<EyesImage> trainingData = TrainerUtil.makeTrainingData(getImages(), 0.5);

        public void train(EyeDetector eyeDetector) {
          eyeDetector.train(trainingData);
        }
      }, false);
  }
}