/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v02;

import prophecy.common.image.ImageSet;
import prophecy.common.image.RGBImage;
import prophecy.video.v01.ImageMeta;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class EyesImage {
  private RGBImage image;
  private List<Rectangle> eyes = new ArrayList<Rectangle>();

  public EyesImage(ImageSet.Image image) {
    this.image = image.image;
    for (ImageMeta.Object object : new ImageMeta(image).getObjects()) {
      if (object.name.startsWith("eye"))
        eyes.add(object.rect);
    }
  }

  public RGBImage getImage() {
    return image;
  }

  public List<Rectangle> getEyes() {
    return eyes;
  }

  public void grow(double factor) {
    for (int i = 0; i < eyes.size(); i++)
      eyes.set(i, grow(eyes.get(i), factor));
  }

  private Rectangle grow(Rectangle r, double factor) {
    return new Rectangle((int) (r.x-r.width*factor), (int) (r.y-r.height*factor),
      (int) (r.width*(1+2*factor)), (int) (r.height*(1+2*factor)));
  }
}