/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v03;

import drjava.util.LetterLayout;
import prophecy.common.InspectableParent;
import prophecy.common.InspectionNode;
import prophecy.common.image.ImageSurface;
import prophecy.common.image.RGBImage;
import prophecy.video.v02.EyesImage;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class EyeExamples implements InspectableParent {
  private List<RGBImage> eyeImages = new ArrayList<RGBImage>();

  public List<RGBImage> getEyeImages() {
    return eyeImages;
  }

  public void add(List<EyesImage> images) {
    for (EyesImage image : images) {
      for (Rectangle r : image.getEyes()) {
        eyeImages.add(image.getImage().clip(r));
      }
    }
  }

  public List<InspectionNode> getInspectionChildren() {
    List<InspectionNode> children = new ArrayList<InspectionNode>();
    for (RGBImage image : eyeImages) {
      ImageSurface imageSurface = new ImageSurface(image);
      imageSurface.setZoom(3);
      children.add(new InspectionNode(imageSurface));
    }
    return children;
  }

  public JComponent displayAll(double zoom) {
    JPanel panel = new JPanel(LetterLayout.stalactite().setSpacing(10).setBorder(10));
    for (RGBImage image : eyeImages) {
      ImageSurface imageSurface = new ImageSurface(image);
      imageSurface.setZoom(zoom);
      panel.add(imageSurface);
    }
    return panel;
  }

  public void add(RGBImage image) {
    eyeImages.add(image);
  }
}