/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v03;

import drjava.util.GUIUtil;
import prophecy.common.Application;
import prophecy.common.SurfaceUtil;
import prophecy.common.image.ImageSet;
import prophecy.video.v02.EyeDetectionContest1;
import prophecy.video.v02.EyesImage;

import javax.swing.*;
import java.awt.*;
import java.util.Collections;

public class Eyes extends Application {
  public static void main(String[] args) {
    new Eyes();
  }

  public Eyes() {
    EyeExamples examples = new EyeExamples();
    for (ImageSet.Image image : EyeDetectionContest1.allImages().getImages()) {
      EyesImage eyesImage = new EyesImage(image);
      eyesImage.grow(0.25);
      examples.add(Collections.singletonList(eyesImage));
    }
    //inspect(examples);
    int cols = 3;
    JPanel panel = new JPanel(new GridLayout(1, cols));
    for (int i = 0; i < cols; i++)
      panel.add(new EyesPanel(examples));
    JFrame frame = showFinalFrame(SurfaceUtil.makeFrame("V03: Eyes [Project Prophecy]", Help.withHelp(
      "Apply various preprocessing filters to a selection of friendly geek eyes.<br>" +
        "The result could be used as input for a recognition algorithm.<br>" +
        "Which combination do you think captures best the essence of what an eye is?", 10, panel)));
    frame.setSize(frame.getWidth(), 740);
    GUIUtil.centerOnScreen(frame);
  }
}