/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v03;

import drjava.util.LetterLayout;
import drjava.util.TextView;

import javax.swing.*;
import java.awt.*;

public class Help {
  public static JComponent withHelp(String text, JComponent component) {
    return withHelp(text, 0, component);
  }

  public static JComponent withHelp(String text, int textInset, JComponent component) {
    JPanel panel = new JPanel(new LetterLayout("h", "c", "c").setSpacing(10));
    panel.add("c", component);
    TextView textView = makeHelpComponent(text, textInset);
    panel.add("h", textView);
    return panel;
  }

  public static TextView makeHelpComponent(String text, int textInset) {
    TextView textView = new TextView(text, true);
    textView.setMinimumSize(new Dimension(100, 60));
    textView.setBorder(BorderFactory.createEmptyBorder(textInset, textInset, 0, textInset));
    return textView;
  }
}