/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v03;

import drjava.util.ToTree;
import drjava.util.Tree;
import prophecy.common.InspectableParent;
import prophecy.common.InspectionNode;
import prophecy.common.image.RGBImage;
import prophecy.video.v02.EyeDetector;
import prophecy.video.v02.EyesImage;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class ImageCollector extends EyeDetector implements InspectableParent, ToTree {
  private List<RGBImage> eyeImages = new ArrayList<RGBImage>();

  public List<Point> findEyes(RGBImage image) {
    //ImageProcessing.getMiniclipRects(image.getWidth(), image.getHeight(), );
    //DUMMY
    return new ArrayList<Point>();
  }

  public void train(List<EyesImage> images) {
    eyeImages = new ArrayList<RGBImage>();
    for (EyesImage image : images) {
      for (Rectangle r : image.getEyes()) {
        eyeImages.add(image.getImage().clip(r));
      }
    }
  }

  public List<InspectionNode> getInspectionChildren() {
    List<InspectionNode> children = new ArrayList<InspectionNode>();
    for (RGBImage image : eyeImages) {
      children.add(new InspectionNode(image));
    }
    return children;
  }

  public Tree toTree() {
    return new Tree(getClass());
  }
}