/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v06;

public class BoolItem implements EvaluationItem {
  private boolean correct;
  private String description;
  private int wrongScore;
  private int rightScore;

  public BoolItem(boolean correct, String description, int wrongScore, int rightScore) {
    this.correct = correct;
    this.description = description;
    this.wrongScore = wrongScore;
    this.rightScore = rightScore;
  }

  public double getScore() {
    return correct ? rightScore : wrongScore;
  }

  public String toString() {
    return "Score " + Evaluation.formatScore(getScore()) + " (" + description + ")";
  }
}