/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v06;

import prophecy.common.ContestOnDisk;
import prophecy.common.*;

import javax.swing.*;
import java.util.List;

public class ContestsPanel {
  static JComponent makePanel() {
    List<ContestOnDisk> contests = ContestUtil.getAllContestsOnDisk();
    InspectionNode root = new InspectionNode("Contests");
    for (final ContestOnDisk contest : contests) {
      InspectionNode node = new InspectionNode(contest.getFullName());
      node.setVisualizable(new Visualizable() {
        public JComponent visualize() {
          return new ContestPanel(contest, true);
        }
      });
      root.add(node);
    }
    return InspectionPanel.makeInspectionPanel(root);
  }
}