/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v06;

import static drjava.util.StringUtil.formatDouble;
import prophecy.common.SimpleInspectableParent;

import java.util.ArrayList;
import java.util.List;

public class Evaluation implements SimpleInspectableParent {
  private List<EvaluationItem> items = new ArrayList<EvaluationItem>();

  public void addItem(EvaluationItem item) {
    items.add(item);
  }

  public double getScore() {
    double score = 0;
    for (EvaluationItem item : items) {
      score += roundScore(item.getScore());
    }
    return roundScore(score);
  }

  private double roundScore(double score) {
    return Math.round(score*100)*0.01;
  }

  public List getInspectionChildren() {
    return items;
  }

  public String toString() {
    return "Score: " + formatScore(getScore());
  }

  public static String formatScore(double score) {
    return formatDouble(score, 2);
  }
}