/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v06;

import drjava.util.Displayable;
import static drjava.util.ObjectUtil.toNiceString;
import drjava.util.StringDisplay;
import drjava.util.TextView;

import javax.swing.*;

public class LogFrame extends JFrame {
  private TextView textView = new TextView();

  public LogFrame(String title) {
    super(title);
    setSize(500, 500);
    getContentPane().add(textView);
  }

  public void logText(Object o) {
    logText(toNiceString(o));
  }

  public void logText(String s) {
    textView.setText(textView.getText() + textView.nlToBrWithIndent(s) + "<br>");
  }

  public void logDisplayable(Displayable displayable) {
    StringDisplay display = new StringDisplay();
    displayable.display(display);
    logText(display.toString());
  }
}