/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v06;

import drjava.util.Errors;
import drjava.util.Tree;
import static drjava.util.TreeUtil.treeToObject;
import prophecy.common.ContestOnDisk;
import prophecy.common.Contest;
import static prophecy.common.ContestUtil.loadTreeHallOfFame;

import prophecy.common.HallOfFame;

import java.util.ArrayList;
import java.util.List;

public class OngoingContest {
  private HallOfFame<Tree> hallOfFame;
  private Contest contest;

  public OngoingContest(ContestOnDisk contestOnDisk) {
    try {
      hallOfFame = loadTreeHallOfFame(contestOnDisk.getFullName());
    } catch (Throwable e) {
      Errors.add(e);
    }

    try {
      contest = contestOnDisk.load();
    } catch (Throwable e) {
      Errors.add(e);
    }
  }

  public HallOfFame<Tree> getHallOfFame() {
    return hallOfFame;
  }

  public Contest getContest() {
    return contest;
  }

  public List getHallOfFameObjects() {
    List objects = new ArrayList();
    for (Tree tree : hallOfFame.getList()) {
      try {
        Object object = treeToObject(tree);
        objects.add(object);
      } catch (Throwable e) {
        Errors.add(e);
        objects.add(null);
      }
    }
    return objects;
  }
}