/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v07;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public abstract class Enabler implements DocumentListener, ChangeListener, ActionListener, ItemListener {
  private JButton button;

  public Enabler(JButton button) {
    this.button = button;
    update();
  }

  private void update() {
    button.setEnabled(isEnabled());
  }

  public abstract boolean isEnabled();

  public void addTrigger(JTextField textField) {
    textField.getDocument().addDocumentListener(this);
  }

  public void insertUpdate(DocumentEvent e) {
    update();
  }

  public void removeUpdate(DocumentEvent e) {
    update();
  }

  public void changedUpdate(DocumentEvent e) {
    update();
  }

  public void addTrigger(JCheckBox checkBox) {
    checkBox.addItemListener(this);
  }

  public void stateChanged(ChangeEvent e) {
    update();
  }

  public void actionPerformed(ActionEvent e) {
    update();
  }

  public void itemStateChanged(ItemEvent e) {
    update();
  }
}