/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v08;

import static drjava.util.StringUtil.formatDouble;
import prophecy.common.image.PixelUtil;
import prophecy.common.image.RGB;
import prophecy.common.image.RGBImage;
import prophecy.video.v06.ObjectDetector;

import java.awt.*;
import java.util.List;

public class Naive3 extends ObjectDetector {
  public List<Rectangle> findObjects(RGBImage image) {
    List<Rectangle> objects = null;
    for (double threshold = 0; threshold < 1; threshold += 0.05) {
      objects = findObjectsForThreshold(image, threshold);
      System.out.println("threshold=" + formatDouble(threshold, 2) + ", objects: " + objects.size());
    }
    return objects;
  }

  public static List<Rectangle> findObjectsForThreshold(RGBImage image, final double threshold) {
    Naive2 naive2 = new Naive2() {
      public boolean isBackground(RGB pixel) {
        return PixelUtil.getBrightness(pixel) >= threshold;
      }
    };
    return naive2.findObjects(image);
  }

}