/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v08;

import junit.framework.TestCase;

import java.io.IOException;
import java.util.Date;

public class TestHistoryTest extends TestCase {
  private TestHistory history;
  private TestRecord testRecord;

  public void testAddRecord() {
    history = new TestHistory();
    assertEquals(0, history.getRecords().size());
    testRecord = new TestRecord("simple square detection", "jazz", new Date(), "aContestant", 125.0);
    history.addTestRecord(testRecord);
    assertEquals(1, history.getRecords().size());
    assertEquals(testRecord, history.getRecords().get(0));
  }

  public void testPersistence() throws IOException {
    testAddRecord();
    history.save("temp/testhistory");
    history = new TestHistory();
    history.load("temp/testhistory");
    assertEquals(1, history.getRecords().size());
    assertRecordEquals(testRecord, history.getRecords().get(0));
  }

  private void assertRecordEquals(TestRecord a, TestRecord b) {
    assertEquals(a.getContest(), b.getContest());
    assertEquals(a.getUser(), b.getUser());
    assertEquals(a.getDate(), b.getDate());
    assertEquals(a.getContestant(), b.getContestant());
    assertEquals(a.getScore(), b.getScore());
  }
}