/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v08;

import drjava.util.ToTree;
import drjava.util.Tree;

import java.util.Date;

public class TestRecord implements ToTree {
  private String contest;
  private String user;
  private Date date;
  private String contestant;
  private double score;

  public TestRecord(String contest, String user, Date date, String contestant, double score) {
    this.contest = contest;
    this.user = user;
    this.date = date;
    this.contestant = contestant;
    this.score = score;
  }

  public String getContest() {
    return contest;
  }

  public String getUser() {
    return user;
  }

  public Date getDate() {
    return date;
  }

  public String getContestant() {
    return contestant;
  }

  public double getScore() {
    return score;
  }

  public Tree toTree() {
    return new Tree(getClass())
      .add("contest", contest)
      .add("user", user)
      .add("date", date.getTime())
      .add("contestant", contestant)
      .add("score", score);
  }

  public TestRecord(Tree tree) {
    contest = tree.getString("contest");
    user = tree.getString("user");
    date = new Date(tree.getLong("date"));
    contestant = tree.getString("contestant");
    score = tree.getDouble("score");
  }
}