/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v08;

import static drjava.util.StringUtil.formatDouble;
import prophecy.common.InspectionNode;
import static prophecy.common.InspectionUtil.inspect;
import prophecy.common.image.RGBImage;
import prophecy.video.v01.ImageMeta;
import prophecy.video.v01.ImageMetaSurface;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class V08ThresholdExperiment {
  public static void main(String[] args) {
    RGBImage image = RGBImage.load("data/v07/typewriter.jpg");
    List list = new ArrayList();
    for (double threshold = 0; threshold < 1; threshold += 0.05) {
      List<Rectangle> objects = Naive3.findObjectsForThreshold(image, threshold);
      //System.out.println("threshold=" + formatDouble(threshold, 2) + ", objects: " + objects.size());
      list.add(new InspectionNode(formatDouble(threshold, 2) + ": " + objects.size() + " objs",
        new ImageMetaSurface(image, new ImageMeta("", objects))));
    }
    inspect(list);
  }
}