/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v09;

import prophecy.common.image.BWImage;
import prophecy.common.image.ImageProcessing;
import prophecy.common.image.PixelMixer;

public class BlockyBlur {
  public static BWImage blur(BWImage image, int fX, int fY, double brightness) {
    PixelMixer pixelMixer;
    if (fX*fY < 4)
      pixelMixer = new MinPixelMixer();
    else
      pixelMixer = new HistogramPixelMixer(brightness);
    BWImage shrunk = ImageProcessing.resize(image,
      image.getWidth()/fX, image.getHeight()/fY, pixelMixer);
    return ImageProcessing.resize(shrunk, image.getWidth(), image.getHeight());

  }
}