/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v09;

import prophecy.common.image.BWImage;
import prophecy.common.image.PixelMixer;
import prophecy.video.v03.Histogram;

public class HistogramPixelMixer implements PixelMixer {
  private double pixelFraction;

  public HistogramPixelMixer(double pixelFraction) {
    this.pixelFraction = pixelFraction;
  }

  public float mix(BWImage image) {
    return (float) new Histogram(image).getThresholdBrightness(pixelFraction);
  }
}