/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v10;

import prophecy.common.image.BWImage;
import prophecy.common.image.ImageProcessing;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class EndFinder {
  private int clipSize = 16;

  public List<Rectangle> findEnds(BWImage originalImage) {
    BWImage image = new BWImage(originalImage.getWidth()+clipSize*2,
      originalImage.getHeight()+clipSize*2, 1);
    ImageProcessing.copy(originalImage, 0, 0, image, clipSize, clipSize,
      originalImage.getWidth(), originalImage.getHeight());
    //SurfaceUtil.show(new ImageSurface(image.toRGB()));
    List<Rectangle> ends = new ArrayList<Rectangle>();
    List<Rectangle> miniClips = ImageProcessing.getMiniclipRects(image.getWidth(), image.getHeight(),
      clipSize, clipSize, clipSize / 2, clipSize / 2);
    for (Rectangle miniClip : miniClips) {
      BWImage clip = image.clip(miniClip);
      boolean top = anyBlack(clip.clip(0, 0, clipSize, 1));
      boolean bottom = anyBlack(clip.clip(0, clipSize-1, clipSize, 1));
      boolean left = anyBlack(clip.clip(0, 0, 1, clipSize));
      boolean right = anyBlack(clip.clip(clipSize-1, 0, 1, clipSize));
      System.out.println(top + "/" + bottom + "/" + left + "/" + right);
      int sum = (top ? 1 : 0) + (bottom ? 1 : 0) + (left ? 1 : 0) + (right ? 1 : 0);
      if (sum == 1) {
        Rectangle r = new Rectangle(miniClip);
        r.translate(-clipSize, -clipSize);
        ends.add(r);
      }
    }
    return ends;
  }

  private boolean anyBlack(BWImage image) {
    for (int y = 0; y < image.getHeight(); y++)
      for (int x = 0; x < image.getWidth(); x++)
        if (image.getPixel(x, y) < 0.5)
          return true;
    return false;
  }
}