/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v10;

import static drjava.util.StringUtil.formatDouble;
import prophecy.common.image.BWImage;

public class Quad {
  private double[] c;
  private double threshold;

  public Quad(BWImage clip, double threshold) {
    this.threshold = threshold;
    int m = clip.getWidth()/2;
    c = new double[4];
    try {
      c[0] = clip.clip(0, 0, m, m).averageBrightness();
      c[1] = clip.clip(m, 0, m, m).averageBrightness();
      c[2] = clip.clip(m, m, m, m).averageBrightness();
      c[3] = clip.clip(0, m, m, m).averageBrightness();
    } catch (RuntimeException e) {
      System.out.println("error");
    }
  }

  public int getSum(double threshold) {
    int sum = 0;
    for (int i = 0; i < 4; i++)
      if (c[i] < threshold) ++sum;
    return sum;
  }

  public double get(int i) {
    return c[i];
  }

  public boolean isBlack(int i) {
    return c[i & 3] < threshold;
  }

  public String toString() {
    return formatDouble(c[0], 1) + " " +
      formatDouble(c[1], 1) + " " +
      formatDouble(c[2], 1) + " " +
      formatDouble(c[3], 1);
  }
}