/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v11;

import drjava.util.Function;
import prophecy.common.image.BWImage;
import prophecy.common.image.RGBImage;

public class BuggyI {
  public static void main(String[] args) {
    final BWImage image = RGBImage.load("data/v11/buggy_i.jpg").toBW();
    /*HardCornerFinder finder = new HardCornerFinder(8);
    List<Corner> corners = finder.findCorners(image);*/
    DataTable.showFunctionValues("clipSize", "corners",
      new Function<Double, Double>() {
        public Double get(Double clipSize) {
          HardCornerFinder finder = new HardCornerFinder(clipSize.intValue());
          return new Double(finder.findCorners(image).size());
        }
      }, new double[] {2, 4, 6, 8, 10, 12, 14, 16});
    /*SurfaceUtil.show(new ImageMetaSurface(image.toRGB(),
      new ImageMeta(corners)));*/
  }
}