/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v11;

import drjava.util.FromTree;
import drjava.util.ToTree;
import drjava.util.Tree;

import java.util.Map;
import java.util.TreeMap;

public class Comments implements FromTree, ToTree {
  private Map<String, String> comments = new TreeMap<String, String>();

  public void fromTree(Tree tree) {
    comments = tree.getObject("comments");
  }

  public Tree toTree() {
    return new Tree(getClass())
      .add("comments", comments);
  }

  public String get(String letter) {
    String result = comments.get(letter);
    return result == null ? "" : result;
  }

  public boolean put(String letter, String comment) {
    String previous = get(letter); 
    comments.put(letter, comment);
    return !comment.equals(previous);
  }
}