/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v11;

import drjava.util.Function;
import drjava.vats.FulfilledPromise;
import drjava.vats.Promise;
import prophecy.common.PromiseBasedTableModel;
import prophecy.common.SurfaceUtil;

import javax.swing.*;

public class DataTable {
  static class Entry {
    double x, y;

    Entry(double x, double y) {
      this.x = x;
      this.y = y;
    }
  }

  public static void showFunctionValues(String xName, String yName,
    Function<Double, Double> function, double[] values) {
    PromiseBasedTableModel<Entry> tableModel = new PromiseBasedTableModel<Entry>(new String[]{xName, yName}) {
      protected int compareRows(Entry entry, Entry b) {
        return 0;
      }

      protected Promise<String> getCell(Entry entry, int row, int col) {
        return new FulfilledPromise<String>(drjava.util.StringUtil.formatDouble(col == 0 ? entry.x : entry.y, 1));
      }
    };
    for (double x : values) {
      tableModel.addItem(new Entry(x, function.get(x)));
    }
    JTable table = new JTable(tableModel);
    SurfaceUtil.show(new JScrollPane(table));
  }
}