/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v12;

import prophecy.video.v05.Neighbors;

import java.util.ArrayList;
import java.util.List;

public class Cols {
  private double threshold = 11.0;
  private Neighbors neighbors;
  private List<Col> cols = new ArrayList<Col>();

  public void process(Neighbors neighbors) {
    this.neighbors = neighbors;
    for (int x = 0; x < neighbors.getCols(); x++)
      processCol(x);
  }

  private void processCol(int x) {
    ColElement[] elements = new ColElement[neighbors.getRows()];
    boolean[] flags = new boolean[neighbors.getRows()];
    for (int y = 0; y < neighbors.getRows(); y++) {
      elements[y] = new ColElement(neighbors, x, y);
      flags[y] = elements[y].getQuality() >= threshold;
    }
    for (int y = 0; y < flags.length; y++) {
      if (flags[y]) {
        int y1 = y;
        double qualitySum = 0;
        do {
          qualitySum += elements[y].getQuality();
          ++y;
        } while (y < flags.length && flags[y]);
        cols.add(new Col(x, y1, 1, y-y1, qualitySum/(y-y1)));
      }
    }
  }

  public List<Col> getCols() {
    return cols;
  }

  public Neighbors getNeighbors() {
    return neighbors;
  }

  public double getThreshold() {
    return threshold;
  }

  public void setThreshold(double threshold) {
    this.threshold = threshold;
  }
}