/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v12;

import drjava.util.StringUtil;
import prophecy.common.Prophecy;
import prophecy.common.Surface;
import prophecy.common.SurfaceUtil;
import prophecy.common.image.RGBImage;
import prophecy.video.v05.Neighbors;

import java.util.ArrayList;
import java.util.List;

public class NeighborsTest {
  public static void main(String[] args) {
    String imgPath = Prophecy.dataDir() + "v12/m15.jpg";
    Neighbors neighbors = new Neighbors(RGBImage.load(imgPath));
    //BeanInspector.inspect(neighbors);
    Neighbors.Clip[][] clips = neighbors.getClips();
    //printLines(clips, clips.length-2, clips.length);
    List<RowElement> list = new ArrayList<RowElement>();
    /*for (int x = 0; x < neighbors.getCols(); x++)
      list.add(new RowElement(neighbors, clips.length-2, x));
    BeanInspector.inspect(list);*/
    //BeanInspector.inspect(new Rows(neighbors));
    double threshold = 12;
    Rows rows = new Rows();
    rows.setThreshold(threshold);
    rows.process(neighbors);

    Cols cols = new Cols();
    cols.setThreshold(threshold);
    cols.process(neighbors);
    //RowsSurface surface = new RowsSurface(rows);

    List<Shape> shapes = new ArrayList<Shape>();
    //shapes.addAll(rows.getRows());
    shapes.addAll(cols.getCols());
    Surface surface = new ShapesSurface(neighbors, shapes);
    SurfaceUtil.showAsMain("V12 threshold=" + StringUtil.formatDouble(rows.getThreshold(), 1),
      surface);
  }

  private static void printLine(Neighbors.Clip[][] allClips, int row) {
    System.out.println();
    System.out.println("Row " + row);
    Neighbors.Clip[] clips = allClips[row];
    for (int i = 0; i < clips.length; i++) {
      Neighbors.Clip clip = clips[i];
      System.out.println("#" + i + ": " + clip);
    }
  }

  private static void printLines(Neighbors.Clip[][] allClips, int row1, int row2) {
    System.out.println();
    System.out.println("Rows " + row1 + "-" + (row2-1));
    for (int i = 0; i < allClips[row1].length; i++) {
      for (int row = row1; row < row2; row++) {
        Neighbors.Clip[] clips = allClips[row];
        Neighbors.Clip clip = clips[i];
        System.out.println("#" + i + ": " + clip);
      }
    }
  }
}