/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v12;

import drjava.util.StringUtil;
import prophecy.video.v05.Neighbors;

public class RowElement {
  private double quality;

  public RowElement(Neighbors neighbors, int col, int row) {
    Neighbors.Clip clip1 = neighbors.getClip(col, row);
    Neighbors.Clip clip2 = neighbors.getClip(col, row+1);
    if (clip1 == null || clip2 == null) return;
    /*quality += match(clip1, 0, 0, 0, 0, 1, 1, 1, 0);
    quality += match(clip2, 1, 1, 1, 0, 0, 0, 0, 0);*/
    quality += match(clip1, 9, 9, 9, 9, 1, 1, 1, 9);
    quality += match(clip2, 1, 1, 1, 9, 9, 9, 9, 9);
  }

  public double getQuality() {
    return quality;
  }

  private double match(Neighbors.Clip clip, double... pattern) {
    double quality = 0;
    for (int i = 0; i < pattern.length; i++)
      if (pattern[i] == 9)
        quality += 1;
      else
        quality += Math.max(0, 1.0-Math.abs(clip.getNeighborDiffs()[i]-pattern[i]));
    return quality;
  }

  public String toString() {
    return "RowElement " + StringUtil.formatDouble(quality, 1);
  }
}