/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v12;

import prophecy.common.image.ImageSurface;

import java.awt.*;

public class RowsSurface extends ImageSurface {
  private Rows rows;

  public RowsSurface(Rows rows) {
    super(rows.getNeighbors().getImage());
    this.rows = rows;
  }

  public void render(int w, int h, Graphics2D g) {
    super.render(w, h, g);
    int cs = rows.getNeighbors().getClipSize();
    for (Row row : rows.getRows()) {
      Rectangle r = row.getRect();
      g.setColor(Color.blue);
      g.drawRect(r.x*cs+1, r.y*cs+1, r.width*cs-2, r.height*cs-2);
    }
  }
}