/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.video.v12;

import drjava.util.ObjectUtil;
import drjava.util.StringUtil;

import java.awt.*;

public class Shape {
  protected Rectangle rect;
  protected double quality;

  public Shape(Rectangle rect, double quality) {
    this.rect = rect;
    this.quality = quality;
  }

  public Rectangle getRect() {
    return rect;
  }

  public double getQuality() {
    return quality;
  }

  public String toString() {
    return ObjectUtil.shortenClassName(getClass().getName()) + " "
      + rect + " q=" + StringUtil.formatDouble(quality, 1);
  }
}