package prophecy.video.v13;

import prophecy.common.image.ImageProcessing;
import prophecy.common.image.RGB;
import prophecy.common.image.RGBImage;

import java.awt.*;

public class ScreenshotEnhancement {
  public static void paintDominantColorBoxes(RGBImage image, int blockSize, int paintedBlockSize) {
    for (int y = 0; y+blockSize <= image.getHeight(); y += blockSize)
      for (int x = 0; x+blockSize <= image.getWidth(); x += blockSize) {
        RGBImage clip = image.clip(new Rectangle(x, y, blockSize, blockSize));
        RGB dominantColor = ImageAnalysis.getDominantColor(clip, 8);
        ImageProcessing.fillRect(image, x, y, paintedBlockSize, paintedBlockSize, new RGB(0));
        ImageProcessing.fillRect(image, x+1, y+1, paintedBlockSize-2, paintedBlockSize-2, dominantColor);
      }
  }
}
