package tinybrain.tb01;

import drjava.util.Tree;
import prophecy.common.socket.DialogServer;
import prophecy.common.socket.SocketCallable;
import prophecy.common.socket.SocketHandler;
import prophecy.t.t06.Cmd;
import prophecy.t.t06.TreeCLI;

import java.io.IOException;

public class GameServer implements SocketCallable {
  public static void main(String[] args) throws IOException {
    int port = 15667; // the BitTorrent port! (i did this for a port forwarding experiment)
    DialogServer dialogServer = new DialogServer(port, new GameServer());
    dialogServer.start();
  }

  public void takeCall(SocketHandler handler) {
    handler.println(new Tree("Welcome", new Tree("Tinybrain game server ready. Type 'help' if you need help.")));
    TreeCLI cli = new TreeCLI();
    cli.addStandardCmds();
    cli.addCmd(new CmdScript());
    cli.loop(handler);
  }

  private class CmdScript extends Cmd {
    public void run(Tree input, SocketHandler handler) {
      Script script = makeScript();
      handler.println(script.toTree());
    }
  }

  private Script makeScript() {
    Script script = new Script();
    for (int i = 0; i < 3; i++)
      script.add("hello", "world");
    return script;
  }
}
