package tinybrain.tb01;

import net.sbbi.upnp.impls.InternetGatewayDevice;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;

public class PortOpeningTest {
  public static void main(String[] args) {
    int port = 49999;
    int discoveryTimeout = 10000;
    try {
      //Discovery of the router
      System.out.println("Router discovery (timeout " + discoveryTimeout + " ms)");
      InternetGatewayDevice[] IGDs = InternetGatewayDevice.getDevices(discoveryTimeout);
      System.out.println(IGDs == null ? "No router found" : IGDs.length + " router(s) found");
      if (IGDs != null) {
        InternetGatewayDevice testIGD = IGDs[0];    //Internal Address
        String external = testIGD.getExternalIPAddress();
        System.out.println("External address: " + external);
        String local = InetAddress.getLocalHost().getHostAddress();
        testIGD.addPortMapping("UPnP Test", null, port, port, local, 0, "TCP");
        System.out.println("Port mapping added");
      }
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    try {
      System.out.println("listening on port " + port);
      ServerSocket server = new ServerSocket(port);
      Socket client = server.accept();
      System.out.println("Client found:" + client.getInetAddress());
    } catch (IOException ex) {
      ex.printStackTrace();
    }
  }
}

