/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.e.e05;

public class FuzzyBool {
  private final float value;

  public FuzzyBool(boolean b) {
    value = b ? 1 : 0;
  }

  public FuzzyBool(float value) {
    this.value = value;
  }

  public float getValue() {
    return value;
  }

  public boolean asBoolean() {
    return value >= 0.5f;
  }

  public static FuzzyBool proContra(int pro, int contra) {
    return new FuzzyBool(pro+contra == 0 ? 0.5f : pro/(float) (pro+contra));
  }

  public static FuzzyBool distances(double distanceA, double distanceB) {
    return new FuzzyBool(distanceA + distanceB == 0 ? 0.5f : (float) (distanceB/(distanceA+distanceB)));
  }
}