/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m10;

import drjava.util.FileUtil;
import prophecy.common.Prophecy;
import prophecy.common.lifeform.Box;
import prophecy.common.lifeform.ProphecyEnv;

import java.io.File;
import java.io.IOException;

public class FilesManagerTest {
  public static void main(String[] args) {
    AutonumFilesManager filesManager = new AutonumFilesManager("temp/FilesManagerTest");
    ProphecyEnv env = new ProphecyEnv(filesManager);
    env.addInhabitant(new Box() {
      protected void idleImpl() {
        super.idleImpl();
        set(Prophecy.getGlobalCommunityServices().getHomelessShelter());
      }
    });
    File file = filesManager.makeFile();
    try {
      FileUtil.saveTextFile(file, "Hello");
    } catch (IOException e) {
      env.addInhabitant(new Box(e));
    }
    filesManager.release(new Box("Next file: " + filesManager.makeFileName()));
    env.showMainFrame();
  }
}