/*
(C) 2007 Stefan Reich (jazz@drjava.de)
This source file is part of Project Prophecy.
For up-to-date information, see http://www.drjava.de/prophecy

This source file is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, version 2.1.
*/

package prophecy.m.m23;

import prophecy.m.m08.CompositeLifeform;
import prophecy.m.m10.AutonumFilesManager;

public class ObjectCollector extends CompositeLifeform {
  private AutonumFilesManager filesManager;

  public ObjectCollector(String dir) {
    addPart(filesManager = new AutonumFilesManager(dir));
  }

  public void idleImpl() {
    super.idleImpl();
    setStatus(filesManager.getStatus());
  }

  public boolean isReady() {
    return filesManager.isReady();
  }

  public void addObject(Object object) {
    release(new ConversionTask(object, FileSet.class) {
      protected void fireSolutionProposed() {
        super.fireSolutionProposed();
        addFileSet((FileSet) getProposedSolution());
        retire();
      }
    });
  }

  public void addFileSet(FileSet fileSet) {
    filesManager.addFileSet(fileSet);
  }
}